{$D+}

unit	WorkMain;

interface

uses	Objects, Drivers, Views, Dialogs, App, MsgBox,
		ZarInc,
		Otdel, Person, TabView, OtdView, PrintMas, SmartDra, CharLog, DataServ;

type

	PWorkOther = ^TWorkOther;
	PWorkMain = ^TWorkMain;
	PWork = ^TWork;
	PWorkAll = ^TWorkAll;
	POtherInfo = ^TOtherInfo;

	TMainState = (msNone, msError, msSave, msCalc, msPrint);

	TWorkMain = Object (TView)
		Otdel		: POtdel;
		Info		: PWorkOther;
		Rez			: PWorkOther;
		Tabel		: PWorkOther;

		SVadd		: PWorkOther;
		SVsub		: PWorkAll;
		BList		: PWorkAll;
		Fond		: PWorkAll;
		Chisl		: PWorkAll;

		Modif		: Boolean;

		constructor Init (AOtdel : POtdel);
		procedure	Save;
		procedure	NewPerson;
		procedure	DelPerson (N : Integer);
		procedure	Recalc;
		procedure	Modified (N : Integer);
		procedure	HandleEvent (Var Event : TEvent); virtual;
		function	Valid (Command : Word) : Boolean; virtual;
		procedure	ResetRange;
		procedure	SetRun (A : TMainState);
		procedure	Draw; virtual;
		destructor	Done; virtual;
	private
		InRun		: TMainState;
	end;

	TWork = Object (TDialog)
		Main		: PWorkMain;
		Info		: POtherInfo;
		List		: PItemList;
		procedure	HandleEvent (Var Event : TEvent); virtual;
		constructor	Load (Var S : TStream);
		procedure	Store (Var S : TStream);
		procedure	Recalc; virtual;
		procedure	Print; virtual;
		function	Format : PTitle; virtual;
		function	Valid (Command : Word) : Boolean; virtual;
		function	Ptr : Pointer; virtual;
		function	Data (I : Integer) : Pointer; virtual;
		destructor	Done; virtual;
	end;

	TWorkOther = Object (TWork)
		constructor	Init (Var R : TRect; ATitle : String; AMain : PWorkMain);
		procedure	HandleEvent (Var Event : TEvent); virtual;
		function	Valid (Command : Word) : Boolean; virtual;
	end;

	TWorkAll = Object (TWork)
		constructor	Init (Var R : TRect; ATitle : String; AMain : PWorkMain);
		function	InitList (Var R : TRect; ALink : PListViewer; AHeight : Integer; HS, VS : PScrollBar) : PItemList; virtual;
		function	ItemsCount : Integer; virtual;
		constructor Load (Var S : TStream);
	end;

	TOtherInfo = Object (TTabViewer)
		Link		: PListViewer;
		constructor Init (Var R : TRect; ALink : PListViewer; HS, VS : PScrollBar; Format : PTitle);
		function	Seek (X, Y : Integer) : Boolean; virtual;
		constructor	Load (Var S : TStream);
		procedure	Store (Var S : TStream);
		function	Data (I : Integer) : Pointer; virtual;
		procedure	Modified (I : Integer); virtual;
		destructor	Done; virtual;
	end;

const

	PMain		: PWorkMain = nil;

	PrintSetup	: TPrintSetup =
			(
				Quality : 1;
				Frames	: 1;
				Count	: 1;
				Left	: 6;
				Length	: 132;
				Page	: 56;
				Top		: 2;
				Bottom	: 2
			);

implementation

{*************************************************************** TWorkMain **}
procedure TWorkMain.ResetRange;
	procedure Check (P : PWorkOther);
		begin
			if P <> nil then
				with P^ do
					begin
						PPersonList (List)^.ResetRange;
						Info^.ResetRange (Otdel^.Count);
					end;
		end;
	begin
		SetRun (msCalc);
		Check (Info);
		Check (Rez);
		Check (Tabel);
		SetRun (msNone);
	end;

procedure TWorkMain.SetRun (A : TMainState);
	begin
		if A <> InRun then
			begin
				InRun := A;
				DrawView;
			end;
	end;

procedure TWorkMain.Modified (N : Integer);
	procedure Check (P : PWorkOther);
		begin
			if P <> nil then
				with P^.List^ do
					if (N >= TopItem) and (N < TopItem + Size.Y - Height) then
						begin
							DrawView;
							Link^.DrawView;
						end;
		end;
	begin
		if (N >= 0) and (N < Otdel^.Count) then
			begin
				SetRun (msCalc);
				PPerson (Otdel^.At (N))^.Recalc;
				Check (Info);
				Check (Rez);
				Check (Tabel);
				Otdel^.Modif := True;
				Modif := True;
				SetRun (msNone);
			end;
	end;

procedure TWorkMain.Save;
	begin
		SetRun (msSave);
		Otdel^.Save;
		if not Otdel^.Head.Test then
			MessageBox (#3'訡  䠩 ~%s~,'#13+
						#13+
						#3'ଠ  ࠭.', @Otdel^.FileName,
						mfError + mfCancelButton)
		else
			Otdel^.Modif := False;
		SetRun (msNone);
	end;

procedure TWorkMain.Recalc;
	begin
		SetRun (msCalc);
		Otdel^.All.Recalc (Otdel^);
		if BList <> nil then BList^.ReDraw;
		if SVadd <> nil then SVadd^.ReDraw;
		if SVsub <> nil then SVsub^.ReDraw;
		if Fond <> nil then Fond^.ReDraw;
		if Chisl <> nil then Chisl^.ReDraw;
		Modif := False;
		SetRun (msNone);
	end;

constructor TWorkMain.Init (AOtdel : POtdel);
	var
		R	: TRect;
	begin
		if PMain <> nil then
			begin
				Fail;
				Exit;
			end;
		PMain := @Self;
		Application^.GetExtent (R);
		R.B.Y := 1;
		TView.Init (R);
		GrowMode := gfGrowHiX;
		Otdel := AOtdel;
		EnableCommands ([cmSave,
			cmWorkInfo, cmWorkTabel, cmWorkRez,
			cmSVadd, cmSVsub, cmFond, cmBList, cmChisl]);
		Application^.Insert (@Self);
	end;

procedure TWorkMain.HandleEvent (Var Event : TEvent);
	begin
		TView.HandleEvent (Event);
		case Event.What of
			evCommand:
				case Event.Command of
					cmSave		: Save;
					cmRecalc	: Recalc;
				else
					Exit;
				end;
		else
			Exit;
		end;
		ClearEvent (Event);
	end;

function TWorkMain.Valid (Command : Word) : Boolean;
	begin
		Valid := True;
		case Command of
			cmValid	:
				if (Otdel = nil) or (Otdel^.Head.Status <> stOk) then
					begin
						MessageBox (#3'訡   .', nil, mfError + mfCancelButton);
						Valid := False;
					end;
			cmClose,
			cmQuit	:
				if ((Info = nil) or Info^.Valid (Command)) and
				((Rez = nil) or Rez^.Valid (Command)) and
				((Tabel = nil) or Tabel^.Valid (Command)) then
					begin
						if Otdel^.Modif then
							case MessageBox (
								#3' 﫨 ଠ,'#13+
								#13+
								#3'࠭ ', nil, mfError + mfYesNoCancel) of
								cmYes:
									begin
										Save;
										if Otdel^.Modif then
											begin
												Valid := False;
												Exit;
											end;
									end;
								cmCancel:
									begin
										Valid := False;
										Exit;
									end;
							end;
					end
				else
					Valid := False
		else
			Valid := TView.Valid (Command)
		end;
	end;

procedure TWorkMain.NewPerson;
	var
		S : String;
		D : PDialog;
		C : PView;
		R : TRect;
		P : PPerson;
	begin
		R.Assign (0, 0, 40, 10);
		D := New (PDialog, Init (R, ' 㤭'));
		with D^ do
			begin
				Options := Options or ofCentered;
				R.Assign (7, 7, 19, 9);
				C := New (PButton, Init (R, cOkStr, cmOk, bfDefault));
				Insert (C);
				R.Move (14, 0);
				C := New (PButton, Init (R, cCancelStr, cmCancel, bfNormal));
				Insert (C);
				R.Assign (2, 3, 38, 4);
				C := New (PInputLine, Init (R, 80));
				Insert (C);
				R.Move (0, -1);
				C := New (PLabel, Init (R, '& 㤭', C));
				Insert (C);
			end;
		if ValidView (D) <> nil then
			begin
				if DeskTop^.ExecView (D) <> cmCancel then
					D^.GetData (S)
				else
					S := '';
				UnSpace (S);
				AlfaStr (S);
				D^.Free;
				P := @S;
				if S <> '' then
					if Otdel^.XSearch (S) >= 0 then
						MessageBox (#3'㤭 ~%s~'#13+
									#3'㦥 ࠡ⠥  ⮬ ⤥.', @P, mfError + mfCancelButton)
					else
						begin
							New (P, Init);
							P^.Info.FIO := S;
							Otdel^.Insert (P);
							Otdel^.Modif := True;
							ResetRange;
						end;
			end;
	end;

procedure TWorkMain.DelPerson (N : Integer);
	var
		P : PString;
	begin
		P := @PPerson (Otdel^.At (N))^.Info.FIO;
		if (PtrRec (P).Seg > 0) and (MessageBox (#3' ⢨⥫쭮  㢮'#13+
												#3'~%s~  ?'#13,
												@P, mfConfirmation or mfYesNoCancel) = cmYes) then
			begin
				Otdel^.Modif := True;
				Otdel^.AtFree (N);
				ResetRange;
			end;
	end;

procedure TWorkMain.Draw;
	var
		B : TDrawBuffer;
		C : Word;
	const
		States : array [TMainState] of String [6] = (
			'',
			'訡',
			'',
			'',
			'' );
	begin
		C := $8087;
		MoveChar (B, ' ', C, Size.X);
		if Otdel^.Modif then WordRec (B [1]).Lo := Ord ('*');
		if Modif then WordRec (B [4]).Lo := Ord ('?');
		MoveCStr (B [7], '~:~ ' + Otdel^.FileName^, C);
		MoveStr (B [Size.X - 8], States [InRun], C);
		WriteLine (0, 0, Size.X, Size.Y, B);
	end;

destructor TWorkMain.Done;
	begin
		Info^.Free;
		Rez^.Free;
		Tabel^.Free;
		PMain := nil;
		PObject (Otdel)^.Free;
		TView.Done;
		DisableCommands ([cmSave,
			cmWorkInfo, cmWorkTabel, cmWorkRez,
			cmSVadd, cmSVsub, cmFond, cmBList, cmChisl]);
		Application^.ReDraw;
	end;

{************************************************************** TWorkOther **}
constructor TWorkOther.Init (Var R : TRect; ATitle : String; AMain : PWorkMain);
	var
		T : TRect;
		V,
		H : PScrollBar;
		P : PView;
		N : Integer;
	begin
		TDialog.Init (R, ATitle);
		Main := AMain;
		Number := DeskTop^.WinNum;
		Options := Options or ofCentered;
		Flags := wfMove or wfClose or wfGrow or wfZoom;
		N := Size.X div 3;

		GetExtent (T);
		Dec (T.B.Y, 4); T.A.Y := T.B.Y - 1; T.B.X := N - 1; Inc (T.A.X);
		New (H, Init (T, lfDefault));
		with H^ do GrowMode := gfGrowHiY or gfGrowLoY;
		GetExtent (T); Dec (T.B.Y, 5); T.B.X := N; Inc (T.A.X); Inc (T.A.Y);
		List := New (PPersonList, Init (T, '  ⢮', 0, Info, H, Nil));
		Insert (H);
		Insert (List);

		GetExtent (T); T.A.X := T.B.X - 1;	Dec (T.B.Y, 5); Inc (T.A.Y);
		New (V, Init (T, lfDefault));
		GetExtent (T); T.A.X := N; Dec (T.B.X); Dec (T.B.Y, 4); T.A.Y := T.B.Y - 1;
		New (H, Init (T, lfDefault));
		GetExtent (T); T.A.X := N; Dec (T.B.X); Dec (T.B.Y, 5); Inc (T.A.Y);
		New (Info, Init (T, List, H, V, Format));
		with H^ do GrowMode := gfGrowHiX or gfGrowHiY or gfGrowLoY;
		with V^ do GrowMode := gfGrowHiX or gfGrowHiY or gfGrowLoX;
		List^.Link := Info;
		List^.Height := Info^.Title^.Levels;
		Insert (H);
		Insert (V);
		with Info^ do Options := Options or ofEditable;
		Insert (Info);
		Info^.ResetRange (AMain^.Otdel^.Count);

		GetExtent (T); T.A.Y := T.B.Y - 3; T.B.X := 12; T.Move (1, 0); Dec (T.B.Y);
		P := New (PButton, Init (T, '&ਭ', cmNewPerson, bfNormal));
		P^.GrowMode := gfGrowLoY or gfGrowHiY;
		Insert (P);
		T.Move (13, 0);
		P := New (PButton, Init (T, '&', cmDelPerson, bfNormal));
		P^.GrowMode := gfGrowLoY or gfGrowHiY;
		Insert (P);
		GetExtent (T); T.A.Y := T.B.Y - 3; T.B.X := 12; T.Move (Size.X - 27, 0); Dec (T.B.Y);
		P := New (PButton, Init (T, '&', cmSave, bfNormal));
		P^.GrowMode := gfGrowAll;
		Insert (P);
		T.Move (13, 0);
		P := New (PButton, Init (T, '&', cmPrint, bfNormal));
		P^.GrowMode := gfGrowAll;
		Insert (P);
		List^.Select;
	end;

function TWorkOther.Valid (Command : Word) : Boolean;
	begin
		Valid := TWork.Valid (Command);
		if Command = cmValid then
			with PPersonList (List)^ do
				begin
					Base := Main^.Otdel;
					ResetRange;
				end;
	end;

procedure TWorkOther.HandleEvent (Var Event : TEvent);
	begin
		TWork.HandleEvent (Event);
		case Event.What of
			evKeyDown:
				case Event.KeyCode of
					kbAltIns:	SendCommand (cmNewPerson);
					kbAltDel:	SendCommand (cmDelPerson);
				else
					Exit;
				end;
			evCommand:
				case Event.Command of
					cmNewPerson	: Main^.NewPerson;
					cmDelPerson	: Main^.DelPerson (List^.Focused);
				else
					Exit;
				end;
		else
			Exit;
		end;
		ClearEvent (Event);
	end;

{******************************************************************* TWork **}
function TWork.Valid (Command : Word) : Boolean;
	var
		B : Boolean;
		P : Pointer;
	begin
		B := True;
		if Command = cmValid then
			if PtrRec (Main).Seg = 0 then
				B := False
			else
				begin
					P := Ptr;
					if (PtrRec (P^).Seg = 0) or PView (P^)^.Valid (cmClose) then
						begin
							PView (P^)^.Free;
							Pointer (P^) := @Self;
						end
					else
						B := False;
				end;
		Valid := B and TView.Valid (Command);
	end;

constructor TWork.Load (Var S : TStream);
	begin
		TDialog.Load (S);
		Main := PMain;
		GetSubViewPtr (S, List);
		GetSubViewPtr (S, Info);
		Info^.Title := Format;
	end;

procedure TWork.Store (Var S : TStream);
	begin
		TDialog.Store (S);
		PutSubViewPtr (S, List);
		PutSubViewPtr (S, Info);
	end;

procedure TWork.Print;
	var
		I, N, L : Integer;
		D	: PDialog;
		P	: PPrintMaster;
		R	: TRect;
		T	: TTabText;
		F	: Integer;
		B	: Boolean;
		C	: Integer;
		S	: PProgresBar;
		V	: PLabel;
	label
		Skip;
	begin
		L := List^.Size.X + Info^.Title^.Width;
		if L > 255 then L := 255;
		if PrintPromt (PrintSetup, ' 㬥⮢') then
			begin
				T.Init (L);
				T.Clear (0);
				Main^.SetRun (msPrint);
				R.Assign (0, 0, 30, 8);
				New (D, Init (R, 'e...'));
				with D^ do Options := Options or ofCentered;
				R.Assign (4, 3, 26, 4);
				New (P, Init (R, 0));
				R.Assign (5, 2, 14, 3);
				New (V, Init (R, 'ਭ', P));
				with P^ do Options := Options or ofFramed;
				R.Assign (2, 6, 28, 7);
				New (S, Init (R));
				D^.Insert (P);
				D^.Insert (V);
				D^.Insert (S);
				DeskTop^.Insert (D);
				with List^ do N := Range + Height;
				F := Trunc (132 / PrintSetup.Length * (L + PrintSetup.Left));
				for C := 1 to PrintSetup.Count do
				begin
				with P^ do
					begin
						if not (Clear
						and Top (PrintSetup.Top)
						and Bottom (PrintSetup.Bottom)
						and PageLen (PrintSetup.Page)
						and LeftMagrin (PrintSetup.Left)) then goto Skip;
						if PrintSetup.Quality = 2 then
							begin
								if not ToLQ then goto Skip;
							end
						else
							if not ToDraft then goto Skip;
						if PrintSetup.Frames and 2 <> 0 then
							begin
								if not To0 then goto Skip
							end
						else
							if not ToO then goto Skip;
					end;
				with P^ do
					if not (RightMagrin (PrintSetup.Left + PrintSetup.Length) and Centered) then goto Skip;
				SetPXMode (PrintSetup.Frames);
				if (PrintSetup.Frames and 1 <> 0) and (PrintSetup.Quality = 0) then SetDraftGraf;
				T.AddClip (Title^, 0, 255);
				if not P^.PrintStr (T.Text) or not (P^.PrintStr (#13#10)) then goto Skip;
				T.Swap;
				with P^ do
					if F <= 66 then
						B := ToDWid and To10
					else
						if F <= 79 then
							B := ToDWid and To12
						else
							if F <= 112 then
								B := ToDWid and To15 and To10
							else
								if F <= 132 then
									B := To10
								else
									if F <= 158 then
										B := To12
									else
										if F <= 226 then
											B := To15 and To10
										else
											B := To15 and To12;
				for I := 0 to N do
					begin
						S^.SetValue (Trunc (I / N * 100 / C));
						List^.PrintStr (T, I);
						Info^.PrintStr (T, I);
						T.Adjust;
						if not P^.PrintStr (T.Text) or not (P^.PrintStr (#13#10)) then goto Skip;
						T.Swap;
					end;
				end;
				Skip:
				D^.Free;
				Main^.SetRun (msNone);
				T.Done;
			end;
	end;

procedure TWork.Recalc;
	begin
		Main^.ReCalc;
	end;

procedure TWork.HandleEvent (Var Event : TEvent);
	begin
		TDialog.HandleEvent (Event);
		case Event.What of
			evCommand:
				case Event.Command of
					cmPrint		: Print;
					cmSave		: Main^.Save;
					cmRecalc	: Recalc;
				else
					Exit;
				end;
		else
			Exit;
		end;
		ClearEvent (Event);
	end;

function TWork.Format : PTitle;
	begin
		Abstract;
	end;

function TWork.Data (I : Integer) : Pointer;
	begin
		Data := Nil;
	end;

function TWork.Ptr : Pointer;
	begin
		Abstract;
	end;

destructor TWork.Done;
	var
		P : Pointer;
	begin
		P := Ptr;
		if Pointer (P^) = @Self then Pointer (P^) := nil;
		TDialog.Done;
	end;
{**************************************************************** TWorkAll **}
constructor TWorkAll.Init (Var R : TRect; ATitle : String; AMain : PWorkMain);
	var
		T : TRect;
		V,
		H : PScrollBar;
		P : PView;
		N : Integer;
	begin
		TDialog.Init (R, ATitle);
		Main := AMain;
		Number := DeskTop^.WinNum;
		Options := Options or ofCentered;
		Flags := wfMove or wfClose or wfGrow or wfZoom;
		N := Size.X div 3;
		GetExtent (T);

		Dec (T.B.X); Dec (T.B.Y, 4); T.A.Y := T.B.Y - 1; Inc (T.A.X);
		New (H, Init (T, lfDefault));
		GetExtent (T); T.A.X := N; Dec (T.B.X); Dec (T.B.Y, 5); Inc (T.A.Y);
		New (Info, Init (T, nil, H, nil, Format));
		with H^ do GrowMode := gfGrowHiX or gfGrowHiY or gfGrowLoY;
		Insert (H);

		GetExtent (T);
		T.A.X := T.B.X - 1;	Dec (T.B.Y, 5); Inc (T.A.Y);
		New (V, Init (T, lfDefault));
		with V^ do GrowMode := gfGrowHiX or gfGrowHiY or gfGrowLoX;
		GetExtent (T); Dec (T.B.Y, 5); T.B.X := N; Inc (T.A.Y); Inc (T.A.X);
		List := InitList (T, Info, Info^.Title^.Levels, nil, V);
		Info^.Link := List;
		Insert (V);
		Insert (List);
		Insert (Info);

		GetExtent (T); Dec (T.B.Y); T.A.Y := T.B.Y - 2; T.B.X := 12; T.Move (Size.X - 40, 0);
		P := New (PButton, Init (T, '&', cmReCalc, bfDefault));
		P^.GrowMode := gfGrowAll;
		Insert (P);

		T.Move (13, 0);
		P := New (PButton, Init (T, '&', cmSave, bfNormal));
		P^.GrowMode := gfGrowAll;
		Insert (P);

		T.Move (13, 0);
		P := New (PButton, Init (T, '&', cmPrint, bfNormal));
		P^.GrowMode := gfGrowAll;
		Insert (P);
		List^.Select;

		N := ItemsCount;
		List^.SetRange (N);
		Info^.ResetRange (N);
	end;

function TWorkAll.ItemsCount : Integer;
	var
		D	: TDate;
	begin
		D.__ := SystemDate;
		if D.Day = DaysInMonth (D.Mon, D.Year) - 1 then Inc (D.Mon);
		ItemsCount := D.Mon + D.Mon div 3;
    end;

constructor TWorkAll.Load (Var S : TStream);
	var
		N : Integer;
	begin
		TWork.Load (S);
		N := ItemsCount;
		List^.SetRange (N);
		Info^.ResetRange (N);
	end;

function TWorkAll.InitList (Var R : TRect; ALink : PListViewer; AHeight : Integer; HS, VS : PScrollBar) : PItemList;
	begin
		InitList := New (PMonthList, Init (R, ' 栬', AHeight, ALink, HS, VS));
	end;

{************************************************************** TOtherInfo **}
constructor TOtherInfo.Init (Var R : TRect; ALink : PListViewer; HS, VS : PScrollBar; Format : PTitle);
	begin
		TTabViewer.Init (R, HS, VS, Format);
		GrowMode := gfGrowHiY or gfGrowHiX;
		Link := ALink;
		with Title^ do Flags := Flags or cfPredSelect or cfNextSelect;
	end;

constructor TOtherInfo.Load (Var S : TStream);
	begin
		TListViewer.Load (S);
		GetPeerViewPtr (S, Link);
	end;

procedure TOtherInfo.Store (Var S : TStream);
	begin
		TListViewer.Store (S);
		PutPeerViewPtr (S, Link);
	end;

function TOtherInfo.Data (I : Integer) : Pointer;
	begin
		if PtrRec (Owner).Seg > 0 then
			Data := PWork (Owner)^.Data (I)
		else
			Data := nil;
	end;

function TOtherInfo.Seek (X, Y : Integer) : Boolean;
	var
		L	: PListViewer;
	begin
		Seek := TTabViewer.Seek (X, Y);
		if (PtrRec (Link).Seg > 0) and
		((Link^.Focused <> Focused) or (Link^.TopItem <> TopItem)) then
			begin
				L := Link;
				Link := nil;
				L^.FocusItem (Y);
				Link := L;
			end;
	end;

procedure TOtherInfo.Modified (I : Integer);
	begin
		if PtrRec (Owner).Seg > 0 then
			PWork (Owner)^.Main^.Modified (I);
	end;

destructor TOtherInfo.Done;
	begin
		Title^.Free;
		Title := nil;
		TTabViewer.Done;
	end;
end.