{Copyright by Leonid Youriev, 1993, os@imfiko.bishkek.su}
{$I VERSION}
{$O-}

unit AniMouse;

interface

uses	Objects, Resident;

{$I VERSION}

type

	TStageMouseAnimator = Object (TMouseAnimator)
		All			: Byte;
		Count		: Byte;
		function	Next : Pointer; virtual;
		function	Get (N : Integer) : Pointer; virtual;
	end;

	TTextMouseImage = record
		SymAND	: Byte;
		AttAND	: Byte;
		SymXOR	: Byte;
		AttXOR	: Byte;
	end;

	TGraphMouseImage = record
{		ShiftY		: Shortint;
		ShiftX		: Shortint;
}		DataAND		: array [0..15] of Word;
		DataXOR		: array [0..15] of Word;
	end;

{$IFDEF SupportMasterMouse}
	PGraphMouseAnimator = ^TGraphMouseAnimator;
	TGraphMouseAnimator = Object (TStageMouseAnimator)
		Stages		: PPtrArray;
		constructor	Init (ACount : Integer);
		function	Get (N : Integer) : Pointer; virtual;
		destructor	Done; virtual;
	end;
{$ENDIF}

	PTextMouseAnimator = ^TTextMouseAnimator;
	TTextMouseAnimator = Object (TStageMouseAnimator)
		Stages		: PWordArray;
		constructor	Init (ACount : Integer);
		function	Get (N : Integer) : Pointer; virtual;
		destructor	Done; virtual;
	end;

implementation
{$L MOUSE.OBJ}

procedure GetImage (Var Data; Index, Count : Integer); external;

{***************************************************** TStageMouseAnimator **}
function TStageMouseAnimator.Next : Pointer;
begin
	Next := Get (Count);
	Inc (Count);
	if Count >= All then Count := 0;
end;

function TStageMouseAnimator.Get (N : Integer) : Pointer;
begin
	Abstract;
end;

{****************************************************** TTextMouseAnimator **}
constructor TTextMouseAnimator.Init (ACount : Integer);
begin
	TObject.Init;
	All := Count;
	GetMem (Stages, SizeOf (TTextMouseImage) * ACount);
end;

function TTextMouseAnimator.Get (N : Integer) : Pointer;
begin
	Get := Pointer (Stages^ [N]);
end;

destructor TTextMouseAnimator.Done;
begin
	FreeMem (Stages, SizeOf (TTextMouseImage) * All);
end;

{$IFDEF SupportMasterMouse}
{****************************************************** TGraphMouseAnimator **}
constructor TGraphMouseAnimator.Init (ACount : Integer);
begin
	TObject.Init;
	All := Count;
	GetMem (Stages, SizeOf (TGraphMouseImage) * ACount);
end;

function TGraphMouseAnimator.Get (N : Integer) : Pointer;
begin
	Get := Stages^ [N];
end;

destructor TGraphMouseAnimator.Done;
begin
	FreeMem (Stages, SizeOf (TGraphMouseImage) * All);
end;

{$ENDIF}

end.