{Copyright by Leonid Youriev, 1993, os@imfiko.bishkek.su}
{$I VERSION}

unit ByDos;

interface

{$I VERSION}

type

	PathStr = String [80];
	DirStr	= String [80];
	NameStr	= String [14];
	ExtStr	= String [5];

	dosTimeDate = record
		Sec		: Byte;
		Min		: Byte;
		Hour	: Byte;
		Day		: Byte;
		Month	: Byte;
		Year	: Word;
	end;

const

	weRetry		= 1;	ceResurce	= 1;	seOther		= 1;
	weWait		= 2;	ceTempo		= 2;	seDeviceB	= 2;
	weEnter		= 3;	ceAssert	= 3;	seReserve	= 3;
	weSkip		= 4;	ceInDos		= 4;	seDeviceC	= 4;
	weAbort		= 5;	ceHardware	= 5;	seMemory	= 5;
	weIgnore	= 6;	ceInSys		= 6;
	weUser		= 7;	ceApp		= 7;
						ceNoFound	= 8;
						ceFormat	= 9;
						ceLock		= 10;
						ceDisk		= 11;
						ceAlready	= 12;
						ceUnknown	= 13;

	aeNone		= 0;
	aeUnFunc	= 1;	aeNoFile	= 2;	aeNoPath	= 3;
	aeManyFile	= 4;	aeAssert	= 5;	aeUnHandle	= 6;
	aeDeadMem	= 7;	aeNoMem		= 8;	aeUnMem		= 9;
	aeUnEnviron	= 10;	aeUnFormat	= 11;	aeUnCode	= 12;
	aeUnDate	= 13;	aeReserve	= 14;	aeNoDisk	= 15;
	aeDelCur	= 16;	aeReplace	= 17; 	aeNoMore	= 18;
	aeWProtect	= 19;	aeUnIDSUB	= 20;	aeNotReady	= 21;
	aeUnCommand	= 22;	aeCRCbad	= 23;	aeUnLength	= 24;
	aeSeek		= 25;	aeUnType	= 26;	aeSector	= 27;
	aeNoPape	= 28;	aeWrite		= 29;	aeRead		= 30;
	aeTotal		= 31;	aeShare		= 32;	aeLock		= 33;
	aeAlready	= 80;	aeINT24		= 83;

	foRead		= 0;	faNone		= $00;
	foWrite		= 1;	faArchive	= $20;
	foReadWrite	= 2;	faReadOnly	= $01;
	foCreate	= 4;	faDirectory	= $10;
						faHidden	= $02;
						faSystem	= $04;
						faVolume	= $08;


var
	IOerror		: Word;
	WantError	: Byte;
	ClassError	: Byte;
	WhenError	: Byte;

function dosOpen		(Path : PathStr; Mode : Byte; Var Handle : Word) : Boolean;
function dosClose		(Handle : Word) : Boolean;
function dosSeek		(Handle : Word; Position : Longint) : Boolean;
function dosCreate		(Path : PathStr; Attr : Word; Var Handle : Word) : Boolean;
function dosDelete		(Path : PathStr) : Boolean;
function dosSetAttr		(Path : PathStr; Attr : Word) : Boolean;
function dosGetAttr		(Path : PathStr; Var Attr : Word) : Boolean;
function dosRename		(Path, NewPath : PathStr) : Boolean;
function dosErase		(Path : PathStr) : Boolean;
function dosRead		(Handle, Count : Word; Dest : Pointer) : Word;
function dosWrite		(Handle, Count : Word; Source : Pointer) : Word;
function dosSize		(Handle : Word) : Longint;
function dosPosition	(Handle : Word) : Longint;
function dosFlush		(Handle : Word) : Boolean;
function dosGetDate		(Handle : Word) : Longint;
function dosSetDate		(Handle : Word; Date : Longint) : Boolean;
function dosPackTime	(ATime : dosTimeDate) : Longint;
function dosTmp			(Var Path : PathStr) : Boolean;
procedure dosUnPackTime	(ADos : Longint; Var ATime : dosTimeDate);

function dosErrorMSG : String;

implementation

function dosErrorMSG : String; assembler;
asm
	PUSH	BP
	MOV		BP, SP
	PUSH	CS
	POP		ES
	CLD
	XOR		AX, AX
	MOV		DX, IOerror
	MOV		DI, OFFSET @5
	CMP		DX, 80
	JE		@2
	MOV		DI, OFFSET @4
	MOV		CX, OFFSET @5
	SUB		CX, DI
	INC		DX
@1:	DEC		DX
	JE		@2
	REPNE	SCASB
	JE		@1
	MOV		DI, OFFSET @6
@2: MOV		SI, DI
	LES		DI, @Result
@3:	STOSB
	SEGCS	LODSB
	TEST	AL, AL
	JNE		@3
	MOV		AX, WORD PTR @Result
	XCHG	AX, DI
	SUB		AX, DI
	DEC		AX
	STOSB
	JMP		@7
@4:	DB	'  䠩', 0
	DB	'⭠ 㭪', 0
	DB	'  ', 0
	DB	'  ', 0
	DB	'  䠩', 0
	DB	' ⮫쪮  ⥭', 0
	DB	' Handle 䠩', 0
	DB	'襭  DOS', 0
	DB	' ᢮ ', 0
	DB	'   ', 0
	DB	'ୠ । DOS', 0
	DB	'ࠢ ଠ', 0
	DB	'ࠢ  㯠', 0
	DB	'ୠ ', 0
	DB	'?', 0
	DB	'୮ ன⢮', 0
	DB	'⪠ 㤠 ⥪ ४', 0
	DB	'ୠ ᬥ ᪠', 0
	DB	'  室 䠩', 0
	DB	'⪠   ', 0
	DB	' 䨪 ன⢠', 0
	DB	'᪮  ⮢', 0
	DB	'⭠ ', 0
	DB	'訡 ஫  (CRC)', 0
	DB	'ୠ  ', 0
	DB	' ⨯ ⥫', 0
	DB	'  ', 0
	DB	' 㬠  ਭ', 0
	DB	'訡 ', 0
	DB	'訡 ⥭', 0
	DB	'訩 ᡮ', 0
	DB	'襭 ࠧ 䠩', 0
	DB	'襭 ஢ 䠩', 0
@5:	DB	' 㦥 ', 0
@6:	DB	'?', 0
@7:	POP		BP
end;

function Error : Integer; near; forward;

function dosGetDate (Handle : Word) : Longint; assembler;
asm
	MOV		AX, 5700H
	MOV		BX, Handle
	INT		21H
	MOV		AX, CX
end;

function dosSetDate (Handle : Word; Date : Longint) : Boolean; assembler;
asm
	MOV		AX, 5701H
	MOV		BX, Handle
	MOV		CX, WORD PTR Date
	MOV		DX, WORD PTR Date + 2
	INT		21H
	CALL	Error
end;

procedure dosUnPackTime (ADos : Longint; Var ATime : dosTimeDate); assembler;
asm
	LES		DI, ATime
	CLD
	MOV		DX, WORD PTR ADos
	MOV		AL, DL
	AND		AL, 1FH
	SAL		AL, 1
	MOV		CL, 5
	SAR		DX, CL
	MOV		AH, DL
	AND		AH, 3FH
	STOSW
	SAL		DX, 1
	SAL		DX, 1
	MOV		AL, DH
	MOV		DX, WORD PTR ADos + 2
	MOV		AH, DL
	AND		AH, 1FH
	STOSW
	MOV		AX, DX
	SAR		AX, CL
	STOSB
	SAR		DH, 1
	MOV		AL, DH
	MOV		AH, 0
	ADD		AX, 1980
	STOSW
end;

function dosPackTime (ATime : dosTimeDate) : Longint; assembler;
asm
	MOV		CL, 5
	MOV		AL, ATime + dosTimeDate.Min
	MOV		AH, 0
	SAL		AX, CL
	MOV		DL, ATime + dosTimeDate.Month
	MOV		DH, 0
	SAL		DX, CL
	MOV		BL, ATime + dosTimeDate.Sec
	SAR		BL, 1
	AND		BL, 1FH
	OR		AL, BL
	MOV		BL, ATime + dosTimeDate.Hour
	MOV		CL, 3
	SAL		BL, CL
	OR		AH, BL
	MOV		BL, ATime + dosTimeDate.Day
	AND		BL, 1FH
	OR		DL, BL
	MOV		BX, ATime + dosTimeDate.Year
	SUB		BX, 1980
	SAL		BX, 1
	OR		DH, BL
end;

function dosFlush (Handle : Word) : Boolean; assembler;
asm
	MOV		BX, Handle
	MOV		AH, 68H
	INT		21H
	CALL	Error
end;

function dosSize (Handle : Word) : Longint; assembler;
asm
	MOV		AX, 4202H
	MOV		BX, Handle
	XOR		CX, CX
	XOR		DX, DX
	INT		21H
	JNC		@E
	CALL	Error
	MOV		AX, -1
	MOV		DX, AX
@E:
end;

function dosPosition (Handle : Word) : Longint; assembler;
asm
	MOV		AX, 4201H
	MOV		BX, Handle
	XOR		CX, CX
	XOR		DX, DX
	INT		21H
	JNC		@E
	CALL	Error
	MOV		AX, -1
	MOV		DX, AX
@E:
end;

function dosRead (Handle, Count : Word; Dest : Pointer) : Word; assembler;
asm
	PUSH	DS
	MOV		AH, 3FH
	MOV		BX, Handle
	MOV		CX, Count
	LDS		DX, Dest
	INT		21H
	POP		DS
	JNC		@E
	CALL	Error
	XOR		AX, AX
@E:
end;

function dosWrite (Handle, Count : Word; Source : Pointer) : Word; assembler;
asm
	PUSH	DS
	MOV		AH, 40H
	MOV		BX, Handle
	MOV		CX, Count
	LDS		DX, Source
	INT		21H
	POP		DS
	JNC		@E
	CALL	Error
	XOR		AX, AX
@E:
end;

function dosSetAttr (Path : PathStr; Attr : Word) : Boolean; assembler;
asm
	PUSH	DS
	CLD
	LDS		SI, Path
	LODSB
	MOV		AH, 0
	MOV		BX, AX
	MOV		DS:[SI + BX], AH
	MOV		DX, SI
	MOV		AX, 4301H
	MOV		CX, Attr
	INT		21H
	POP		DS
	CALL	Error
end;

function dosErase (Path : PathStr) : Boolean; assembler;
asm
	PUSH	DS
	CLD
	LDS		SI, Path
	LODSB
	MOV		AH, 0
	MOV		BX, AX
	MOV		DS:[SI + BX], AH
	MOV		DX, SI
	MOV		AX, 4301H
	XOR		CX, CX
	INT		21H
	JC		@E
	MOV		AH, 41H
	INT		21H
@E:	POP		DS
	CALL	Error
end;

function dosGetAttr (Path : PathStr; Var Attr : Word) : Boolean; assembler;
asm
	PUSH	DS
	CLD
	LDS		SI, Path
	LODSB
	MOV		AH, 0
	MOV		BX, AX
	MOV		DS:[SI + BX], AH
	MOV		DX, SI
	MOV		AX, 4300H
	INT		21H
	LDS		SI, Attr
	MOV		DS:[SI], CX
	POP		DS
	CALL	Error
end;

function dosDelete (Path : PathStr) : Boolean; assembler;
asm
	PUSH	DS
	CLD
	LDS		SI, Path
	LODSB
	MOV		AH, 0
	MOV		BX, AX
	MOV		DS:[SI + BX], AH
	MOV		DX, SI
	MOV		AH, 41H
	INT		21H
	POP		DS
	CALL	Error
end;

function dosRename (Path, NewPath : PathStr) : Boolean; assembler;
asm
	PUSH	DS
	CLD
	LDS		DX, Path
	LODSB
	MOV		AH, 0
	MOV		BX, AX
	MOV		DS:[SI+BX], AH
	PUSH	BX
	LES		DI, NewPath
	MOV		AL, ES:[DI]
	INC		DI
	MOV		BX, AX
	MOV		ES:[DI+BX], AH
	PUSH	BX
	MOV		AH, 56H
	INT		21H
	POP		BX
	POP		BX
	POP		DS
	CALL	Error
end;

function dosCreate (Path : PathStr; Attr : Word; Var Handle : Word) : Boolean; assembler;
asm
	PUSH	DS
	CLD
	LDS		SI, Path
	LODSB
	MOV		AH, 0
	MOV		BX, AX
	MOV		DS:[SI+BX], AH
	MOV		DX, SI
	MOV		AH, 5BH
	MOV		CX, Attr
	INT		21H
	LDS		SI, Handle
	MOV		DS:[SI], AX
	POP		DS
	CALL	Error
end;

function dosSeek (Handle : Word; Position : Longint) : Boolean; assembler;
asm
	MOV		AX, 4200H
	MOV		BX, Handle
	MOV		CX, WORD PTR Position + 2
	MOV		DX, WORD PTR Position
	INT		21H
	CALL	Error
end;

function dosOpen (Path : PathStr; Mode : Byte; Var Handle : Word) : Boolean; assembler;
asm
	PUSH	DS
	CLD
	LDS		SI, Path
	LODSB
	MOV		AH, 0
	MOV		BX, AX
	MOV		DS:[SI+BX], AH
	MOV		DX, SI
	MOV		AH, 3DH
	MOV		AL, Mode
	CMP		AL, 2
	JBE		@1
	DEC		AH
	XOR		CX, CX
@1:	INT		21H
	LDS		SI, Handle
	MOV		DS:[SI], AX
	POP		DS
	CALL	Error
end;

function dosClose (Handle : Word) : Boolean; assembler;
asm
	MOV		AH, 3EH
	MOV		BX, Handle
	INT		21H
	CALL	Error
end;

function Error : Integer; assembler;
asm
	JC		@R
@N:	XOR		AX, AX
	MOV		WORD PTR WantError, AX
	MOV		WhenError, AL
	MOV		IOerror, AX
	INC		AX
	RETN
@R:	PUSH	DS
	PUSH	BP
	MOV		AH, 59H
	XOR		BX, BX
	INT		21H
	POP		BP
	POP		DS
	TEST	AX, AX
	JE		@N
	MOV		IOerror, AX
	MOV		WORD PTR WantError, BX
	MOV		WhenError, CH
	XOR		AX, AX
	STC
	RETN
end;

function DosTmp (Var Path : PathStr) : Boolean; assembler;
asm
	PUSH	DS
	CLD
	LDS		SI, Path
	LODSB
	MOV		DX, SI
	MOV		AH, 0
	ADD		SI, AX
	MOV		[SI], AH
	XOR		CX, CX
	MOV		AH, 5AH
	INT		21H
	JNC		@2
	XOR		AX, AX
	JMP		@3
@2: MOV		BX, AX
	MOV		AH, 3EH
	INT		21H
	LDS		SI, Path
	MOV		BX, SI
	INC		SI
@1:	LODSB
	TEST	AL, AL
	JNE		@1
	SUB		SI, BX
	MOV		AX, SI
	SUB		AL, 2
	MOV		DS:[BX], AL
	MOV		AL, 1
@3:	POP		DS
end;

end.
