{Copyright by Leonid Youriev, 1993, os@imfiko.bishkek.su}
{$I VERSION}

unit CharLog;

interface

{$I VERSION}
{$S-}		{ ! 맮 UpCase  AlfaUpStr  $S+ 뢠 "Runtime error 202", - ⮣  DS ॣ㦥}

type

	SChar = Set of Char;
	CharGraph = ''..'';
	SCharGraph = Set of CharGraph;
	PSCharGraph = ^SCharGraph;

function OrdCharGraph (L, R, U, D : Char; P : PSCharGraph) : Char;

function UpCase (C : Char) : Char;
function LowCase (C : Char) : Char;
function AlfaCase (C : Char) : Char;
function AlfaUpCase (C : Char) : Char;
function IsDelimiter (C : Char) : Boolean;
function PosCharInStr (C : Char; S : String) : Integer;

procedure UpStr (S: String);
procedure LowStr (S: String);
procedure AlfaUpStr (S : String);
procedure AlfaStr (S : String);
function Contains (S1, S2 : String) : Boolean;
function FirstNEqu (var S1, S2 : String) : Integer;
procedure Replace_0 (S : String);
procedure ReplaceChar (S : String; AOld, ANew : Char);
procedure UnSpace (var S : String);
procedure RemoveChar (var S : String; C : Char);
procedure RemoveSpace (var S : String);
procedure RemoveLowSpace (var S : String);
procedure CutSpace (var S : String);
procedure ToIndex (var S : String);
function CharPos (S : String; C : Char) : Integer;
function CountChar (S : String; C : Char) : Integer;

function IsTone (C : Char) : Boolean;
function IsLatTone (C : Char) : Boolean;
function IsCirTone (C : Char) : Boolean;
function IsCTone (C : Char) : Boolean;
function IsLatCTone (C : Char) : Boolean;
function IsCirCTone (C : Char) : Boolean;
function IsCirText (S : String) : Boolean;
function WrPtr (P : Pointer) : String;
function UnCStr (var S : String) : String;

function Space (ALen : Integer) : String;
function RepeatChar (Count : Integer; C : Char) : String;
{$IFNDEF Turbo6}
procedure PartFromStr (var Dest; const S : String; Clip, Number : Integer);
{$ELSE}
procedure PartFromStr (var Dest; S : String; Clip, Number : Integer);
{$ENDIF}

function CutOnTerm (Source : String; var At : Integer) : String;
function CutOnName (Source : String; var At : Integer) : String;

function StrCompare (Key1, Key2 : String) : Integer;

implementation

const

	LS : SCharGraph = ['','','','','','','','','','','','',''];
	LD : SCharGraph = ['','','','','','','','','','','','',''];
	RS : SCharGraph = ['','','','','','','','','','','','',''];
	RD : SCharGraph = ['','','','','','','','','','','','',''];
	US : SCharGraph = ['','','','','','','','','','','','',''];
	UD : SCharGraph = ['','','','','','','','','','','','',''];
	DS : SCharGraph = ['','','','','','','','','','','','',''];
	DD : SCharGraph = ['','','','','','','','','','','','',''];

	LatTone : SChar = ['E','Y','U','I','O','A','e','y','u','i','o','a'];

	CirTone : SChar = ['','','','','','','','','','','','','','','','','',''];

	CirLatTone : SChar = ['E','Y','U','I','O','A','e','y','u','i','o','a',
						  '','','','','','','','','','','','','','','','','',''];

	LatCTone : SChar = ['Q','W','R','T','Y','U','P','S','D','F','G','H','J','K','L','Z','X','C','V','B','N','M',
						'q','w','r','t','p','s','d','f','g','h','j','k','l','z','x','c','v','b','n','m'];

	CirCTone : SChar = ['','','','','','','','','','','','','','','','','','','','','','','',
						'','','','','','','','','','','','','','','','','','','','','','',''];

	CirLatCTone : SChar = ['Q','W','R','T','Y','U','P','S','D','F','G','H','J','K','L','Z','X','C','V','B','N','M',
						   'q','w','r','t','p','s','d','f','g','h','j','k','l','z','x','c','v','b','n','m',
						   '','','','','','','','','','','','','','','','','','','','','','','',
						   '','','','','','','','','','','','','','','','','','','','','','',''];

function OrdCharGraph (L, R, U, D : Char; P : PSCharGraph) : Char;
var
	X	: SCharGraph;
	I	: Char;

	procedure LogIn (C : Char; var S, NS : SCharGraph); near;
		begin
			if C = #0 then Exit;
			if C in S then
				X := X * NS
			else
				X := X - NS;
		end;
begin
	X := [''..''];
	LogIn (L, LS, RS);
	LogIn (R, RS, LS);
	LogIn (U, US, DS);
	LogIn (D, DS, US);
	LogIn (L, LD, RD);
	LogIn (R, RD, LD);
	LogIn (U, UD, DD);
	LogIn (D, DD, UD);
	if P <> nil then P^ := X;
	OrdCharGraph := ' ';
	for I := '' to '' do
		if I in X then
			begin
				OrdCharGraph := I;
				Exit;
			end;
end;

function AlfaCase (C : Char) : Char; assembler;
asm
	MOV		AX, CS
	MOV		ES, AX
	MOV		AL, C
	MOV		DI, OFFSET @F
	CLD
	MOV		CX, 17
	REPNE	SCASB
	JNE		@1
	MOV		AL, CS:[DI+16]
	JMP		@1
@F:	DB		''
@T:	DB		'KEHXBAPOCMTexapoc'
@1:
end;

function UpCase (C : Char) : Char; assembler;
asm
	MOV		AL, C
	CMP		AL, 97
	JB		@E
	CMP		AL, 122
	JBE		@1
	CMP		AL, 160
	JB		@E
	CMP		AL, 175
	JBE		@1
	CMP		AL, 224
	JB		@E
	CMP		AL, 240
	JAE		@E
	SUB		AL, 48
@1: SUB		AL, 32
@E:
end;

function LowCase (C : Char) : Char; assembler;
asm
	MOV		AL, C
	CMP		AL, 65
	JB		@E
	CMP		AL, 91
	JB		@1
	CMP		AL, 128
	JB		@E
	CMP		AL, 144
	JB		@1
	CMP		AL, 160
	JAE		@E
	ADD		AL, 48
@1:	ADD		AL, 32
@E:
end;

function IsDelimiter (C : Char) : Boolean;
const
	CDelimiter : SChar = [
		' ','*','(',')','-','=','+','[','{',']','}',
		';',':','''','"',',','<','.','>','/','?','\',
		'|','~','`','!','@','#','$','%','^','&',
		#0,#8,#9,#10,#13];
begin
	IsDelimiter := C in CDelimiter;
end;

procedure AlfaUpStr (S : String); assembler;
asm
	PUSH	DS
	LDS		SI, S
	CLD
	LODSB
	MOV		DH, 0
	MOV		DL, AL
	OR		DX, DX
	JE		@E
@1:	PUSH	WORD PTR DS:[SI]
	CALL	UpCase
	PUSH	AX
	CALL	AlfaCase
	MOV		[SI], AL
	INC		SI
	DEC		DX
	JNE		@1
@E:	POP		DS
end;

procedure AlfaStr (S : String); assembler;
asm
	MOV		DX, DS
	LDS		SI, S
	CLD
	LODSB
	MOV		CH, 0
	MOV		CL, AL
	JCXZ	@E
@1:	PUSH	CX
	PUSH	WORD PTR DS:[SI]
	CALL	AlfaCase
	MOV		[SI], AL
	INC		SI
	POP		CX
	LOOP	@1
@E:	MOV		DS, DX
end;

procedure Replace_0 (S : String); assembler;
asm
	LES		DI, S
	MOV		AX, 'O0'
	MOV		CH, 0
	MOV		CL, ES:[DI]
	MOV		BX, -1
	INC		DI
	CLD
@1:	JCXZ	@2
	REPNE	SCASB
	JNE		@2
	MOV		ES:[DI][BX], AH
	JMP		@1
@2:
	end;

procedure ReplaceChar (S : String; AOld, ANew : Char); assembler;
asm
	LES		DI, S
	MOV		AH, ANew
	MOV		AL, AOld
	MOV		CH, 0
	MOV		CL, ES:[DI]
	MOV		BX, -1
	INC		DI
	CLD
@1:	JCXZ	@2
	REPNE	SCASB
	JNE		@2
	MOV		ES:[DI][BX], AH
	JMP		@1
@2:
end;

function StrCompare (Key1, Key2 : String) : Integer; assembler;
asm
	PUSH	DS
	CLD
	LDS		SI, Key1
	LES		DI, Key2
	LODSB
	MOV		AH, ES:[DI]
	INC		DI
	MOV		CL, AL
	CMP		CL, AH
	JBE		@1
	MOV		CL, AH
@1:	XOR		CH, CH
	REPE	CMPSB
	JE		@2
	MOV		AL, DS:[SI-1]
	MOV		AH, 0
	MOV		CL, ES:[DI-1]
	MOV		CH, AH
	SUB		AX, CX
	JMP		@3
@2:	SUB		AL, AH
	CBW
@3:	POP		DS
end;

function QStrCompare (Key1, Key2 : String) : Integer; assembler;
asm
	PUSH	DS
	CLD
	LDS		SI, Key1
	LES		DI, Key2
	LODSB
	MOV		AH, ES:[DI]
	INC		DI
	MOV		CL, AL
	CMP		CL, AH
	JBE		@1
	MOV		CL, AH
@1:	XOR		CH, CH
	REPE	CMPSB
	JE		@2
	MOV		DL, DS:[SI-1]
	CMP		DL, '?'
	JE      @1
	MOV		DH, ES:[DI-1]
	CMP		DH, '?'
	JE		@1
	MOV		AH, 0
	MOV		AL, DL
	MOV		DH, 0
	SUB		AX, DX
	JMP		@3
@2:	SUB		AL, AH
	CBW
@3:	POP		DS
end;

procedure UnSpace (var S : String); assembler;
asm
	MOV		DX, DS
	LDS		SI, S
	MOV		AX, DS
	MOV		ES, AX
	XOR		AX, AX
	CLD
	LODSB
	MOV		CX, AX
	MOV		DI, SI
	JCXZ	@E
@1:	LODSB
	CMP		AL, ' '
	JBE		@4
	MOV		AH, 0
@2:	STOSB
@3:	LOOP	@1
	JMP		@E
@4:	TEST	AH, -1
	JNE		@3
	MOV		AX, 0120H
	JMP		@2
@E:	MOV		AX, DI
	MOV		DI, WORD PTR S
	SUB		AX, DI
	DEC		AX
	STOSB
	MOV		DS, DX
end;

procedure UpStr (S : String); assembler;
asm
	LES		DI, S
	MOV		CL, ES:[DI]
	MOV		CH, 0
	JCXZ	@2
	CLD
	INC		DI
@1:	PUSH	WORD PTR ES:[DI]
	CALL	UpCase
	STOSB
	LOOP	@1
@2:
end;

procedure LowStr (S : String); assembler;
asm
	LES		DI, S
	MOV		CL, ES:[DI]
	MOV		CH, 0
	JCXZ	@2
	CLD
	INC		DI
@1:	PUSH	WORD PTR ES:[DI]
	CALL	LowCase
	STOSB
	LOOP	@1
@2:
end;

function Contains (S1, S2 : String): Boolean; assembler;
asm
	PUSH    DS
	CLD
	LDS     SI, S1
	LES     DI, S2
	MOV     DX, DI
	XOR     AH, AH
	LODSB
	MOV     BX, AX
	OR      BX, BX
	JZ      @2
	MOV     AL, ES:[DI]
	XCHG    AX, CX
@1: PUSH    CX
	MOV     DI, DX
	LODSB
	REPNE   SCASB
	POP     CX
	JE      @3
	DEC     BX
	JNZ     @1
@2:	XOR     AL, AL
	JMP     @4
@3:	MOV     AL, 1
@4: POP     DS
end;

function IsTone (C : Char) : Boolean;
begin
	IsTone := C in CirLatTone;
end;

function IsLatTone (C : Char) : Boolean;
begin
	IsLatTone := C in LatTone;
end;

function IsCirTone (C : Char) : Boolean;
begin
	IsCirTone := C in CirTone;
end;

function IsCTone (C : Char) : Boolean;
begin
	IsCTone := C in CirLatCTone;
end;

function IsLatCTone (C : Char) : Boolean;
begin
	IsLatCTone := C in LatCTone;
end;

function IsCirCTone (C : Char) : Boolean;
begin
	IsCirCTone := C in CirCTone;
end;

function UnCStr (var S : String) : String;
var
	I : Integer;
begin
	for I := 1 to Ord(S[0]) do
		if (S[I] = '~') or (S[I] = '&') then Delete (S, I, 1);
	UnCStr := S;
end;

function AlfaUpCase (C : Char) : Char; assembler;
asm
	MOV		AL, C
	PUSH	AX
	CALL	UpCase
	PUSH	AX
	CALL	AlfaCase
end;

function IsCirText (S : String) : Boolean; assembler;
asm
	PUSH	DS
	LDS		SI, S
	CLD
	LODSB
	MOV		AH, 0
	MOV		CX, AX
@1:	JCXZ	@3
	LODSB
	DEC		CX
	CMP		AL, ' '
	JE		@1
	CMP		AL, '0'
	JB		@2
	CMP		AL, '9'
	JBE		@1
	CMP		AL, 128
	JB		@2
	CMP 	AL, 176
	JB		@1
	CMP		AL, 224
	JB		@2
	CMP		AL, 239
	JBE		@1
@2:	MOV		AL, 0
	JMP		@4
@3:	MOV		AL, 1
@4:	POP		DS
end;

function CutOnTerm (Source : String; var At : Integer) : String; assembler;
asm
	MOV		DX, DS
	LDS		SI, At
	MOV		BX, [SI]
	LDS		SI, Source
	LES		DI, @Result
	INC		DI
	CLD
	LODSB
	MOV		CL, AL
	MOV		CH, 0
	SUB		CX, BX
	JBE		@E
@1: INC		BX
	LODSB
	STOSB
	CMP		AL, '-'
	JB		@E
	LOOP	@1
@E:	MOV		AX, DI
	MOV		DI, WORD PTR @Result
	SUB		AX, DI
	DEC		AX
	STOSB
	LDS		SI, At
	MOV		[SI], BX
	MOV		DS, DX
end;

function CutOnName (Source : String; var At : Integer) : String; assembler;
asm
	MOV		DX, DS
	LDS		SI, At
	MOV		BX, [SI]
	LDS		SI, Source
	LES		DI, @Result
	INC		DI
	CLD
	LODSB
	MOV		CL, AL
	MOV		CH, 0
	SUB		CX, BX
	JBE		@E
@1: INC		BX
	LODSB
	CMP		AL, 'A'
	JB		@E
	CMP		AL, 'Z'
	JBE		@2
	CMP		AL, 'a'
	JB		@E
	CMP		AL, 'z'
	JBE		@2
	CMP		AL, 128
	JB		@E
	CMP		AL, ''
	JBE		@2
	CMP		AL, ''
	JB		@E
	CMP		AL, ''
	JA		@E
@2:	STOSB
	INC		BX
	LOOP	@1
@E:	MOV		AX, DI
	MOV		DI, WORD PTR @Result
	SUB		AX, DI
	DEC		AX
	STOSB
	LDS		SI, At
	MOV		[SI], BX
	MOV		DS, DX
end;

function Space (ALen : Integer) : String; assembler;
asm
	CLD
	LES		DI, @Result
	MOV		CX, ALen
	JCXZ	@1
	CMP		CX, 256
	JAE		@1
	MOV		AL, CL
	STOSB
	MOV		AL,  ' '
	REP		STOSB
@1:	MOV		BYTE PTR ES:[DI], 0
end;

procedure RemoveSpace (var S : String); assembler;
asm
	MOV		DX, DS
	LES		DI, S
	LDS		SI, S
	CLD
	LODSB
	INC		DI
	MOV		CL, AL
	MOV		CH, 0
	JCXZ	@3
@1:	LODSB
	CMP		AL, ' '
	JE		@2
	STOSB
@2:	LOOP	@1
@3:	MOV		AX, DI
	MOV		DI, WORD PTR S
	SUB		AX, DI
	DEC		AX
	STOSB
	MOV		DS, DX
end;

procedure RemoveChar (var S : String; C : Char); assembler;
asm
	MOV		DX, DS
	LES		DI, S
	LDS		SI, S
	CLD
	LODSB
	INC		DI
	MOV		CL, AL
	MOV		CH, 0
	JCXZ	@3
@1:	LODSB
	CMP		AL, C
	JE		@2
	STOSB
@2:	LOOP	@1
@3:	MOV		AX, DI
	MOV		DI, WORD PTR S
	SUB		AX, DI
	DEC		AX
	STOSB
	MOV		DS, DX
end;

procedure RemoveLowSpace (var S : String); assembler;
asm
	MOV		DX, DS
	LES		DI, S
	LDS		SI, S
	CLD
	LODSB
	INC		DI
	MOV		CL, AL
	MOV		CH, 0
	JCXZ	@3
@1:	LODSB
	CMP		AL, ' '
	JBE		@2
	STOSB
@2:	LOOP	@1
@3:	MOV		AX, DI
	MOV		DI, WORD PTR S
	SUB		AX, DI
	DEC		AX
	STOSB
	MOV		DS, DX
end;

procedure CutSpace (var S : String); assembler;
asm
	LES		SI, S
	MOV		DI, SI
	CLD
	SEGES	LODSB
	MOV		CL, AL
	MOV		CH, 0
	JCXZ	@3
	ADD		DI, CX
	MOV		AL, ' '
	STD
	REPE	SCASB
	CLD
	JE		@2
	INC		CX
	MOV		DI, SI
	REPE	SCASB
	XCHG	SI, DI
	JE		@1
	DEC		SI
	INC		CX
	SEGES	REP	MOVSB
@1: DEC		DI
@2:	MOV		AX, WORD PTR S
	XCHG	AX, DI
	SUB		AX, DI
	STOSB
@3:
end;

function RepeatChar (Count : Integer; C : Char) : String; assembler;
asm
	CLD
	LES		DI, @Result
	MOV		CX, Count
	JCXZ	@1
	CMP		CX, 256
	JAE		@1
	MOV		AL, CL
	STOSB
	MOV		AL, C
	REP		STOSB
@1:	MOV		BYTE PTR ES:[DI], 0
end;

function PosCharInStr (C : Char; S : String) : Integer; assembler;
asm
	LES		SI, S
	CLD
	XOR		AX, AX
	SEGES	LODSB
	MOV		CX, AX
	MOV		DI, SI
	MOV		AL, C
	REPNE	SCASB
	JE		@1
	MOV		DI, SI
@1:	SUB		DI, SI
	MOV		AX, DI
end;

procedure ToIndex (var S : String);
var
	I	: Integer;
Label
	Next;
begin
	for I := Length (S) downto 1  do
		if IsDelimiter (S [I]) then S [I] := ' ';
	RemoveLowSpace (S);
	AlfaUpStr (S);
end;

function FirstNEqu (var S1, S2 : String) : Integer; assembler;
asm
	MOV		DX, DS
	LDS		SI, S1
	LES		DI, S2
	CLD
	XOR		CX, CX
	MOV		CL, ES:[DI]
	INC		DI
	LODSB
	CMP		CL, AL
	JB		@1
	MOV		CL, AL
@1: MOV		AX, CX
	REPE	CMPSB
	JNE		@2
	INC		AX
@2:	SUB		AX, CX
	MOV		DS, DX
end;

function IsAlfa (C : Char) : Boolean; assembler;
asm
	MOV		AL, 0
	MOV		AH, C
	CMP		AH, 'A'
	JB		@2
	CMP		AH, 'Z'
	JBE		@1
	CMP		AH, 'a'
	JB		@2
	CMP		AH, 'z'
	JBE		@1
	CMP		AH, ''
	JB		@2
	CMP		AH, ''
	JBE		@1
	CMP		AH, ''
	JB		@2
	CMP		AH, ''
	JA		@2
@1:	INC		AX
@2:
end;


{$IFNDEF Turbo6}
procedure PartFromStr (var Dest; const S : String; Clip, Number : Integer); assembler;
{$ELSE}
procedure PartFromStr (var Dest; S : String; Clip, Number : Integer); assembler;
{$ENDIF}
asm
	PUSH	DS
	LES		DI, Dest
	LDS		SI, S
	MOV		CX, Clip
	MOV		AX, Number
	MUL		CX
	INC		AX
	ADD		SI, AX
	CLD
	REP		MOVSB
	POP		DS
end;

function CharPos (S : String; C : Char) : Integer; assembler;
asm
	LES		DI, S
	MOV		AL, C
	CLD
	MOV		CL, ES:[DI]
	MOV		CH, 0
	INC		DI
@1:	REPNE	SCASB
	MOV		AX, 0
	JNE		@2
	SUB		DI, WORD PTR S
	MOV		AX, DI
@2:	DEC		AX
end;

function CountChar (S : String; C : Char) : Integer; assembler;
asm
	LES		DI, S
	MOV		CL, ES:[DI]
	MOV		CH, 0
	INC		DI
	MOV		AL, C
	MOV		BX, -1
	CLD
@1: INC		BX
	REPNE	SCASB
	JE		@1
	MOV		AX, BX
end;

function WrPtr (P : Pointer) : String; assembler;
asm
	LES		DI, @Result
	MOV		AL, 8
	STOSB
	MOV		AL, BYTE PTR P [3]
	CALL	@1
	MOV		AL, BYTE PTR P [2]
	CALL	@1
	MOV		AL, BYTE PTR P [1]
	CALL	@1
	MOV		AL, BYTE PTR P [0]
	CALL	@1
	JMP		@4
@1: PUSH	AX
	SHR		AL, 1
	SHR		AL, 1
	SHR		AL, 1
	SHR		AL, 1
	CALL	@2
	POP		AX
@2:	AND		AL, $0F
	ADD		AL, '0'
	CMP		AL, '9'
	JBE		@3
	ADD		AL, 'A' - '9' - 1
@3:	STOSB
	RETN
@4:
end;

end.