{Copyright by Leonid Youriev, 1993, os@imfiko.bishkek.su}
{$I VERSION}

unit Cref;

interface

uses	Objects;

{$I VERSION}

type

	PCref = ^TCref;
	TCref = Object (TCollection)
		constructor	Load (Var S : TStream);
		procedure	Store (Var S : TStream);
		function	Search (AKey : Word; Var Index : Integer) : Boolean;
		function	Exist (Key : Word) : Boolean;
		function	Cref (Key : Word) : Word;
		procedure	Shift (Min, Ofs : Word);
		destructor	Done; virtual;
	end;

const

	RCref : TStreamRec = (
		ObjType	:	4003;
		VmtLink	:	Ofs (TypeOf (TCref)^);
		Load	:	@TCref.Load;
		Store	:	@TCref.Store );

implementation

{****************************************************************** TCref **}
constructor TCref.Load (Var S : TStream);
	var
		I	: Integer;
	begin
		TObject.Init;
		S.Read (Count, SizeOf (Integer) * 3);
		I := Limit;
		Limit := 0;
		SetLimit (I);
		if Limit < I then
			S.Status := 1
		else
			S.Read (Items^, Word (Count) shl 2);
	end;
 
procedure TCref.Store (Var S : TStream);
	begin
		S.Write (Count, SizeOf (Integer) * 3);
		S.Write (Items^, Word (Count) shl 2);
	end;

function TCref.Exist (Key : Word) : Boolean;
	var
		I : Integer;
	begin
		Exist := Search (Key, I);
	end;

function TCref.Cref (Key : Word) : Word;
	var
		I : Integer;
	begin
		if Search (Key, I) then
			Cref := PtrRec (Items^[I]).Seg
		else
			Cref := $FFFF;
	end;

function TCref.Search (AKey : Word; Var Index : Integer) : Boolean; assembler;
	asm
		PUSH	DS
		PUSH	BP
		LDS		SI, Self
		MOV		DX, [SI].Count
		XOR		CX, CX
		LDS		SI, [SI].Items
		MOV		AX, AKey
		JMP		@1
	@0:	MOV		DX, BP
	@1:	CMP		CX, DX
		JAE		@N
		MOV		BX, CX
		ADD		BX, DX
		SHR		BX, 1
		MOV		BP, BX
		ADD		BX, BX
		ADD		BX, BX
		LES		DI, [SI+BX]
		SCASW
		JB		@0
		MOV		CX, BP
		JA		@1
		POP		BP
		LDS		SI, Index
		MOV		[SI], CX
		MOV		AL, 1
		JMP		@E
	@N:	POP		BP
		MOV		AL, 0
	@E:	POP		DS
	end;

procedure TCref.Shift (Min, Ofs : Word); assembler;
	asm
		MOV		DX, DS
		LDS		SI, Self
		MOV		CX, [SI].Count
		JCXZ	@E
		LDS		SI, [SI].Items
		MOV		AX, Min
		MOV		DI, Ofs
		MOV		BX, 4
	@1:	CMP		AX, [SI+2]
		JBE		@2
		ADD		[SI], DI
	@2:	ADD		SI, BX
		LOOP	@1
	@E:	MOV		DS, DX
	end;

destructor TCref.Done;
	begin
 		Count := 0;
		SetLimit (0);
	end;

end.

