{1/2 Copyright by Leonid Youriev, 1993, os@imfiko.bishkek.su}
{$I VERSION}

unit MsgBox;

interface

uses	Objects, CharLog;

{$I VERSION}

const

{ Message box classes }
	mfWarning		= $0000;
	mfError			= $0001;
	mfInformation	= $0002;
	mfConfirmation	= $0003;

{ Message box button flags }
	mfYesButton		= $0100;
	mfNoButton		= $0200;
	mfOKButton		= $0400;
	mfCancelButton	= $0800;
	mfAllButton		= $1000;
	mfDefaultYes	= $0000;
	mfDefaultNo		= $0010;
	mfDefaultCancel	= $0030;

	mfYesNoCancel	= mfYesButton + mfNoButton + mfCancelButton;
	mfOKCancel		= mfOKButton + mfCancelButton;

function MessageBox (Msg : String; Params : Pointer; AOptions : Word) : Word;
function MessageBoxRect (var R : TRect; Msg : String; Params : Pointer; AOptions : Word) : Word;
function InputBox (Title : String; ALabel : String; var S : String; Limit : Byte) : Word;
function InputBoxRect (var Bounds : TRect; Title : String; ALabel : String; var S : String; Limit : Byte) : Word;

implementation

uses	Drivers, Views, Dialogs, App;

function MessageRect (var R : TRect; Msg : String; AOptions : Word) : Word;
const
	ButtonName	: array [0..4] of Word = (
		Ofs (cYesStr),
		Ofs (cNoStr),
		Ofs (cOkStr),
		Ofs (cCancelStr),
		Ofs (cDefStr));
	Commands	: array [0..4] of Word = (cmYes, cmNo, cmOK, cmCancel, cmOK );
	Titles		: array [0..3] of String [10] = ('','訡','ଠ','');
var
	I,
	X,
	ButtonCount	: Integer;
	Dialog		: PDialog;
	Control		: PView;
	T			: TRect;
	ButtonList	: array [0..4] of PView;
begin
	Dialog := New (PDialog, Init (R, Titles [AOptions and $3]));
	with Dialog^ do
		begin
			Flags := wfClose or wfMove or wfBoldFrame or wfWinFrame or wfWinTitle;
			R.Assign (3, 2, Size.X - 2, Size.Y - 3);
			Control := New (PStaticText, Init (R, Msg));
			with Control^ do
				GrowMode := gfGrowLoX + gfGrowHiX;
			Insert (Control);
			X := -2;
			ButtonCount := 0;
			for I := 0 to 4 do
				if AOptions and ($0100 shl I) <> 0 then
					begin
						R.Assign (0, 0, 10, 2);
						Control := New (PButton, Init (R, PString (Ptr (DSeg, ButtonName [I]))^, Commands [I], bfNormal));
						with Control^ do
							begin
								GrowMode := gfGrowAll;
								Options := Options or ofSelectable;
							end;
						Inc (X, Control^.Size.X + 2);
						ButtonList [ButtonCount] := Control;
						Inc (ButtonCount);
					end;
			X := (Size.X - X) shr 1;
			for I := 0 to ButtonCount - 1 do
				begin
					Control := ButtonList [I];
					Control^.MoveTo (X, Size.Y - 3);
					Inc (X, Control^.Size.X + 2);
					Insert (Control);
				end;
			if AOptions and ($10 shl I) = 0 then
				SelectNext (False);
		end;
	MessageRect := ExecuteDialog (Dialog, NIL);
end;

function MessageBox (Msg : String; Params : Pointer; AOptions : Word) : Word;
var
	R	: TRect;
	Dx,
	Dy,
	I,
	l	: integer;
	S	: String;
begin
	Dx := 0; Dy := 0; l := 0;
	FormatStr (S, Msg, Params^);
	for I := 1 to Byte (S [0]) do
		if S [I] = #13 then
			begin
				Inc (Dy);
				if Dx < l then Dx := l;
				l := 0;
			end
		else
			Inc (l);
	if Dx < l then Dx := l;
	l := 2; Dx := Dx + 4;
	for I := 0 to 4 do
		if AOptions and ($0100 shl I) <> 0 then l := l + 12;
	if Dx < l then Dx := l;
	R.Assign (0, 0, Dx, Dy + 7);
	R.Move ( (Desktop^.Size.X - R.B.X) div 2, (Desktop^.Size.Y - R.B.Y) div 2);
	MessageBox := MessageRect (R, S, AOptions);
end;

function MessageBoxRect (var R : TRect; Msg : String; Params : Pointer; AOptions : Word) : Word;
var
	S	: String;
begin
	FormatStr (S, Msg, Params^);
	MessageBoxRect := MessageRect (R, S, AOptions);
end;

function InputBox (Title : String; ALabel : String; var S : String; Limit : Byte) : Word;
var
	R	: TRect;
	I	: Integer;
begin
	I := Word (ALabel [0]) + Limit;
	if I > 70 then I := 70;
	if I < 26 then I := 26;
	R.Assign (0, 0, I, 7);
	R.Move ( (Desktop^.Size.X - R.B.X) div 2, (Desktop^.Size.Y - R.B.Y) div 2);
	InputBox := InputBoxRect (R, Title, ALabel, S, Limit);
end;

function InputBoxRect (var Bounds : TRect; Title : String; ALabel : String; var S : String; Limit : Byte) : Word;
var
	Dialog	: PDialog;
	Control	: PView;
	R		: TRect;
begin
	Dialog := New (PDialog, Init (Bounds, Title));
	with Dialog^ do
		begin
			Flags := wfClose or wfMove or wfBoldFrame or wfWinTitle or wfWinFrame;
			R.Assign (4 + CStrLen (ALabel), 2, Size.X - 3, 3);
			Control := New (PInputLine, Init (R, Limit));
			Insert (Control);
			R.Assign (2, 2, 3 + CStrLen (ALabel), 3);
			Insert (New (PLabel, Init (R, ALabel, Control)));
			R.Assign ( (Size.X - 20) div 2, Size.Y - 3, 0, Size.Y - 1);
			R.B.X := R.A.X + 10;
			Insert (New (PButton, Init (R, cOkStr, cmOk, bfDefault)));
			R.Move (10, 0);
			Insert (New (PButton, Init (R, cCancelStr, cmCancel, bfNormal)));
			SelectNext (False);
		end;
	InputBoxRect := ExecuteDialog (Dialog, @S);
end;

end.
