{1/2 Copyright by Leonid Youriev, 1993, os@imfiko.bishkek.su}
{$I VERSION}

unit Objects;

interface

{$I VERSION}

const

	ObjectUnableMSG : String [20] = 'ꥪ 㯥...';

{ TStream access modes }
	stCreate		= $3C00;
	stOpenRead		= $3D00;
	stOpenWrite		= $3D01;
	stOpen			= $3D02;

{ TStream error codes }
	stNoMemory		= 1;
	stOk			= 0;
	stError			= -1;
	stInitError		= -2;
	stReadError		= -3;
	stWriteError	= -4;
	stGetError		= -5;
	stPutError		= -6;

{ Maximum TCollection size}
	MaxCollectionSize = 65520 div SizeOf (Pointer);

{ TCollection error codes }
{$IFDEF CollectionCheckRange}
	coIndexError	= -1;
{$ENDIF}
	coOverflow		= -2;

type

{$IFDEF Windows}
	FNameStr	= PChar;
{$ELSE}
	FNameStr	= String [80];
{$ENDIF}

	WordRec = record
		Lo,
		Hi	: Byte;
	end;

	LongRec = record
		Lo,
		Hi	: Word;
	end;

	PtrRec = record
		Ofs,
		Seg : Word;
	end;

	PString = ^String;
{$IFDEF Turbo6}
	PChar	= ^Char;
{$ENDIF}
	PByte	= ^Byte;
	PLong	= ^Longint;
	PInt	= ^Integer;
	PWord	= ^Word;
	PPtr	= ^Pointer;
	PReal	= ^Real;

	PByteArray	= ^TByteArray;
	TByteArray	= array [0..MaxInt shl 1] of Byte;

	PCharArray	= ^TCharArray;
	TCharArray	= array [0..MaxInt shl 1] of Char;

	PCharSet	= ^TCharSet;
	TCharSet	= Set of Char;

	PWordArray	= ^TWordArray;
	TWordArray	= array [0..MaxInt - 1] of Word;

	PLongArray	= ^TLongArray;
	TLongArray	= array [0..MaxCollectionSize - 1] of Longint;

	PPtrArray	= ^TPtrArray;
	TPtrArray	= array [0..MaxCollectionSize - 1] of Pointer;

	PObject = ^TObject;
	TObject = Object
		constructor Init;
		procedure	Free;
		procedure	Kill;
		function	Ok : Boolean;
		destructor	Done; virtual;
	end;

	PStreamRec = ^TStreamRec;
	TStreamRec = Record
		ObjType : Word;
		VmtLink : Word;
		Load	: Pointer;
		Store	: Pointer;
		Next	: Word;
	end;

	PProcedure = procedure;

	PStream = ^TStream;
	TStream = Object (TObject)
		Status		: Integer;
		ErrorInfo	: Integer;
		procedure	CopyFrom (var S : TStream; Count : Longint);
		procedure	Error (Code, Info : Integer); virtual;
		procedure	Flush; virtual;
		function	Get : PObject;
		function	GetPos : Longint; virtual;
		function	GetSize : Longint; virtual;
		procedure	Put (P : PObject);
		procedure	Read (var Buf; Count : Word); virtual;
		function	ReadStr : PString;
		function	ReadPointer : Pointer;
		procedure	Reset;
		procedure	Seek (Pos : Longint); virtual;
		procedure	Truncate; virtual;
		procedure	Write (var Buf; Count : Word); virtual;
		procedure	WriteStr (P : PString);
		procedure	WritePointer (P : Pointer);
		function	Test : Boolean;
		procedure	WriteSignature (var ASignature);
		function	ReadSignature (var ASignature) : Boolean;
		function	GetMem (Size : Word) : Pointer;
{$IFNDEF Turbo6}
		function	StrRead : PChar;
		procedure	StrWrite (P : PChar);
{$ENDIF}
		procedure	WriteText (S : String);
	end;

	PDosStream = ^TDosStream;
	TDosStream = Object (TStream)
		Handle		: Word;
		constructor Init (FileName : FNameStr; Mode : Word);
		destructor	Done; virtual;
		function	GetPos : Longint; virtual;
		function	GetSize : Longint; virtual;
		procedure	Read (var Buf; Count : Word); virtual;
		procedure	Seek (Pos : Longint); virtual;
		procedure	Truncate; virtual;
		procedure	Write (var Buf; Count : Word); virtual;
		procedure	Flush; virtual;
	end;

	PBufStream = ^TBufStream;
	TBufStream = Object (TDosStream)
		Buffer		: Pointer;
		BufSize		: Word;
		BufPtr		: Word;
		BufEnd		: Word;
		constructor Init (FileName : FNameStr; Mode, Size : Word);
		destructor	Done; virtual;
		procedure	Flush; virtual;
		function	GetPos : Longint; virtual;
		function	GetSize : Longint; virtual;
		procedure	Read (var Buf; Count : Word); virtual;
		procedure	Seek (Pos : Longint); virtual;
		procedure	Truncate; virtual;
		procedure	Write (var Buf; Count : Word); virtual;
	end;

	PEmsStream = ^TEmsStream;
	TEmsStream = Object (TStream)
		Handle		: Word;
		PageCount	: Word;
		Size		: Longint;
		Position	: Longint;
		constructor Init (MinSize, MaxSize : Longint);
		destructor	Done; virtual;
		function	GetPos : Longint; virtual;
		function	GetSize : Longint; virtual;
		procedure	Read (var Buf; Count : Word); virtual;
		procedure	Seek (Pos : Longint); virtual;
		procedure	Truncate; virtual;
		procedure	Write (var Buf; Count : Word); virtual;
	end;

	PNulStream = ^TNulStream;
	TNulStream = Object (TStream)
		constructor Init;
		procedure	Read (var Buf; Count : Word); virtual;
		procedure	Write (var Buf; Count : Word); virtual;
		function	ObjectSize (P : PObject) : Longint;
		function	GetPos : Longint; virtual;
		procedure	Seek (Pos : Longint); virtual;
	private
		Position	: Longint;
	end;

{$IFNDEF Windows}
{$IFNDEF DPMI}
	PMemStream = ^TMemStream;
	TMemStream = Object (TStream)
		procedure	Read (var Buf; Count : Word); virtual;
		procedure	Write (var Buf; Count : Word); virtual;
		procedure	Seek (Pos : Longint); virtual;
		function	GetPos : Longint; virtual;
	private
		Position	: PByte;
	end;
{$ENDIF}
{$ENDIF}

	PMemoryStream = ^TMemoryStream;
	TMemoryStream = Object (TStream)
		SegCount	: Integer;
		SegList		: PWordArray;
		CurSeg		: Integer;
		BlockSize	: Integer;
		Size		: Longint;
		Position	: Longint;
		constructor Init (ALimit : Longint; ABlockSize : Word);
		destructor	Done; virtual;
		function	GetPos : Longint; virtual;
		function	GetSize : Longint; virtual;
		procedure	Read (var Buf; Count : Word); virtual;
		procedure	Seek (Pos : Longint); virtual;
		procedure	Truncate; virtual;
		procedure	Write (var Buf; Count : Word); virtual;
	private
		function ChangeListSize (ALimit : Word) : Boolean;
	end;

	PItemList = ^TItemList;
	TItemList = array [0..MaxCollectionSize - 1] of Pointer;

	PCollection = ^TCollection;
	TCollection = Object (TObject)
		Items		: PItemList;
		Count		: Integer;
		Limit		: Integer;
		Delta		: Integer;
		constructor Init (ALimit, ADelta : Integer);
		constructor Load (var S : TStream);
		destructor	Done; virtual;
		function	At (Index : Integer) : Pointer;
		procedure	AtDelete (Index : Integer);
		procedure	AtFree (Index : Integer);
		procedure	AtInsert (Index : Integer; Item : Pointer);
		procedure	AtPut (Index : Integer; Item : Pointer);
		procedure	Delete (Item : Pointer);
		procedure	DeleteAll;
		procedure	Error (Code, Info : Integer); virtual;
		function	FirstThat (Test : Pointer) : Pointer;
		procedure	ForEach (Action : Pointer);
		procedure	Free (Item : Pointer);
		procedure	FreeAll;
		procedure	FreeItem (Item : Pointer); virtual;
		function	GetItem (var S : TStream) : Pointer; virtual;
		function	IndexOf (Item : Pointer) : Integer; virtual;
		procedure	Insert (Item : Pointer); virtual;
		function	LastThat (Test : Pointer) : Pointer;
		procedure	Pack;
		procedure	PutItem (var S : TStream; Item : Pointer); virtual;
		procedure	SetLimit (ALimit : Integer); virtual;
		procedure	Store (var S : TStream);
		function	ConfirmInsert (AFind : Boolean; Item : Pointer) : Boolean; virtual;
		procedure	Press;
		procedure	Swap (I, J : Integer);
	end;

	PSortedCollection = ^TSortedCollection;
	TSortedCollection = Object (TCollection)
		Duplicates	: Boolean;
		constructor Load (var S : TStream);
		function	Compare (Key1, Key2 : Pointer) : Integer; virtual;
		function	IndexOf (Item : Pointer) : Integer; virtual;
		procedure	Insert (Item : Pointer); virtual;
		function	KeyOf (Item : Pointer) : Pointer; virtual;
		function	Search (Key : Pointer; var Index : Integer) : Boolean; virtual;
		function	ConfirmInsert (AFind : Boolean; Item : Pointer) : Boolean; virtual;
		procedure	Store (var S : TStream);
		procedure	QuickSort (Hi, Lo : Integer);
		procedure	SwapSort (Hi, Lo : Integer);
		procedure	ScanSort (Hi, Lo : Integer);
		procedure	MoveSort (Hi, Lo : Integer);
		function	Exist (Item : Pointer) : Boolean;
	end;

	PStringCollection = ^TStringCollection;
	TStringCollection = Object (TSortedCollection)
		function	Compare (Key1, Key2 : Pointer) : Integer; virtual;
		procedure	FreeItem (Item : Pointer); virtual;
		function	GetItem (var S : TStream) : Pointer; virtual;
		procedure	PutItem (var S : TStream; Item : Pointer); virtual;
	end;

{$IFNDEF Turbo6}
	PStrCollection = ^TStrCollection;
	TStrCollection = Object (TSortedCollection)
		function	Compare (Key1, Key2 : Pointer) : Integer; virtual;
		procedure	FreeItem (Item : Pointer); virtual;
		function	GetItem (var S : TStream) : Pointer; virtual;
		procedure	PutItem (var S : TStream; Item : Pointer); virtual;
	end;
{$ENDIF}

{$IFNDEF Windows}
	PResourceCollection = ^TResourceCollection;
	TResourceCollection = Object (TStringCollection)
		procedure	FreeItem (Item : Pointer); virtual;
		function	GetItem (var S : TStream) : Pointer; virtual;
		function	KeyOf (Item : Pointer) : Pointer; virtual;
		procedure	PutItem (var S : TStream; Item : Pointer); virtual;
	end;

	PResourceFile = ^TResourceFile;
	TResourceFile = Object (TObject)
		Stream		: PStream;
		Modified	: Boolean;
		constructor Init (AStream : PStream);
		destructor	Done; virtual;
		function	Count : Integer;
		procedure	Delete (Key : String);
		procedure	Flush;
		function	Get (Key : String) : PObject;
		function	KeyAt (I : Integer) : String;
		procedure	Put (Item : PObject; Key : String);
		function	SwitchTo (AStream : PStream; Pack : Boolean) : PStream;
	private
		BasePos		: Longint;
		IndexPos	: Longint;
		Index		: TResourceCollection;
	end;

	TStrindexRec = record
		Key,
		Count,
		Offset	: Word;
	end;

	TPoint = Object
		X,
		Y	: Integer;
	end;

	TRect = Object
		A,
		B			: TPoint;
		procedure	Assign (XA, YA, XB, YB : Integer);
		procedure	Copy (R : TRect);
		procedure	Move (ADX, ADY : Integer);
		procedure	Grow (ADX, ADY : Integer);
		procedure	Intersect (R : TRect);
		procedure	Union (R : TRect);
		function	Contains (P : TPoint) : Boolean;
		function	Equals (R : TRect) : Boolean;
		function	Empty : Boolean;
	end;

	PStrindex = ^TStrindex;
	TStrindex = array [0..9999] of TStrindexRec;

	PStringList = ^TStringList;
	TStringList = Object (TObject)
		constructor Load (var S : TStream);
		destructor	Done; virtual;
		function	Get (Key : Word) : String;
	private
		Stream		: PStream;
		BasePos		: Longint;
		IndexSize	: Integer;
		Index		: PStrindex;
		procedure ReadStr (var S : String; Offset, Skip : Word);
	end;

	PStrListMaker = ^TStrListMaker;
	TStrListMaker = Object (TObject)
		constructor Init (AStrSize, AIndexSize : Word);
		destructor	Done; virtual;
		procedure	Put (Key : Word; S : String);
		procedure	Store (var S : TStream);
	private
		StrPos		: Word;
		StrSize		: Word;
		Strings		: PByteArray;
		IndexPos	: Word;
		IndexSize	: Word;
		Index		: PStrindex;
		Cur			: TStrindexRec;
		procedure	CloseCurrent;
	end;
{$ENDIF}

	TSignature = record
		Key		: Longint;
		Text	: String;
	end;

function	NewStr (S : String) : PString;
function	GenStr (S : PString) : PString;
procedure	ReMakeStr (var P : PString; var S : String);
function	GetStr (P : PString) : PString;
function	DupStr (S : PString) : PString;
procedure	DisposeStr (P : PString);
procedure	DisposeObj (var P);

procedure RegisterType (var S : TStreamRec);
procedure Abstract;
procedure RegisterObjects;
function nOk : Boolean;
inline (
	$26/$8B/$3D/	{	MOV		DI, ES:[DI]		}
	$8B/$05/		{	MOV		AX, [DI]		}
	$03/$45/$02/	{	ADD		AX, [DI + 2]	}
	$0A/$C4			{	OR		AL, AH			}
	);

const

	StreamError		: Pointer = NIL;

	EmsCurHandle	: Word = $FFFF;
	EmsCurPage		: Word = $FFFF;

const

	RCollection : TStreamRec = (
		ObjType : 50;
		VmtLink : Ofs (TypeOf (TCollection)^);
		Load	: @TCollection.Load;
		Store	: @TCollection.Store);

	RStringCollection	: TStreamRec = (
		ObjType : 51;
		VmtLink : Ofs (TypeOf (TStringCollection)^);
		Load	: @TStringCollection.Load;
		Store	: @TStringCollection.Store);

{$IFNDEF Windows }
	RStringList : TStreamRec = (
		ObjType : 52;
		VmtLink : Ofs (TypeOf (TStringList)^);
		Load	: @TStringList.Load;
		Store	: NIL);

	RStrListMaker : TStreamRec = (
		ObjType : 52;
		VmtLink : Ofs (TypeOf (TStrListMaker)^);
		Load	: NIL;
		Store	: @TStrListMaker.Store);
{$ENDIF}

var
	Nul			: TNulStream;

implementation

{$IFDEF Windows}
{$IFDEF AntiCopy}
uses	Anti, Quick, WinProcs, Strings, OMemory;
{$ELSE}
uses	Quick, WinProcs, Strings, OMemory;
{$ENDIF}
{$ELSE}
{$IFDEF AntiCopy}
uses	Anti, Memory, Quick, Strings;
{$ELSE}
uses	Memory, Quick, Strings;
{$ENDIF}
{$ENDIF}

{$IFDEF Windows}
	{$DEFINE NewExeFormat}
{$ENDIF}

{$IFDEF DPMI}
	{$DEFINE NewExeFormat}
{$ENDIF}

const
	CR_LF_EOF	: array [0..2] of Char = (#$0D, #$0A, #$1A);

procedure Abstract;
begin
{	RunError (211);}
end;

procedure DisposeObj (var P); assembler;
asm
	LES		DI, P
	XOR		AX, AX
	CWD
	XCHG	AX, ES:[DI]
	XCHG	DX, ES:[DI + 2]
	PUSH	DX
	PUSH	AX
	CALL	TObject.Free
end;

{***************************************************************** TObject **}
constructor TObject.Init; assembler;
asm
	LES		DI, Self
	MOV		SI, ES:[DI]
	MOV		CX, [SI]
	XOR		AX, AX
	CLD
	ADD		DI, 2
	RCR		CX, 1
	DEC		CX
	REP		STOSW
	RCL		CX, 1
	REP		STOSB
end;

procedure TObject.Free;
label
	No;
begin
	asm
		MOV		CX, WORD PTR Self [2]
		JCXZ	No
		CMP		CX, SEG @DATA
		JE		No
		MOV		AX, SS
		CMP		AX, CX
		JE		No
	end;
	Dispose (PObject (@Self), Done);
	No:
end;

procedure TObject.Kill;
label
	No;
begin
	asm
		LES		DI, Self
		MOV		CX, ES:[DI]
		JCXZ	No
	end;
	Done;
	asm
		CMP		WORD PTR Self [2], SEG @Data
		JNE		No
		LES		DI, Self
		MOV		WORD PTR ES:[DI], 0
	end;
	No:
end;

function TObject.Ok : Boolean; assembler;
asm
	XOR		AX, AX
	CMP		WORD PTR Self [2], AX
	JE		@1
	LES		DI, Self
	MOV		DI, ES:[DI]
	MOV		CX, [DI]
	JCXZ	@1
	ADD		CX, [DI + 2]
	JNE		@1
	INC		AX
@1:
end;

destructor TObject.Done;
begin
end;

{************************************** TStream type registration routines **}
const
	StreamTypes : Word = 0;

procedure RegisterError;
begin
	RunError (212);
end;

procedure RegisterType (var S : TStreamRec); assembler;
asm
	MOV		AX, DS
	CMP		AX, S.Word [2]
	JNE		@1
	MOV		SI, S.Word [0]
	MOV		AX, [SI].TStreamRec.ObjType
	OR		AX, AX
	JE		@1
	MOV		DI, StreamTypes
	MOV		[SI].TStreamRec.Next, DI
	JMP		@3
@1: JMP		RegisterError
@2: CMP		AX, [DI].TStreamRec.ObjType
	JE		@1
	MOV		DI, [DI].TStreamRec.Next
@3: OR		DI, DI
	JNE		@2
	MOV		StreamTypes, SI
end;

{************************************************ TStream support routines **}
const
	TStream_Error	= $04 + vmtHeaderSize;
	TStream_Flush	= $08 + vmtHeaderSize;
	TStream_Read	= $14 + vmtHeaderSize;
	TStream_Write	= $20 + vmtHeaderSize;

{ Stream error handler									}
{ In	AX		= Error info							}
{		DX		= Error code							}
{		ES :DI	= Stream Object pointer					}
{ Uses	AX, BX, CX, DX, SI								}

procedure DoStreamError; assembler;
asm
	PUSH	ES
	PUSH	DI
	PUSH	DX
	PUSH	AX
	PUSH	ES
	PUSH	DI
	MOV		DI, ES:[DI]
	CALL	DWORD PTR [DI].TStream_Error
	POP		DI
	POP		ES
end;

{***************************************************************** TStream **}
procedure TStream.CopyFrom (var S : TStream; Count : Longint);
var
	N		: Word;
	Buffer	: array [0..1023] of Byte;
begin
	while Count > 0 do
		begin
			if Count > SizeOf (Buffer) then
				N := SizeOf (Buffer)
			else
				N := Count;
			S.Read (Buffer, N);
			Write (Buffer, N);
			Dec (Count, N);
		end;
end;

procedure TStream.WriteSignature (var ASignature);
var
	Signature	: TSignature absolute ASignature;
begin
	Write (Signature.Text [1], Length (Signature.Text));
	Write (CR_LF_EOF, SizeOf (CR_LF_EOF));
	Write (Signature.Key, SizeOf (Signature.Key));
end;

function TStream.ReadSignature (var ASignature) : Boolean;
var
	Etalon		: TSignature absolute ASignature;
	Signature	: TSignature;
	_CrLf		: array [0..SizeOf (CR_LF_EOF) - 1] of Byte;
begin
	ReadSignature := False;
	Read (Signature.Text [1], Length (Etalon.Text));
	Read (_CrLf, SizeOf (_CrLf));
	Read (Signature.Key, SizeOf (Etalon.Key));
	Signature.Text [0] := Etalon.Text [0];
	if Status = stOk then
		if (Signature.Text = Etalon.Text) and (Signature.Key = Etalon.Key) then
			ReadSignature := True
		else
			Status := 2;
end;

procedure TStream.Error (Code, Info : Integer);
type
	TErrorProc = procedure (var S : TStream);
begin
	Status := Code;
	ErrorInfo := Info;
	if PtrRec (StreamError).Seg <> 0 then TErrorProc (StreamError) (Self);
end;

procedure TStream.Flush;
begin
end;

function TStream.Get : PObject; assembler;
asm
	PUSH	AX
	PUSH	AX
	MOV		AX, SP
	PUSH	SS
	PUSH	AX
	MOV		AX, 4
	PUSH	AX
	LES		DI, Self
	PUSH	ES
	PUSH	DI
	MOV		DI, ES:[DI]
	CALL	DWORD PTR [DI].TStream_Read
	POP		AX
	POP		CX
	OR		AX, AX
	JE		@3
	ADD		CX, AX
	JNE		@2
	MOV		BX, StreamTypes
	JMP		@2
@1: CMP		AX, [BX].TStreamRec.ObjType
	JE		@4
	MOV		BX, [BX].TStreamRec.Next
@2: OR		BX, BX
	JNE		@1
	LES		DI, Self
	MOV		DX, stGetError
	CALL	DoStreamError
@3: XOR		AX, AX
	MOV		DX, AX
	JMP		@5
@4: LES		DI, Self
	PUSH	ES
	PUSH	DI
	PUSH	[BX].TStreamRec.VmtLink
	XOR		AX, AX
	PUSH	AX
	PUSH	AX
	CALL	[BX].TStreamRec.Load
@5:
end;

function TStream.GetPos : Longint;
begin
	Abstract;
end;

function TStream.GetSize : Longint;
begin
	Abstract;
end;

procedure TStream.Put (P : PObject); assembler;
asm
	LES		DI, P
	MOV		CX, ES
	JCXZ	@4
	MOV		AX, ES:[DI]
	MOV		BX, StreamTypes
	JMP		@2
@1: CMP		AX, [BX].TStreamRec.VmtLink
	JE		@3
	MOV		BX, [BX].TStreamRec.Next
@2: OR		BX, BX
	JNE		@1
	LES		DI, Self
	MOV		DX, stPutError
	CALL	DoStreamError
	JMP		@5
@3: MOV		CX, [BX].TStreamRec.ObjType
@4: PUSH	BX
	MOV		AX, CX
	NEG		AX
	PUSH	AX
	PUSH	CX
	MOV		AX, SP
	PUSH	SS
	PUSH	AX
	MOV		AX, 4
	PUSH	AX
	LES		DI, Self
	PUSH	ES
	PUSH	DI
	MOV		DI, ES:[DI]
	CALL	DWORD PTR [DI].TStream_Write
	POP		CX
	POP		AX
	POP		BX
	JCXZ	@5
	LES		DI, Self
	PUSH	ES
	PUSH	DI
	PUSH	P.Word [2]
	PUSH	P.Word [0]
	CALL	[BX].TStreamRec.Store
@5:
end;

procedure TStream.Read (var Buf; Count : Word);
begin
	Abstract;
end;

function TStream.ReadPointer : Pointer;
var
	P : Pointer;
begin
	Read (P, SizeOf (P));
	asm
		ADD		WORD PTR P [2], SEG @DATA
	end;
	ReadPointer := P;
end;

procedure TStream.WritePointer (P : Pointer);
begin
	asm
		SUB		WORD PTR P [2], SEG @DATA
	end;
	Write (P, SizeOf (P));
end;

function TStream.Test : Boolean;
begin
	if Status = stOk then
		Test := True
	else
		begin
			Reset;
			Test := False;
		end;
end;

function TStream.ReadStr : PString;
var
	L	: Byte;
	P	: PString;
begin
	Read (L, 1);
	if L > 0 then
		begin
			P := GetMem (L + 1);
			if PtrRec (P).Seg > 0 then
				begin
					P^ [0] := Char (L);
					Read (P^ [1], L);
					ReadStr := P;
				end;
		end
	else
		ReadStr := NIL;
end;

{$IFNDEF Turbo6}
function TStream.StrRead : PChar;
var
	L : Word;
	P : PChar;
begin
	Read (L, SizeOf (Word));
	if L = 0 then
		StrRead := NIL
	else
		begin
			P := GetMem (L + 1);
			if PtrRec (P).Seg > 0 then
				begin
					Read (P [0], L);
					P [L] := #0;
				end;
			StrRead := P;
		end;
end;

procedure TStream.StrWrite (P : PChar);
var
	L : Word;
begin
	if PtrRec (P).Seg = 0 then
		L := 0
	else
		L := StrLen (P);
	Write (L, SizeOf (Word));
	if L > 0 then Write (P [0], L);
end;
{$ENDIF}

procedure TStream.Reset;
begin
	Status := 0;
	ErrorInfo := 0;
end;

procedure TStream.Seek (Pos : Longint);
begin
	Abstract;
end;

procedure TStream.Truncate;
begin
	Abstract;
end;

procedure TStream.Write (var Buf; Count : Word);
begin
	Abstract;
end;

function TStream.GetMem (Size : Word) : Pointer;
var
	P	: Pointer;
begin
	System.GetMem (P, Size);
	if PtrRec (P).Seg = 0 then Error (stNoMemory, 0);
	GetMem := P;
end;

procedure TStream.WriteStr (P : PString);
const
	Empty	: Byte = 0;
begin
	if PtrRec (P).Seg <> 0 then
		Write (P^, Length (P^) + 1)
	else
		Write (Empty, 1);
end;

procedure TStream.WriteText (S : String);
begin
	Write (S [1], Length (S));
end;

{************************************************************** TDosStream **}
constructor TDosStream.Init (FileName : FNameStr; Mode : Word); assembler;
var
	NameBuf : array [0..80] of Char;
asm
	XOR		AX, AX
	PUSH	AX
	LES		DI, Self
	PUSH	ES
	PUSH	DI
	CALL	TStream.Init
{$IFDEF Windows}
	LEA		DI, NameBuf
	PUSH	SS
	PUSH	DI
	LES		DI, FileName
	PUSH	ES
	PUSH	DI
	MOV		AX, 79
	PUSH	AX
	CALL	StrLCopy
	PUSH	DX
	PUSH	AX
	PUSH	DX
	PUSH	AX
	CALL	AnsiToOem
	PUSH	DS
	LEA		DX, NameBuf
{$ELSE}
	PUSH	DS
	LDS		SI, FileName
	LEA		DI, NameBuf
	MOV		DX, DI
	PUSH	SS
	POP		ES
	CLD
	LODSB
	CMP		AL, 79
	JB		@1
	MOV		AL, 79
@1: CBW
	XCHG	AX, CX
	REP		MOVSB
	XCHG	AX, CX
	STOSB
{$ENDIF}
	PUSH	SS
	POP		DS
	XOR		CX, CX
	MOV		AX, Mode
	INT		21H
	POP		DS
	JNC		@2
	LES		DI, Self
	MOV		DX, stInitError
	CALL	DoStreamError
	MOV		AX, -1
@2: LES		DI, Self
	MOV		ES:[DI].TDosStream.Handle, AX
end;

destructor TDosStream.Done; assembler;
asm
	LES		DI, Self
	MOV		BX, ES:[DI].TDosStream.Handle
	CMP		BX, -1
	JE		@1
	MOV		AH, 3EH
	INT		21H
@1: XOR		AX, AX
	PUSH	AX
	PUSH	ES
	PUSH	DI
	CALL	TStream.Done
end;

function TDosStream.GetPos : Longint; assembler;
asm
	LES		DI, Self
	XOR		DX, DX
	CMP		DX, ES:[DI].TDosStream.Status
	JNE		@1
	MOV		CX, DX
	MOV		BX, ES:[DI].TDosStream.Handle
	MOV		AX, 4201H
	INT		21H
	JNC		@2
	MOV		DX, stError
	CALL	DoStreamError
@1: MOV		AX, -1
	CWD
@2:
end;

function TDosStream.GetSize : Longint; assembler;
asm
	LES		DI, Self
	XOR		DX, DX
	CMP		DX, ES:[DI].TDosStream.Status
	JNE		@1
	MOV		CX, DX
	MOV		BX, ES:[DI].TDosStream.Handle
	MOV		AX, 4201H
	INT		21H
	PUSH	DX
	PUSH	AX
	XOR		DX, DX
	MOV		CX, DX
	MOV		AX, 4202H
	INT		21H
	POP		SI
	POP		CX
	PUSH	DX
	PUSH	AX
	MOV		DX, SI
	MOV		AX, 4200H
	INT		21H
	POP		AX
	POP		DX
	JNC		@2
	MOV		DX, stError
	CALL	DoStreamError
@1: MOV		AX, -1
	CWD
@2:
end;

procedure TDosStream.Read (var Buf; Count : Word); assembler;
asm
	LES		DI, Self
	CMP		ES:[DI].TDosStream.Status, 0
	JNE		@2
{$IFDEF StreamDestCheck}
	MOV		CX, WORD PTR Buf [2]
	JCXZ	@0
{$ENDIF}
	PUSH	DS
	LDS		DX, Buf
	MOV		CX, Count
	MOV		BX, ES:[DI].TDosStream.Handle
	MOV		AH, 3FH
	INT		21H
	POP		DS
	MOV		DX, stError
	JC		@1
	CMP		AX, CX
	JE		@3
@0: XOR		AX, AX
	MOV		DX, stReadError
@1: CALL	DoStreamError
@2: LES		DI, Buf
	MOV		CX, Count
	XOR		AL, AL
	CLD
	REP		STOSB
@3:
end;

procedure TDosStream.Seek (Pos : Longint); assembler;
asm
	LES		DI, Self
	CMP		ES:[DI].TDosStream.Status, 0
	JNE		@2
	MOV		DX, Pos.Word [0]
	MOV		CX, Pos.Word [2]
	OR		CX, CX
	JNS		@1
	XOR		DX, DX
	XOR		CX, CX
@1: MOV		BX, ES:[DI].TDosStream.Handle
	MOV		AX, 4200H
	INT		21H
	JNC		@2
	MOV		DX, stError
	CALL	DoStreamError
@2:
end;

procedure TDosStream.Truncate; assembler;
asm
	LES		DI, Self
	XOR		CX, CX
	CMP		CX, ES:[DI].TDosStream.Status
	JNE		@1
	MOV		BX, ES:[DI].TDosStream.Handle
	MOV		AH, 40H
	INT		21H
	JNC		@1
	MOV		DX, stError
	CALL	DoStreamError
@1:
end;

procedure TDosStream.Write (var Buf; Count : Word); assembler;
asm
	LES		DI, Self
	CMP		ES:[DI].TDosStream.Status, 0
	JNE		@2
	PUSH	DS
	LDS		DX, Buf
	MOV		CX, Count
	MOV		BX, ES:[DI].TDosStream.Handle
	MOV		AH, 40H
	INT		21H
	POP		DS
	MOV		DX, stError
	JC		@1
	CMP		AX, CX
	JE		@2
	XOR		AX, AX
	MOV		DX, stWriteError
@1: CALL	DoStreamError
@2:
end;

procedure TDosStream.Flush; assembler;
asm
	LES		DI, Self
	MOV		BX, ES:[DI].TDosStream.Handle
	MOV		AH, 68H
	INT		21H
end;

{************************************************************** TBufStream **}
{ Flush TBufStream buffer								}
{ In	AL		= Flush mode (0=Read, 1=Write, 2=Both)	}
{		ES :DI	= TBufStream pointer					}
{ Out	ZF		= Status test							}

procedure FlushBuffer; assembler;
asm
	MOV		CX, ES:[DI].TBufStream.BufPtr
	SUB		CX, ES:[DI].TBufStream.BufEnd
	JE		@4
	MOV		BX, ES:[DI].TDosStream.Handle
	JA		@1
	CMP		AL, 1
	JE		@4
	MOV		DX, CX
	MOV		CX, -1
	MOV		AX, 4201H
	INT		21H
	JMP		@3
@1: CMP		AL, 0
	JE		@4
	PUSH	DS
	LDS		DX, ES:[DI].TBufStream.Buffer
	MOV		AH, 40H
	INT		21H
	POP		DS
	MOV		DX, stError
	JC		@2
	CMP		AX, CX
	JE		@3
	XOR		AX, AX
	MOV		DX, stWriteError
@2: CALL	DoStreamError
@3: XOR		AX, AX
	MOV		ES:[DI].TBufStream.BufPtr, AX
	MOV		ES:[DI].TBufStream.BufEnd, AX
	CMP		AX, ES:[DI].TStream.Status
@4:
end;

constructor TBufStream.Init (FileName : FNameStr; Mode, Size : Word);
begin
{$IFNDEF Turbo6}
	inherited Init (FileName, Mode);
{$ELSE}
	TDosStream.Init (FileName, Mode);
{$ENDIF}
	BufSize := Size;
	if Size = 0 then
		Error (stInitError, 0)
	else
		Buffer := GetMem (Size);
	BufPtr := 0;
	BufEnd := 0;
end;

destructor TBufStream.Done;
begin
	Flush;
{$IFNDEF Turbo6}
	inherited Done;
{$ELSE}
	TDosStream.Done;
{$ENDIF}
	if PtrRec (Buffer).Seg > 0 then
		FreeMem (Buffer, BufSize);
end;

procedure TBufStream.Flush; assembler;
asm
	LES		DI, Self
	CMP		ES:[DI].TBufStream.Status, 0
	JNE		@1
	MOV		AL, 2
	CALL	FlushBuffer
@1: LES		DI, Self
	MOV		BX, ES:[DI].TDosStream.Handle
	MOV		AH, 68H
	INT		21H
end;

function TBufStream.GetPos : Longint; assembler;
asm
	LES		DI, Self
	PUSH	ES
	PUSH	DI
	CALL	TDosStream.GetPos
	OR		DX, DX
	JS		@1
	LES		DI, Self
	SUB		AX, ES:[DI].TBufStream.BufEnd
	SBB		DX, 0
	ADD		AX, ES:[DI].TBufStream.BufPtr
	ADC		DX, 0
@1:
end;

function TBufStream.GetSize : Longint; assembler;
asm
	LES		DI, Self
	PUSH	ES
	PUSH	DI
	PUSH	ES
	PUSH	DI
	CALL	TBufStream.Flush
	CALL	TDosStream.GetSize
end;

procedure TBufStream.Read (var Buf; Count : Word); assembler;
asm
	LES		DI, Self
	CMP		ES:[DI].TBufStream.Status, 0
	JNE		@6
{$IFDEF StreamDestCheck}
	MOV		CX, WORD PTR Buf [2]
	JCXZ	@0
{$ENDIF}
	MOV		AL, 1
	CALL	FlushBuffer
	JNE		@6
	XOR		BX, BX
@1: MOV		CX, Count
	SUB		CX, BX
	JE		@7
	LES		DI, Self
	MOV		AX, ES:[DI].TBufStream.BufEnd
	SUB		AX, ES:[DI].TBufStream.BufPtr
	JA		@2
	PUSH	DS
	PUSH	CX
	PUSH	BX
	LDS		DX, ES:[DI].TBufStream.Buffer
	MOV		CX, ES:[DI].TBufStream.BufSize
	MOV		BX, ES:[DI].TBufStream.Handle
	MOV		AH, 3FH
	INT		21H
	POP		BX
	POP		CX
	POP		DS
	MOV		DX, stError
	JC		@5
	MOV		ES:[DI].TBufStream.BufPtr, 0
	MOV		ES:[DI].TBufStream.BufEnd, AX
	OR		AX, AX
	JE		@4
@2: CMP		CX, AX
	JB		@3
	MOV		CX, AX
@3: PUSH	DS
	LDS		SI, ES:[DI].TBufStream.Buffer
	ADD		SI, ES:[DI].TBufStream.BufPtr
	ADD		ES:[DI].TBufStream.BufPtr, CX
	LES		DI, Buf
	ADD		DI, BX
	ADD		BX, CX
	CLD
	REP		MOVSB
	POP		DS
	JMP		@1
{$IFDEF StreamDestCheck}
@0: XOR		AX, AX
{$ENDIF}
@4: MOV		DX, stReadError
@5: CALL	DoStreamError
@6: LES		DI, Buf
	MOV		CX, Count
	XOR		AL, AL
	CLD
	REP		STOSB
@7:
end;

procedure TBufStream.Seek (Pos : Longint); assembler;
asm
	LES		DI, Self
	PUSH	ES
	PUSH	DI
	CALL	TDosStream.GetPos
	OR		DX, DX
	JS		@2
	LES		DI, Self
	SUB		AX, Pos.Word [0]
	SBB		DX, Pos.Word [2]
	JNE		@1
	OR		AX, AX
	JE		@1
	MOV		DX, ES:[DI].TBufStream.BufEnd
	SUB		DX, AX
	JB		@1
	MOV		ES:[DI].TBufStream.BufPtr, DX
	JMP		@2
@1: PUSH	Pos.Word [2]
	PUSH	Pos.Word [0]
	PUSH	ES
	PUSH	DI
	PUSH	ES
	PUSH	DI
	CALL	TBufStream.Flush
	CALL	TDosStream.Seek
@2:
end;

procedure TBufStream.Truncate;
begin
	Flush;
{$IFNDEF Turbo6}
	inherited Truncate;
{$ELSE}
	TDosStream.Truncate;
{$ENDIF}
end;

procedure TBufStream.Write (var Buf; Count : Word); assembler;
asm
	LES		DI, Self
	CMP		ES:[DI].TBufStream.Status, 0
	JNE		@4
	MOV		AL, 0
	CALL	FlushBuffer
	JNE		@4
	XOR		DX, DX
@1: MOV		CX, Count
	SUB		CX, DX
	JE		@4
	LES		DI, Self
	MOV		AX, ES:[DI].TBufStream.BufSize
	SUB		AX, ES:[DI].TBufStream.BufPtr
	JA		@2
	PUSH	CX
	PUSH	DX
	MOV		AL, 1
	CALL	FlushBuffer
	POP		DX
	POP		CX
	JNE		@4
	MOV		AX, ES:[DI].TBufStream.BufSize
@2: CMP		CX, AX
	JB		@3
	MOV		CX, AX
@3: PUSH	DS
	MOV		AX, ES:[DI].TBufStream.BufPtr
	ADD		ES:[DI].TBufStream.BufPtr, CX
	LES		DI, ES:[DI].TBufStream.Buffer
	ADD		DI, AX
	LDS		SI, Buf
	ADD		SI, DX
	ADD		DX, CX
	CLD
	REP		MOVSB
	POP		DS
	JMP		@1
@4:
end;

{************************************************************** TEmsStream **}
const
	EmsPageSize = $4000;

var
	EmsBaseSeg	: Word;
	EmsVersion	: Byte;

procedure EmsSelectPage; assembler;
asm
	MOV		AX, ES:[DI].TEmsStream.Position.Word [0]
	MOV		DX, ES:[DI].TEmsStream.Position.Word [2]
	MOV		CX, EmsPageSize
	DIV		CX
	SUB		CX, DX
	MOV		SI, DX
	MOV		DX, ES:[DI].TEmsStream.Handle
	CMP		DX, EmsCurHandle
	JNE		@1
	CMP		AX, EmsCurPage
	JE		@3
@1: MOV		BX, AX
	MOV		AX, 4400H
	INT		67H
	MOV		AL, AH
	AND		AX, 0FFH
	JE		@2
	MOV		DX, stError
	JMP		@3
@2: MOV		EmsCurHandle, DX
	MOV		EmsCurPage, BX
@3:
end;

procedure EmsSetPages; assembler;
asm
	CMP		EmsVersion, 40H
	JAE		@1
	MOV		AX, 84H
	JMP		@2
@1: MOV		DX, ES:[DI].TEmsStream.Handle
	MOV		BX, AX
	MOV		AH, 51H
	INT		67H
	MOV		AL, AH
	AND		AX, 0FFH
	JNE		@2
	MOV		ES:[DI].TEmsStream.PageCount, BX
@2:
end;

constructor TEmsStream.Init (MinSize, MaxSize : LongInt); assembler;
const
	EmsDeviceLen	= 8;
	EmsDeviceStr	: array [1..EmsDeviceLen] of Char = 'EMMXXXX0';
asm
	XOR		AX, AX
	PUSH	AX
	LES		DI, Self
	PUSH	ES
	PUSH	DI
	CALL	TStream.Init
	MOV		AX, 3567H
	INT		21H
	MOV		CX, EmsDeviceLen
	MOV		SI, OFFSET EmsDeviceStr
	MOV		DI, 0AH
	CLD
	REP		CMPSB
	LES		DI, Self
	MOV		AX, -1
	JNE		@3
	MOV		AH, 41H
	INT		67H
	MOV		EmsBaseSeg, BX
	MOV		AH, 46H
	INT		67H
	MOV		EmsVersion, AL
	MOV		CX, EmsPageSize
	MOV		AX, MinSize.Word [0]
	MOV		DX, MinSize.Word [2]
	ADD		AX, EmsPageSize - 1
	ADC		DX, 0
	DIV		CX
	MOV		BX, AX
	CMP		EmsVersion, 40H
	JAE		@2
	PUSH	AX
	MOV		AX, MaxSize.Word [0]
	MOV		DX, MaxSize.Word [2]
	ADD		AX, EmsPageSize - 1
	ADC		DX, 0
	DIV		CX
	MOV		CX, AX
	MOV		AH, 42H
	INT		67H
	POP		AX
	CMP		BX, CX
	JB		@1
	MOV		BX, CX
@1: CMP		BX, AX
	JA		@2
	MOV		BX, AX
@2: MOV		AH, 43H
	INT		67H
	MOV		AL, AH
	AND		AX, 0FFH
	JE		@4
@3: MOV		DX, stInitError
	CALL	DoStreamError
	MOV		DX, -1
	XOR		BX, BX
@4: MOV		ES:[DI].TEmsStream.Handle, DX
	MOV		ES:[DI].TEmsStream.PageCount, BX
	XOR		AX, AX
	ADD		DI, OFFSET TEmsStream.Size
	MOV		CX, 4
	REP		STOSW
end;

destructor TEmsStream.Done; assembler;
asm
	LES		DI, Self
	MOV		DX, ES:[DI].TEmsStream.Handle
	CMP		DX, -1
	JE		@1
	MOV		AH, 45H
	INT		67H
@1: XOR		AX, AX
	PUSH	AX
	PUSH	ES
	PUSH	DI
	CALL	TStream.Done
end;

function TEmsStream.GetPos : Longint; assembler;
asm
	LES		DI, Self
	CMP		ES:[DI].TEmsStream.Status, 0
	JNE		@1
	MOV		AX, ES:[DI].TEmsStream.Position.Word [0]
	MOV		DX, ES:[DI].TEmsStream.Position.Word [2]
	JMP		@2
@1: MOV		AX, -1
	CWD
@2:
end;

function TEmsStream.GetSize : Longint; assembler;
asm
	LES		DI, Self
	CMP		ES:[DI].TEmsStream.Status, 0
	JNE		@1
	MOV		AX, ES:[DI].TEmsStream.Size.Word [0]
	MOV		DX, ES:[DI].TEmsStream.Size.Word [2]
	JMP		@2
@1: MOV		AX, -1
	CWD
@2:
end;

procedure TEmsStream.Read (var Buf; Count : Word); assembler;
asm
	LES		DI, Self
	XOR		BX, BX
	CMP		BX, ES:[DI].TEmsStream.Status
	JNE		@3
{$IFDEF StreamDestCheck}
	MOV		CX, WORD PTR Buf [2]
	JCXZ	@1
{$ENDIF}
	MOV		AX, ES:[DI].TEmsStream.Position.Word [0]
	MOV		DX, ES:[DI].TEmsStream.Position.Word [2]
	ADD		AX, Count
	ADC		DX, BX
	CMP		DX, ES:[DI].TEmsStream.Size.Word [2]
	JA		@1
	JB		@7
	CMP		AX, ES:[DI].TEmsStream.Size.Word [0]
	JBE		@7
@1: XOR		AX, AX
	MOV		DX, stReadError
@2: CALL	DoStreamError
@3: LES		DI, Buf
	MOV		CX, Count
	XOR		AL, AL
	CLD
	REP		STOSB
	JMP		@8
@5: PUSH	BX
	CALL	EmsSelectPage
	POP		BX
	JNE		@2
	MOV		AX, Count
	SUB		AX, BX
	CMP		CX, AX
	JB		@6
	MOV		CX, AX
@6: ADD		ES:[DI].TEmsStream.Position.Word [0], CX
	ADC		ES:[DI].TEmsStream.Position.Word [2], 0
	PUSH	ES
	PUSH	DS
	PUSH	DI
	LES		DI, Buf
	ADD		DI, BX
	ADD		BX, CX
	MOV		DS, EmsBaseSeg
	CLD
	REP		MOVSB
	POP		DI
	POP		DS
	POP		ES
@7: CMP		BX, Count
	JB		@5
@8:
end;

procedure TEmsStream.Seek (Pos : Longint); assembler;
asm
	LES		DI, Self
	MOV		AX, Pos.Word [0]
	MOV		DX, Pos.Word [2]
	OR		DX, DX
	JNS		@1
	XOR		AX, AX
	CWD
@1: MOV		ES:[DI].TEmsStream.Position.Word [0], AX
	MOV		ES:[DI].TEmsStream.Position.Word [2], DX
end;

procedure TEmsStream.Truncate; assembler;
asm
	LES		DI, Self
	XOR		BX, BX
	CMP		ES:[DI].TEmsStream.Status, BX
	JNE		@2
	CMP		EmsVersion, 40H
	JB		@1
	MOV		AX, ES:[DI].TEmsStream.Position.Word [0]
	MOV		DX, ES:[DI].TEmsStream.Position.Word [2]
	ADD		AX, EmsPageSize - 1
	ADC		DX, BX
	MOV		CX, EmsPageSize
	DIV		CX
	CALL	EmsSetPages
	JE		@1
	MOV		DX, stError
	CALL	DoStreamError
	JMP		@2
@1: MOV		AX, ES:[DI].TEmsStream.Position.Word [0]
	MOV		DX, ES:[DI].TEmsStream.Position.Word [2]
	MOV		ES:[DI].TEmsStream.Size.Word [0], AX
	MOV		ES:[DI].TEmsStream.Size.Word [2], DX
@2:
end;

procedure TEmsStream.Write (var Buf; Count : Word); assembler;
asm
	LES		DI, Self
	XOR		BX, BX
	CMP		BX, ES:[DI].TEmsStream.Status
	JNE		@7
	MOV		AX, ES:[DI].TEmsStream.Position.Word [0]
	MOV		DX, ES:[DI].TEmsStream.Position.Word [2]
	ADD		AX, Count
	ADC		DX, BX
	ADD		AX, EmsPageSize - 1
	ADC		DX, BX
	MOV		CX, EmsPageSize
	DIV		CX
	CMP		AX, ES:[DI].TEmsStream.PageCount
	JBE		@4
	PUSH	BX
	CALL	EmsSetPages
	POP		BX
	JE		@4
@1: MOV		DX, stWriteError
	CALL	DoStreamError
	JMP		@7
@2: PUSH	BX
	CALL	EmsSelectPage
	POP		BX
	JNE		@1
	MOV		AX, Count
	SUB		AX, BX
	CMP		CX, AX
	JB		@3
	MOV		CX, AX
@3: ADD		ES:[DI].TEmsStream.Position.Word [0], CX
	ADC		ES:[DI].TEmsStream.Position.Word [2], 0
	PUSH	ES
	PUSH	DS
	PUSH	DI
	MOV		DI, SI
	MOV		ES, EmsBaseSeg
	LDS		SI, Buf
	ADD		SI, BX
	ADD		BX, CX
	CLD
	REP		MOVSB
	POP		DI
	POP		DS
	POP		ES
@4: CMP		BX, Count
	JB		@2
@5: MOV		AX, ES:[DI].TEmsStream.Position.Word [0]
	MOV		DX, ES:[DI].TEmsStream.Position.Word [2]
	CMP		DX, ES:[DI].TEmsStream.Size.Word [2]
	JB		@7
	JA		@6
	CMP		AX, ES:[DI].TEmsStream.Size.Word [0]
	JBE		@7
@6: MOV		ES:[DI].TEmsStream.Size.Word [0], AX
	MOV		ES:[DI].TEmsStream.Size.Word [2], DX
@7:
end;

{************************************************************** TNulStream **}
constructor TNulStream.Init;
begin
	TStream.Init;
end;

procedure TNulStream.Read (var Buf; Count : Word);
begin
	if PtrRec (Buf).Seg > 0 then Clear (Buf, Count);
	Inc (Position, Count);
end;

procedure TNulStream.Write (var Buf; Count : Word); assembler;
asm
	LES		SI, Self
	MOV		AX, Count
	ADD		WORD PTR ES:[SI].Position [0], AX
	ADC		WORD PTR ES:[SI].Position [2], 0
end;

procedure TNulStream.Seek (Pos : Longint);
begin
	Position := Pos;
end;

function TNulStream.GetPos : Longint;
begin
	GetPos := Position;
end;

function TNulStream.ObjectSize (P : PObject) : Longint;
var
	OldPos	: Longint;
begin
	OldPos := Position;
	Put (P);
	ObjectSize := Position - OldPos;
end;

{$IFNDEF Windows}
{$IFNDEF DPMI}
{************************************************************** TMemStream **}
function PtrInc (P : Pointer; W : Word) : Pointer; assembler;
asm
	MOV		BX, WORD PTR P
	MOV		DX, WORD PTR P + 2
	ADD		BX, W
	JNC		@1
	ADD		DX, 1000H
	JMP		@2
@1: MOV		CL, 4
	MOV		AX, BX
	AND		AX, 0000FH
	SHR		BX, CL
	ADD		DX, BX
@2:
end;

procedure TMemStream.Read (var Buf; Count : Word);
begin
	Move (Position^, Buf, Count);
	Position := PtrInc (Position, Count);
end;

procedure TMemStream.Write (var Buf; Count : Word);
begin
	Move (Buf, Position^, Count);
	Position := PtrInc (Position, Count);
end;

procedure TMemStream.Seek (Pos : Longint);
begin
	Position := PtrInc (Pointer (Pos), 0);
end;

function TMemStream.GetPos : Longint;
begin
	GetPos := Longint (Position);
end;
{$ENDIF}
{$ENDIF}

{*********************************************************** TMemoryStream **}
const
	MaxSegArraySize = 16384;

{$IFDEF NewExeFormat}
	DefaultBlockSize	= $2000;
{$ELSE}
	DefaultBlockSize	= $0800;
{$ENDIF}

procedure MemSelectSeg; near; assembler;
asm
	MOV		AX, ES:[DI].TMemoryStream.Position.Word [0]
	MOV		DX, ES:[DI].TMemoryStream.Position.Word [2]
	MOV		CX, ES:[DI].TMemoryStream.BlockSize
	DIV		CX
	SUB		CX, DX
	MOV		SI, DX
	SHL		AX, 1
	MOV		ES:[DI].TMemoryStream.CurSeg, AX
end;

const
	MemStreamSize	= (SizeOf (TMemoryStream) - SizeOf (TStream)) div 2;

constructor TMemoryStream.Init (ALimit : Longint; ABlockSize : Word); assembler;
asm
	XOR		AX, AX
	PUSH	AX
	LES		DI, Self
	PUSH	ES
	PUSH	DI
	CALL	TStream.Init
	LES		DI, Self
{$IFDEF Windows}
	XOR		AX, AX
	PUSH	DI
	ADD		DI, OFFSET TMemoryStream.SegCount
	MOV		CX, MemStreamSize
	REP		STOSW
	POP		DI
{$ENDIF}
	CMP		ABlockSize, 0
	JNZ		@1
	MOV		ABlockSize, DefaultBlockSize
@1: MOV		AX, ALimit.Word [0]
	MOV		DX, ALimit.Word [2]
	DIV		ABlockSize
	NEG		DX
	ADC		AX, 0
	MOV		DX, ABlockSize
	MOV		ES:[DI].TMemoryStream.BlockSize, DX
	PUSH	AX
	PUSH	ES
	PUSH	DI
	CALL	ChangeListSize
	LES		DI, Self
	OR		AX, AX
	JNZ		@2
	MOV		DX, stInitError
	CALL	DoStreamError
	MOV		ALimit.Word [0], 0
	MOV		ALimit.Word [2], 0
@2: MOV		AX, ALimit.Word [0]
	MOV		DX, ALimit.Word [2]
	MOV		ES:[DI].TMemoryStream.Size.Word [0], AX
	MOV		ES:[DI].TMemoryStream.Size.Word [2], DX
end;

destructor TMemoryStream.Done;
begin
	ChangeListSize (0);
{$IFNDEF Turbo6}
	inherited Done;
{$ELSE}
	TStream.Done;
{$ENDIF}
end;

function TMemoryStream.ChangeListSize (ALimit : Word) : Boolean;
var
	AItems		: PWordArray;
	Dif,
	Term		: Word;
	NewBlock	: Pointer;
begin
	ChangeListSize := False;
	if ALimit > MaxSegArraySize then ALimit := MaxSegArraySize;
	if ALimit <> SegCount then
		begin
			if ALimit = 0 then
				AItems := NIL
			else
				begin
					AItems := MemAlloc (ALimit * SizeOf (Word));
					if PtrRec (AItems).Seg = 0 then Exit;
					if (SegCount <> 0) and (PtrRec (SegList).Seg <> 0) then
					if SegCount > ALimit then
						Move (SegList^, AItems^, ALimit * SizeOf (Word))
					else
						Move (SegList^, AItems^, SegCount * SizeOf (Word));
				end;
			if ALimit < SegCount then
				begin
					Dif := ALimit;
					Term := SegCount - 1;
					while Dif <= Term do
						begin
							FreeMem (Ptr (SegList^ [Dif], 0), BlockSize);
							Inc (Dif);
						end;
				end
			else
				begin
					Dif := SegCount;
					Term := ALimit - 1;
					while Dif <= Term do
						begin
							NewBlock := MemAllocSeg (BlockSize);
							if NewBlock = NIL then
								Exit
							else
								AItems^ [Dif] := PtrRec (NewBlock).Seg;
							Inc (Dif);
						end;
				end;
			if SegCount <> 0 then FreeMem (SegList, SegCount * SizeOf (Word));
			SegList := AItems;
			SegCount := ALimit;
		end;
	ChangeListSize := True;
end;

function TMemoryStream.GetPos : Longint; assembler;
asm
	LES		DI, Self
	CMP		ES:[DI].TMemoryStream.Status, 0
	JNE		@1
	MOV		AX, ES:[DI].TMemoryStream.Position.Word [0]
	MOV		DX, ES:[DI].TMemoryStream.Position.Word [2]
	JMP		@2
@1: MOV		AX, -1
	CWD
@2:
end;

function TMemoryStream.GetSize : Longint; assembler;
asm
	LES DI, Self
	CMP ES:[DI].TMemoryStream.Status, 0
	JNE @1
	MOV AX, ES:[DI].TMemoryStream.Size.Word [0]
	MOV DX, ES:[DI].TMemoryStream.Size.Word [2]
	JMP @2
@1: MOV AX, -1
	CWD
@2:
end;

procedure TMemoryStream.Read (var Buf; Count : Word); assembler;
asm
	LES		DI, Self
	XOR		BX, BX
	CMP		BX, ES:[DI].TMemoryStream.Status
	JNE		@3
{$IFDEF StreamDestCheck}
	MOV		CX, WORD PTR Buf [2]
	JCXZ	@1
{$ENDIF}
	MOV		AX, ES:[DI].TMemoryStream.Position.Word [0]
	MOV		DX, ES:[DI].TMemoryStream.Position.Word [2]
	ADD		AX, Count
	ADC		DX, BX
	CMP		DX, ES:[DI].TMemoryStream.Size.Word [2]
	JA		@1
	JB		@7
	CMP		AX, ES:[DI].TMemoryStream.Size.Word [0]
	JBE		@7
@1: XOR		AX, AX
	MOV		DX, stReadError
@2: CALL	DoStreamError
@3: LES		DI, Buf
	MOV		CX, Count
	XOR		AL, AL
	CLD
	REP		STOSB
	JMP		@8
@5: CALL	MemSelectSeg
	MOV		AX, Count
	SUB		AX, BX
	CMP		CX, AX
	JB		@6
	MOV		CX, AX
@6: ADD		ES:[DI].TMemoryStream.Position.Word [0], CX
	ADC		ES:[DI].TMemoryStream.Position.Word [2], 0
	PUSH	ES
	PUSH	DS
	PUSH	DI
	MOV		DX, ES:[DI].TMemoryStream.CurSeg
	LES		DI, ES:[DI].TMemoryStream.SegList
	ADD		DI, DX
	MOV		DS, WORD PTR ES:[DI]
	LES		DI, Buf
	ADD		DI, BX
	ADD		BX, CX
	CLD
	REP		MOVSB
	POP		DI
	POP		DS
	POP		ES
@7: CMP		BX, Count
	JB		@5
@8:
end;

procedure TMemoryStream.Seek (Pos : Longint); assembler;
asm
	LES		DI, Self
	MOV		AX, Pos.Word [0]
	MOV		DX, Pos.Word [2]
	OR		DX, DX
	JNS		@1
	XOR		AX, AX
	CWD
@1: MOV		ES:[DI].TMemoryStream.Position.Word [0], AX
	MOV		ES:[DI].TMemoryStream.Position.Word [2], DX
end;

procedure TMemoryStream.Truncate; assembler;
asm
	LES		DI, Self
	XOR		BX, BX
	CMP		ES:[DI].TMemoryStream.Status, BX
	JNE		@2
	MOV		AX, ES:[DI].TMemoryStream.Position.Word [0]
	MOV		DX, ES:[DI].TMemoryStream.Position.Word [2]
	DIV		ES:[DI].TMemoryStream.BlockSize
	NEG		DX
	ADC		AX, BX
	PUSH	AX
	PUSH	ES
	PUSH	DI
	CALL	ChangeListSize
	OR		AX, AX
	JNZ		@1
	MOV		DX, stError
	CALL	DoStreamError
	JMP		@2
@1: LES		DI, Self
	MOV		AX, ES:[DI].TMemoryStream.Position.Word [0]
	MOV		DX, ES:[DI].TMemoryStream.Position.Word [2]
	MOV		ES:[DI].TMemoryStream.Size.Word [0], AX
	MOV		ES:[DI].TMemoryStream.Size.Word [2], DX
@2:
end;

procedure TMemoryStream.Write (var Buf; Count : Word); assembler;
asm
	LES		DI, Self
	XOR		BX, BX
	CMP		BX, ES:[DI].TMemoryStream.Status
	JNE		@7
	MOV		AX, ES:[DI].TMemoryStream.Position.Word [0]
	MOV		DX, ES:[DI].TMemoryStream.Position.Word [2]
	ADD		AX, Count
	ADC		DX, BX
	DIV		ES:[DI].TMemoryStream.BlockSize
	NEG		DX
	ADC		AX, BX
	CMP		AX, ES:[DI].TMemoryStream.SegCount
	JBE		@4
	PUSH	BX
	PUSH	ES
	PUSH	DI
	PUSH	AX
	PUSH	ES
	PUSH	DI
	CALL	ChangeListSize
	POP		DI
	POP		ES
	POP		BX
	OR		AX, AX
	JNZ		@4
@1: MOV		DX, stWriteError
	CALL	DoStreamError
	JMP		@7
@2: CALL	MemSelectSeg
	MOV		AX, Count
	SUB		AX, BX
	CMP		CX, AX
	JB		@3
	MOV		CX, AX
@3: ADD		ES:[DI].TMemoryStream.Position.Word [0], CX
	ADC		ES:[DI].TMemoryStream.Position.Word [2], 0
	PUSH	ES
	PUSH	DS
	PUSH	DI
	MOV		DX, ES:[DI].TMemoryStream.CurSeg
	LES		DI, ES:[DI].TMemoryStream.SegList
	ADD		DI, DX
	MOV		ES, WORD PTR ES:[DI]
	MOV		DI, SI
	LDS		SI, Buf
	ADD		SI, BX
	ADD		BX, CX
	CLD
	REP		MOVSB
	POP		DI
	POP		DS
	POP		ES
@4: CMP		BX, Count
	JB		@2
@5: MOV		AX, ES:[DI].TMemoryStream.Position.Word [0]
	MOV		DX, ES:[DI].TMemoryStream.Position.Word [2]
	CMP		DX, ES:[DI].TMemoryStream.Size.Word [2]
	JB		@7
	JA		@6
	CMP		AX, ES:[DI].TMemoryStream.Size.Word [0]
	JBE		@7
@6: MOV		ES:[DI].TMemoryStream.Size.Word [0], AX
	MOV		ES:[DI].TMemoryStream.Size.Word [2], DX
@7:
end;

{************************************************************* TCollection **}

const
	TCollection_Error		= $04 + vmtHeaderSize;
	TCollection_SetLimit	= $1C + vmtHeaderSize;

procedure CollectionError; assembler;
asm
	PUSH	AX
	PUSH	BX
	PUSH	ES
	PUSH	DI
	MOV		DI, ES:[DI]
	CALL	DWORD PTR [DI].TCollection_Error
end;

constructor TCollection.Init (ALimit, ADelta : Integer);
begin
{$IFNDEF Turbo6}
	inherited Init;
{$ELSE}
	TObject.Init;
{$ENDIF}
	SetLimit (ALimit);
	Delta := ADelta;
end;

constructor TCollection.Load (var S : TStream);
var
	C,
	I	: Integer;
begin
{$IFNDEF Turbo6}
	inherited Init;
{$ELSE}
	TObject.Init;
{$ENDIF}
	S.Read (Count, SizeOf (Integer) * 3);
	Items := NIL;
	C := Count;
	I := Limit;
	Count := 0;
	Limit := 0;
	SetLimit (I);
	Count := C;
	for I := 0 to C - 1 do
		AtPut (I, GetItem (S));
end;

destructor TCollection.Done;
begin
	FreeAll;
	SetLimit (0);
end;

function TCollection.At (Index : Integer) : Pointer; assembler;
asm
	LES		DI, Self
	MOV		BX, Index
{$IFDEF CollectionCheckRange}
	OR		BX, BX
	JL		@1
	CMP		BX, ES:[DI].TCollection.Count
	JGE		@1
{$ENDIF}
	LES		DI, ES:[DI].TCollection.Items
	SHL		BX, 1
	SHL		BX, 1
	MOV		AX, ES:[DI+BX]
	MOV		DX, ES:[DI+BX + 2]
{$IFDEF CollectionCheckRange}
	JMP		@2
@1: MOV		AX, coIndexError
	CALL	CollectionError
	XOR		AX, AX
	MOV		DX, AX
@2:
{$ENDIF}
end;

procedure TCollection.AtDelete (Index : Integer); assembler;
asm
	LES		DI, Self
	MOV		BX, Index
{$IFDEF CollectionCheckRange}
	OR		BX, BX
	JL		@1
	CMP		BX, ES:[DI].TCollection.Count
	JGE		@1
{$ENDIF}
	DEC		ES:[DI].TCollection.Count
	MOV		CX, ES:[DI].TCollection.Count
	SUB		CX, BX
	JE		@2
	CLD
	LES		DI, ES:[DI].TCollection.Items
	SHL		BX, 1
	SHL		BX, 1
	ADD		DI, BX
	LEA		SI, [DI+4]
	SHL		CX, 1
	PUSH	DS
	PUSH	ES
	POP		DS
	REP		MOVSW
	POP		DS
{$IFDEF CollectionCheckRange}
	JMP		@2
@1: MOV		AX, coIndexError
	CALL	CollectionError
{$ENDIF}
@2:
end;

procedure TCollection.AtFree (Index : Integer);
var
	Item	: Pointer;
begin
	Item := At (Index);
	AtDelete (Index);
	FreeItem (Item);
end;

procedure TCollection.Swap (I, J : Integer); assembler;
asm
	LES		DI, Self
	MOV		BX, I
	MOV		SI, J
{$IFDEF CollectionCheckRange}
	OR		BX, BX
	JL		@1
	OR		SI, SI
	JL		@1
	CMP		BX, ES:[DI].TCollection.Count
	JGE		@1
	CMP		SI, ES:[DI].TCollection.Count
	JGE		@1
{$ENDIF}
	LES		DI, ES:[DI].TCollection.Items
	SHL		BX, 1
	SHL		BX, 1
	SHL		SI, 1
	SHL		SI, 1
	ADD		SI, DI
	MOV		AX, ES:[DI+BX]
	MOV		DX, ES:[DI+BX+2]
	XCHG	AX, ES:[SI]
	XCHG	DX, ES:[SI+2]
	MOV		ES:[DI+BX], AX
	MOV		ES:[DI+BX+2], DX
{$IFDEF CollectionCheckRange}
	JMP		@2
@1: MOV		AX, coIndexError
	CALL	CollectionError
@2:
{$ENDIF}
end;

procedure TCollection.AtInsert (Index : Integer; Item : Pointer); assembler;
asm
	LES		DI, Self
	MOV		BX, Index
	MOV		CX, ES:[DI].TCollection.Count
{$IFDEF CollectionCheckRange}
	OR		BX, BX
	JL		@3
	CMP		BX, CX
	JG		@3
{$ENDIF}
	CMP		CX, ES:[DI].TCollection.Limit
	JNE		@1
	PUSH	CX
	PUSH	BX
	ADD		CX, ES:[DI].TCollection.Delta
	PUSH	CX
	PUSH	ES
	PUSH	DI
	MOV		DI, ES:[DI]
	CALL	DWORD PTR [DI].TCollection_SetLimit
	POP		BX
	POP		CX
	LES		DI, Self
	CMP		CX, ES:[DI].TCollection.Limit
	JE		@4
@1: INC		ES:[DI].TCollection.Count
	STD
	LES		DI, ES:[DI].TCollection.Items
	SHL		CX, 1
	ADD		DI, CX
	ADD		DI, CX
	INC		DI
	INC		DI
	SHL		BX, 1
	SUB		CX, BX
	JE		@2
	LEA		SI, [DI-4]
	PUSH	DS
	PUSH	ES
	POP		DS
	REP		MOVSW
	POP		DS
@2: MOV		AX, WORD PTR [Item+2]
	STOSW
	MOV		AX, WORD PTR [Item]
	STOSW
	JMP		@6
{$IFDEF CollectionCheckRange}
@3: MOV		AX, coIndexError
	JMP		@5
{$ENDIF}
@4: MOV		AX, coOverflow
	MOV		BX, CX
@5: CALL	CollectionError
@6:
end;

procedure TCollection.AtPut (Index : Integer; Item : Pointer); assembler;
asm
	MOV		AX, Item.Word [0]
	MOV		DX, Item.Word [2]
	LES		DI, Self
	MOV		BX, Index
{$IFDEF CollectionCheckRange}
	OR		BX, BX
	JL		@1
	CMP		BX, ES:[DI].TCollection.Count
	JGE		@1
{$ENDIF}
	LES		DI, ES:[DI].TCollection.Items
	SHL		BX, 1
	SHL		BX, 1
	MOV		ES:[DI+BX], AX
	MOV		ES:[DI+BX+2], DX
{$IFDEF CollectionCheckRange}
	JMP		@2
@1: MOV		AX, coIndexError
	CALL	CollectionError
{$ENDIF}
@2:
end;

procedure TCollection.Delete (Item : Pointer);
begin
	AtDelete (IndexOf (Item));
end;

procedure TCollection.DeleteAll;
begin
	Count := 0;
end;

procedure TCollection.Error (Code, Info : Integer);
begin
{	RunError (212 - Code);
}end;

function TCollection.FirstThat (Test : Pointer) : Pointer; assembler;
asm
	LES		DI, Self
	MOV		CX, ES:[DI].TCollection.Count
	JCXZ	@2
	LES		DI, ES:[DI].TCollection.Items
@1: PUSH	ES
	PUSH	DI
	PUSH	CX
	PUSH	WORD PTR ES:[DI+2]
	PUSH	WORD PTR ES:[DI]
{$IFDEF Windows}
	MOV		AX, [BP]
	AND		AL, 0FEH
	PUSH	AX
{$ELSE}
	PUSH	WORD PTR [BP]
{$ENDIF}
	CALL	Test
	POP		CX
	POP		DI
	POP		ES
	OR		AL, AL
	JNE		@3
	ADD		DI, 4
	LOOP	@1
@2: XOR		AX, AX
	MOV		DX, AX
	JMP		@4
@3: MOV		AX, ES:[DI]
	MOV		DX, ES:[DI+2]
@4:
end;

procedure TCollection.ForEach (Action : Pointer); assembler;
asm
	LES		DI, Self
	MOV		CX, ES:[DI].TCollection.Count
	JCXZ	@2
	LES		DI, ES:[DI].TCollection.Items
@1: PUSH	ES
	PUSH	DI
	PUSH	CX
	PUSH	WORD PTR ES:[DI+2]
	PUSH	WORD PTR ES:[DI]
{$IFDEF Windows}
	MOV		AX, [BP]
	AND		AL, 0FEH
	PUSH	AX
{$ELSE}
	PUSH	WORD PTR [BP]
{$ENDIF}
	CALL	Action
	POP		CX
	POP		DI
	POP		ES
	ADD		DI, 4
	LOOP	@1
@2:
end;

procedure TCollection.Free (Item : Pointer);
begin
	Delete (Item);
	FreeItem (Item);
end;

procedure TCollection.FreeAll;
var
	I	: Integer;
begin
	I := Count;
	Count := 0;
	while I > 0 do
		begin
			Dec (I);
			FreeItem (Items^ [I]);
		end;
end;

procedure TCollection.FreeItem (Item : Pointer);
begin
	if PtrRec (Item).Seg > 0 then PObject (Item)^.Done;
end;

function TCollection.GetItem (var S : TStream) : Pointer;
begin
	GetItem := S.Get;
end;

function TCollection.IndexOf (Item : Pointer) : Integer; assembler;
asm
	MOV		AX, Item.Word [0]
	MOV		DX, Item.Word [2]
	LES		DI, Self
	MOV		CX, ES:[DI].TCollection.Count
	JCXZ	@3
	LES		DI, ES:[DI].TCollection.Items
	MOV		BX, DI
	SHL		CX, 1
	CLD
@1: REPNE	SCASW
	JCXZ	@3
	TEST	CX, 1
	JE		@1
	XCHG	AX, DX
	SCASW
	XCHG	AX, DX
	LOOPNE	@1
	JNE		@3
	MOV		AX, DI
	SUB		AX, BX
	SHR		AX, 1
	SHR		AX, 1
	DEC		AX
	JMP		@2
@3: MOV		AX, -1
@2:
end;

procedure TCollection.Insert (Item : Pointer);
begin
	if ConfirmInsert (False, Item) then AtInsert (Count, Item);
end;

function TCollection.LastThat (Test : Pointer) : Pointer; assembler;
asm
	LES		DI, Self
	MOV		CX, ES:[DI].TCollection.Count
	JCXZ	@2
	LES		DI, ES:[DI].TCollection.Items
	MOV		AX, CX
	SHL		AX, 1
	SHL		AX, 1
	ADD		DI, AX
@1: SUB		DI, 4
	PUSH	ES
	PUSH	DI
	PUSH	CX
	PUSH	WORD PTR ES:[DI+2]
	PUSH	WORD PTR ES:[DI]
{$IFDEF Windows}
	MOV		AX, [BP]
	AND		AL, 0FEH
	PUSH	AX
{$ELSE}
	PUSH	WORD PTR [BP]
{$ENDIF}
	CALL	Test
	POP		CX
	POP		DI
	POP		ES
	OR		AL, AL
	JNE		@3
	LOOP	@1
@2: XOR		AX, AX
	MOV		DX, AX
	JMP		@4
@3: MOV		AX, ES:[DI]
	MOV		DX, ES:[DI+2]
@4:
end;

procedure TCollection.Press;
begin
	SetLimit (Count);
end;

procedure TCollection.Pack; assembler;
asm
	LES		DI, Self
	MOV		CX, ES:[DI].TCollection.Count
	JCXZ	@3
	LES		DI, ES:[DI].TCollection.Items
	MOV		SI, DI
	PUSH	DS
	PUSH	ES
	POP		DS
	CLD
@1: LODSW
	XCHG	AX, DX
	LODSW
	MOV		BX, AX
	OR		BX, DX
	JE		@2
	XCHG	AX, DX
	STOSW
	XCHG	AX, DX
	STOSW
@2: LOOP	@1
	POP		DS
	LES		BX, Self
	SUB		DI, WORD PTR ES:[BX].TCollection.Items
	SHR		DI, 1
	SHR		DI, 1
	MOV		ES:[BX].TCollection.Count, DI
@3:
end;

procedure TCollection.PutItem (var S : TStream; Item : Pointer);
begin
	S.Put (Item);
end;

procedure TCollection.SetLimit (ALimit : Integer);
var
	AItems : PItemList;
begin
	if ALimit < Count then ALimit := Count;
	if ALimit > MaxCollectionSize then ALimit := MaxCollectionSize;
	if ALimit <> Limit then
		begin
			if ALimit = 0 then
				AItems := NIL
			else
				begin
					if MaxAvail <= Word (ALimit) * SizeOf (Pointer) then Exit;
					GetMem (AItems, Word (ALimit) * SizeOf (Pointer));
					if Count <> 0 then Move (Items^, AItems^, Word (Count) * SizeOf (Pointer));
				end;
			if Limit <> 0 then FreeMem (Items, Word (Limit) * SizeOf (Pointer));
			Items := AItems;
			Limit := ALimit;
		end;
end;

function TCollection.ConfirmInsert (AFind : Boolean; Item : Pointer) : Boolean;
begin
	ConfirmInsert := PtrRec (Item).Seg > 0;
end;

procedure TCollection.Store (var S : TStream);

	procedure DoPutItem (P : Pointer); far;
	begin
		PutItem (S, P);
	end;

begin
	S.Write (Count, SizeOf (Count) + SizeOf (Delta) + SizeOf (Limit));
	ForEach (@DoPutItem);
end;

{******************************************************* TSortedCollection **}
constructor TSortedCollection.Load (var S : TStream);
begin
	TCollection.Load (S);
	S.Read (Duplicates, SizeOf (Boolean));
end;

function TSortedCollection.Compare (Key1, Key2 : Pointer) : Integer;
begin
	Abstract;
end;

function TSortedCollection.IndexOf (Item : Pointer) : Integer;
var
	I	: Integer;
begin
	IndexOf := -1;
	if Search (KeyOf (Item), I) then
		begin
			if Duplicates then
				while (I < Count) and (Item <> Items^ [I]) do Inc (I);
			if I < Count then IndexOf := I;
		end;
end;

procedure TSortedCollection.Insert (Item : Pointer);
var
	I	: Integer;
begin
	if ConfirmInsert (Search (KeyOf (Item), I), Item) then AtInsert (I, Item);
end;

function TSortedCollection.ConfirmInsert (AFind : Boolean; Item : Pointer) : Boolean;
begin
	ConfirmInsert := (not AFind) or (Duplicates);
end;

function TSortedCollection.KeyOf (Item : Pointer) : Pointer; assembler;
asm
	MOV		AX, WORD PTR Item
	MOV		DX, WORD PTR Item + 2
end;

function TSortedCollection.Exist (Item : Pointer) : Boolean;
var
	I	: Integer;
begin
	Exist := Search (KeyOf (Item), I);
end;

function TSortedCollection.Search (Key : Pointer; var Index : Integer) : Boolean;
var
	L,
	H,
	I,
	C	: Integer;
begin
	Search := False;
	L := 0;
	H := Count - 1;
	while L <= H do
		begin
			I := (L + H) shr 1;
			C := Compare (KeyOf (Items^ [I]), Key);
			if C < 0 then
				L := I + 1
			else
				begin
					H := I - 1;
					if C = 0 then
						begin
							Search := True;
							if not Duplicates then L := I;
						end;
				end;
		end;
	Index := L;
end;

procedure TSortedCollection.SwapSort (Hi, Lo : Integer);
var
	I	: Integer;
	B	: Boolean;
begin
	Dec (Hi);
	repeat
		B := True;
		for I := Lo to Hi do
			if Compare (KeyOf (At (I)), KeyOf (At (I + 1))) > 0 then
				begin
					B := False;
					Swap (I, I + 1)
				end;
	until B;
end;

procedure TSortedCollection.ScanSort (Hi, Lo : Integer);
var
	I,
	J,
	N	: Integer;
	P	: Pointer;
begin
	for I := Lo to Hi do
		begin
			N := I;
			P := KeyOf (At (N));
			for J := I + 1 to Hi do
				if Compare (P, KeyOf (At (J))) > 0 then
					begin
						N := J;
						P := KeyOf (At (N));
					end;
			if N <> I then Swap (I, N);
		end;
end;

procedure TSortedCollection.QuickSort (Hi, Lo : Integer);
var
	I,
	J	: Integer;
	P	: Pointer;
begin
	I := Lo;
	J := Hi;
	P := KeyOf (At ((I + J) shr 1));
	repeat
		while (I < Count) and (Compare (P, KeyOf (At (I))) > 0) do Inc (I);
		while (J > 0) and (Compare (P, KeyOf (At (J))) < 0) do Dec (J);
		if I <= J then
			begin
				Swap (I, J);
				Inc (I); Dec (J);
			end;
	until I > J;
	if Lo < J then QuickSort (J, Lo);
	if I < Hi then QuickSort (Hi, I);
end;

procedure TSortedCollection.MoveSort (Hi, Lo : Integer);
var
	I,
	N	: Integer;
	C	: Integer;
	L,
	H	: Integer;
	P	: Pointer;
begin
	C := Count;
	for I := Lo + 1 to Hi do
		begin
			P := KeyOf (At (I));
			if Compare (KeyOf (At (I - 1)), P) > 0 then
				begin
					H := I - 1; L := Lo;
					N := H;
					while (H >= L) do
						begin
							N := (L + H) shr 1;
							if Compare (KeyOf (At (N)), P) > 0 then
								H := N - 1
							else
								L := N + 1;
						end;
					Count := I;
					AtInsert (N, P);
					Count := C;
				end;
		end;
end;

procedure TSortedCollection.Store (var S : TStream);
begin
	TCollection.Store (S);
	S.Write (Duplicates, SizeOf (Boolean));
end;

{******************************************************* TStringCollection **}
function TStringCollection.Compare (Key1, Key2 : Pointer) : Integer; assembler;
asm
	PUSH	DS
	CLD
	LDS		SI, Key1
	LES		DI, Key2
	LODSB
	MOV		AH, ES:[DI]
	INC		DI
	MOV		CL, AL
	CMP		CL, AH
	JB		@1
	MOV		CL, AH
@1:	XOR		CH, CH
	REP		CMPSB
	JE		@2
	MOV		AL, DS:[SI-1]
	MOV		AH, 0
	MOV		CL, ES:[DI-1]
	MOV		CH, 0
	SUB		AX, CX
	JMP		@3
@2:	SUB		AL, AH
	CBW
@3:	POP		DS
end;

procedure TStringCollection.FreeItem (Item : Pointer);
begin
	DisposeStr (Item);
end;

function TStringCollection.GetItem (var S : TStream) : Pointer;
begin
	GetItem := S.ReadStr;
end;

procedure TStringCollection.PutItem (var S : TStream; Item : Pointer);
begin
	S.WriteStr (Item);
end;

{$IFNDEF Turbo6}
{********************************************************** TStrCollection **}
function TStrCollection.Compare (Key1, Key2 : Pointer) : Integer;
begin
	Compare := StrComp (Key1, Key2);
end;

procedure TStrCollection.FreeItem (Item : Pointer);
begin
	StrDispose (Item);
end;

function TStrCollection.GetItem (var S : TStream) : Pointer;
begin
	GetItem := S.StrRead;
end;

procedure TStrCollection.PutItem (var S : TStream; Item : Pointer);
begin
	S.StrWrite (Item);
end;
{$ENDIF}

{$IFNDEF Windows }
{****************************************** Private resource manager types **}
const
	RStreamMagic	: Longint = $52504246;	{'FBPR'}
	RStreamBackLink : Longint = $4C424246;	{'FBBL'}

type
	PResourceItem = ^TResourceItem;
	TResourceItem = record
		Pos		: Longint;
		Size	: Longint;
		Key		: String;
	end;

{***************************************************** TResourceCollection **}
procedure TResourceCollection.FreeItem (Item : Pointer);
begin
	FreeMem (Item, Length (PResourceItem (Item)^.Key) + (SizeOf (TResourceItem) - SizeOf (String) + 1));
end;

function TResourceCollection.GetItem (var S : TStream) : Pointer;
var
	APos	: Longint;
	ASize	: Longint;
	L		: Byte;
	P		: PResourceItem;
begin
	S.Read (APos, SizeOf (Longint));
	S.Read (ASize, SizeOf (Longint));
	S.Read (L, 1);
	GetMem (P, L + (SizeOf (TResourceItem) - SizeOf (String) + 1));
	if PtrRec (P).Seg <> 0 then
		with P^ do
			begin
				Pos := APos;
				Size := ASize;
				Key [0] := Char (L);
				S.Read (Key [1], L);
			end;
	GetItem := P;
end;

function TResourceCollection.KeyOf (Item : Pointer) : Pointer; assembler;
asm
	MOV		AX, Item.Word [0]
	MOV		DX, Item.Word [2]
	ADD		AX, OFFSET TResourceItem.Key
end;

procedure TResourceCollection.PutItem (var S : TStream; Item : Pointer);
begin
	S.Write (PResourceItem (Item)^, Length (PResourceItem (Item)^.Key) + (SizeOf (TResourceItem) - SizeOf (String) + 1));
end;

{*********************************************************** TResourceFile **}
constructor TResourceFile.Init (AStream : PStream);
type

{$IFDEF NewExeFormat}
	TExeHeader = record
		eHdrSize	: Word;
		eMinAbove	: Word;
		eMaxAbove	: Word;
		eInitSS		: Word;
		eInitSP		: Word;
		eCheckSum	: Word;
		eInitPC		: Word;
		eInitCS		: Word;
		eRelocOfs	: Word;
		eOvlyNum	: Word;
		eRelocTab	: Word;
		eSpace		: Array [1..30] of Byte;
		eNewHeader	: Word;
 end;
{$ENDIF}

	THeader = record
		Signature	: Word;
		case Integer of
			0	: (
					LastCount	: Word;
					PageCount	: Word;
					ReloCount	: Word);
			1	: (
					InfoType	: Word;
					InfoSize	: Longint);
	end;

var
	Found,
	Stop	: Boolean;
	Header	: THeader;
{$IFDEF NewExeFormat}
 ExeHeader : TExeHeader;
{$ENDIF}

begin
{$IFNDEF Turbo6}
	inherited Init;
{$ELSE}
	TObject.Init;
{$ENDIF}
	Stream := AStream;
	BasePos := Stream^.GetPos;
	Found := False;
	repeat
		Stop := True;
		if BasePos <= Stream^.GetSize - SizeOf (THeader) then
			begin
				Stream^.Seek (BasePos);
				Stream^.Read (Header, SizeOf (THeader));
				case Header.Signature of
{$IFDEF NewExeFormat}
					$5A4D	:
						begin
							Stream^.Read (ExeHeader, SizeOf (TExeHeader));
							BasePos := ExeHeader.eNewHeader;
							Stop := False;
						end;
					$454E	:
						begin
							BasePos := Stream^.GetSize - 8;
							Stop := False;
						end;
					$4246	:
						begin
							Stop := False;
							case Header.Infotype of
								$5250	:{Found Resource}
									begin
										Found := True;
										Stop := True;
									end;
								$4C42	:{Found BackLink}
									Dec (BasePos, Header.InfoSize - 8);
								$4648	:{Found HelpFile}
									Dec (BasePos, SizeOf (THeader) * 2);
							else
								Stop := True;
							end;
						end;
					$424E	:{Found Debug Info}
						if Header.InfoType = $3230 then
							begin
								Dec (BasePos, Header.InfoSize);
								Stop := False;
							end;
{$ELSE}
					$5A4D	:
						begin
							Inc (BasePos, LongMul (Header.PageCount, 512) - (-Header.LastCount and 511));
							Stop := False;
						end;
					$4246	:
						if Header.InfoType = $5250 then
							Found := True
						else
							begin
								Inc (BasePos, Header.InfoSize + 8);
								Stop := False;
							end;
{$ENDIF}
				end;
			end;
	until Stop;
	if Found then
		begin
			Stream^.Seek (BasePos + SizeOf (Longint) * 2);
			Stream^.Read (IndexPos, SizeOf (Longint));
			Stream^.Seek (BasePos + IndexPos);
			Index.Load (Stream^);
		end
	else
		begin
			IndexPos := SizeOf (Longint) * 3;
			Index.Init (0, 8);
		end;
end;

destructor TResourceFile.Done;
begin
	Flush;
	Index.Done;
	DisposeObj (Stream);
{$IFNDEF Turbo6}
	inherited Done;
{$ELSE}
	TObject.Done;
{$ENDIF}
end;

function TResourceFile.Count : Integer;
begin
	Count := Index.Count;
end;

procedure TResourceFile.Delete (Key : String);
var
	I	: Integer;
begin
	if Index.Search (@Key, I) then
		begin
			Index.Free (Index.At (I));
			Modified := True;
		end;
end;

procedure TResourceFile.Flush;
var
	ResSize		: Longint;
	LinkSize	: Longint;
begin
	if Modified then
		begin
			Stream^.Seek (BasePos + IndexPos);
			Index.Store (Stream^);
			ResSize := Stream^.GetPos - BasePos;
			LinkSize := ResSize + SizeOf (Longint) * 2;
			With Stream^ do
				begin
					Write (RStreamBackLink, SizeOf (Longint));
					Write (LinkSize, SizeOf (Longint));
					Seek (BasePos);
					Write (RStreamMagic, SizeOf (Longint));
					Write (ResSize, SizeOf (Longint));
					Write (IndexPos, SizeOf (Longint));
					Flush;
				end;
			Modified := False;
	end;
end;

function TResourceFile.Get (Key : String) : PObject;
var
	I	: Integer;
begin
	if not Index.Search (@Key, I) then
		Get := NIL
	else
		begin
			Stream^.Seek (BasePos + PResourceItem (Index.At (I))^.Pos);
			Get := Stream^.Get;
		end;
end;

function TResourceFile.KeyAt (I : Integer) : String;
begin
	KeyAt := PResourceItem (Index.At (I))^.Key;
end;

procedure TResourceFile.Put (Item	: PObject; Key : String);
var
	I	: Integer;
	P	: PResourceItem;
begin
	if Index.Search (@Key, I) then
		P := Index.At (I)
	else
		begin
			GetMem (P, Length (Key) + (SizeOf (TResourceItem) - SizeOf (String) + 1));
			P^.Key := Key;
			Index.AtInsert (I, P);
		end;
	P^.Pos := IndexPos;
	Stream^.Seek (BasePos + IndexPos);
	Stream^.Put (Item);
	IndexPos := Stream^.GetPos - BasePos;
	P^.Size := IndexPos - P^.Pos;
	Modified := True;
end;

function TResourceFile.SwitchTo (AStream : PStream; Pack : Boolean) : PStream;
var
	NewBasePos	: Longint;

	procedure DoCopyResource (Item : PResourceItem); far;
	begin
		Stream^.Seek (BasePos + Item^.Pos);
		Item^.Pos := AStream^.GetPos - NewBasePos;
		AStream^.CopyFrom (Stream^, Item^.Size);
	end;

begin
	SwitchTo := Stream;
	NewBasePos := AStream^.GetPos;
	if Pack then
		begin
		AStream^.Seek (NewBasePos + SizeOf (Longint) * 2);
		Index.ForEach (@DoCopyResource);
		IndexPos := AStream^.GetPos - NewBasePos;
		end
	else
		begin
			Stream^.Seek (BasePos);
			AStream^.CopyFrom (Stream^, IndexPos);
		end;
	Stream := AStream;
	Modified := True;
	BasePos := NewBasePos;
end;

{************************************************************* TStringList **}
constructor TStringList.Load (var S : TStream);
var
	Size	: Word;
begin
	Stream := @S;
	S.Read (Size, SizeOf (Word));
	BasePos := S.GetPos;
	S.Seek (BasePos + Size);
	S.Read (IndexSize, SizeOf (Integer));
	Index := S.GetMem (Word (IndexSize) * SizeOf (TStrindexRec));
	S.Read (Index^, Word (IndexSize) * SizeOf (TStrindexRec));
end;

destructor TStringList.Done;
begin
	FreeMem (Index, Word (IndexSize) * SizeOf (TStrindexRec));
end;

function TStringList.Get (Key : Word) : String; assembler;
asm
	PUSH	DS
	LDS		SI, Self
	LES		DI, @Result
	CLD
	MOV		CX, DS:[SI].TStringList.IndexSize
	JCXZ	@2
	MOV		BX, Key
	LDS		SI, DS:[SI].TStringList.Index
@1: MOV		DX, BX
	LODSW
	SUB		DX, AX
	LODSW
	CMP		DX, AX
	LODSW
	JB		@3
	LOOP	@1
@2: POP		DS
	XOR		AL, AL
	STOSB
	JMP		@4
@3: POP		DS
	PUSH	ES
	PUSH	DI
	PUSH	AX
	PUSH	DX
	LES		DI, Self
	PUSH	ES
	PUSH	DI
	CALL	TStringList.ReadStr
@4:
end;

procedure TStringList.ReadStr (var S : String; Offset, Skip : Word);
begin
	Stream^.Seek (BasePos + Offset);
	Inc (Skip);
	repeat
		Stream^.Read (S [0], 1);
		Stream^.Read (S [1], Ord (S [0]));
		Dec (Skip);
	until Skip = 0;
end;

{*********************************************************** TStrListMaker **}
constructor TStrListMaker.Init (AStrSize, AIndexSize : Word);
begin
	TObject.Init;
	StrSize := AStrSize;
	IndexSize := AIndexSize;
	GetMem (Strings, AStrSize);
	GetMem (Index, Word (AIndexSize) * SizeOf (TStrindexRec));
end;

destructor TStrListMaker.Done;
begin
	FreeMem (Index, Word (IndexSize) * SizeOf (TStrindexRec));
	FreeMem (Strings, StrSize);
end;

procedure TStrListMaker.CloseCurrent;
begin
	if Cur.Count <> 0 then
		begin
			Index^ [IndexPos] := Cur;
			Inc (IndexPos);
			Cur.Count := 0;
		end;
end;

procedure TStrListMaker.Put (Key : Word; S : String);
begin
	if (Cur.Count = 16) or (Key <> Cur.Key + Cur.Count) then CloseCurrent;
	if Cur.Count = 0 then
		begin
			Cur.Key := Key;
			Cur.Offset := StrPos;
		end;
	Inc (Cur.Count);
	Move (S, Strings^ [StrPos], Length (S) + 1);
	Inc (StrPos, Length (S) + 1);
end;

procedure TStrListMaker.Store (var S : TStream);
begin
	CloseCurrent;
	S.Write (StrPos, SizeOf (Word));
	S.Write (Strings^, StrPos);
	S.Write (IndexPos, SizeOf (Word));
	S.Write (Index^, Word (IndexPos) * SizeOf (TStrindexRec));
end;

{******************************************************************* TRect **}
procedure CheckEmpty; near; assembler;
asm
	MOV		AX, ES:[DI].TRect.A.X
	CMP		AX, ES:[DI].TRect.B.X
	JGE		@1
	MOV		AX, ES:[DI].TRect.A.Y
	CMP		AX, ES:[DI].TRect.B.Y
	JL		@2
@1: CLD
	XOR		AX, AX
	STOSW
	STOSW
	STOSW
	STOSW
@2:
end;

procedure TRect.Assign (XA, YA, XB, YB : Integer); assembler;
asm
	LES		DI, Self
	CLD
	MOV		AX, XA
	STOSW
	MOV		AX, YA
	STOSW
	MOV		AX, XB
	STOSW
	MOV		AX, YB
	STOSW
end;

procedure TRect.Copy (R : TRect); assembler;
asm
	PUSH	DS
	LDS		SI, R
	LES		DI, Self
	CLD
	MOV		CX, 4
	REP		MOVSW
	POP		DS
end;

procedure TRect.Move (ADX, ADY : Integer); assembler;
asm
	LES		DI, Self
	MOV		AX, ADX
	ADD		ES:[DI].TRect.A.X, AX
	ADD		ES:[DI].TRect.B.X, AX
	MOV		AX, ADY
	ADD		ES:[DI].TRect.A.Y, AX
	ADD		ES:[DI].TRect.B.Y, AX
end;

procedure TRect.Grow (ADX, ADY : Integer); assembler;
asm
	LES		DI, Self
	MOV		AX, ADX
	SUB		ES:[DI].TRect.A.X, AX
	ADD		ES:[DI].TRect.B.X, AX
	MOV		AX, ADY
	SUB		ES:[DI].TRect.A.Y, AX
	ADD		ES:[DI].TRect.B.Y, AX
	CALL	CheckEmpty
end;

procedure TRect.Intersect (R : TRect); assembler;
asm
	PUSH	DS
	LDS		SI, R
	LES		DI, Self
	CLD
	LODSW
	SCASW
	JLE		@1
	DEC		DI
	DEC		DI
	STOSW
@1: LODSW
	SCASW
	JLE		@2
	DEC		DI
	DEC		DI
	STOSW
@2: LODSW
	SCASW
	JGE		@3
	DEC		DI
	DEC		DI
	STOSW
@3: LODSW
	SCASW
	JGE		@4
	DEC		DI
	DEC		DI
	STOSW
@4: POP		DS
	SUB		DI, 8
	CALL	CheckEmpty
end;

procedure TRect.Union (R : TRect); assembler;
asm
	PUSH	DS
	LDS		SI, R
	LES		DI, Self
	CLD
	LODSW
	SCASW
	JGE		@1
	DEC		DI
	DEC		DI
	STOSW
@1: LODSW
	SCASW
	JGE		@2
	DEC		DI
	DEC		DI
	STOSW
@2: LODSW
	SCASW
	JLE		@3
	DEC		DI
	DEC		DI
	STOSW
@3: LODSW
	SCASW
	JLE		@4
	DEC		DI
	DEC		DI
	STOSW
@4: POP		DS
end;

function TRect.Contains (P : TPoint) : Boolean; assembler;
asm
	LES		DI, Self
	XOR		AX, AX
	MOV		DX, P.X
	CMP		DX, ES:[DI].TRect.A.X
	JL		@1
	CMP		DX, ES:[DI].TRect.B.X
	JGE		@1
	MOV		DX, P.Y
	CMP		DX, ES:[DI].TRect.A.Y
	JL		@1
	CMP		DX, ES:[DI].TRect.B.Y
	JGE		@1
	INC		AX
@1:
end;

function TRect.Equals (R : TRect) : Boolean; assembler;
asm
	PUSH	DS
	XOR		AX, AX
	LDS		SI, R
	LES		DI, Self
	MOV		CX, 4
	CLD
	REP		CMPSW
	JNE		@1
	INC		AX
@1: POP		DS
end;

function TRect.Empty : Boolean; assembler;
asm
	LES		DI, Self
	MOV		AL, 1
	MOV		DX, ES:[DI].TRect.A.X
	CMP		DX, ES:[DI].TRect.B.X
	JGE		@1
	MOV		DX, ES:[DI].TRect.A.Y
	CMP		DX, ES:[DI].TRect.B.Y
	JGE		@1
	DEC		AX
@1:
end;
{$ENDIF}

{**************************************** Dynamic String handling routines **}
function NewStr (S : String) : PString; assembler;
	asm
		LES		DI, S
		PUSH	ES
		PUSH	DI
		CALL	GenStr
	end;

function GenStr (S : PString) : PString;
label
	No;
var
	P : PString;
begin
	asm
		CMP		WORD PTR S + 2, SEG @DATA
		JBE		No
	end;
		GetMem (P, Length (S^) + 1);
		if PtrRec (P).Seg > 0 then P^ := S^;
		GenStr := P;
		Exit;
	No:
		GenStr := S;
end;

function DupStr (S : PString) : PString;
var
	P : PString;
begin
	GetMem (P, Length (S^) + 1);
	if PtrRec (P).Seg > 0 then P^ := S^;
	DupStr := P;
end;

procedure DisposeStr (P : PString);
label
	No;
begin
	asm
		MOV		CX, WORD PTR P + 2
		CMP		CX, SEG @DATA
		JBE		No
		MOV		AX, SS
		CMP		AX, CX
		JE		No
	end;
		FreeMem (P, Length (P^) + 1);
	No:
end;

procedure ReMakeStr (var P : PString; var S : String);
begin
	if (PtrRec (P).Seg <> 0) and (Length (P^) = Length (S)) then
		P^ := S
	else
		begin
			DisposeStr (P);
			P := GenStr (@S);
		end;
end;

function GetStr (P : PString) : PString; assembler;
const
	Empty	: Byte = 0;
asm
	LES		AX, P
	MOV		DX, ES
	TEST	DX, DX
	JNE		@1
	MOV		AX, OFFSET Empty
	MOV		DX, SEG @Data
@1:
end;

{****************************************** Objects registration procedure **}
procedure RegisterObjects;
begin
	RegisterType (RCollection);
	RegisterType (RStringCollection);
	Nul.Init;
end;

end.
