{1/2 Copyright by Leonid Youriev 1992, 93}
{$I VERSION}
{$D+}

unit Views;

interface

uses	Objects, Drivers, Styles;

{$I VERSION}

const

{ TView State masks }
	sfVisible			= $0001;
	sfCursorVis			= $0002;
	sfCursorIns			= $0004;
	sfShadow			= $0008;
	sfActive			= $0010;
	sfSelected			= $0020;
	sfFocused			= $0040;
	sfDragging			= $0080;
	sfDisabled			= $0100;
	sfModal				= $0200;
	sfDefault			= $0400;
	sfExposed			= $0800;

	sfRunning			= $1000;
	sfDestroyed			= $2000;
	sfDrawing			= $4000;

{ TView Option masks }
	ofFramed			= $0001;
	ofDoubleFramed		= $0002;
	ofBoldFramed		= $0003;
	ofShadowFrame		= $0004;
	ofISFramed			= $0007;

	ofSelectable		= $0008;
	ofTopSelect			= $0010;
	ofFirstClick		= $0020;
	ofPreProcess		= $0040;
	ofPostProcess		= $0080;
	ofBuffered			= $0100;
	ofTileable			= $0200;
	ofCenterX			= $0400;
	ofCenterY			= $0800;
	ofCentered			= $0C00;
	ofValidate			= $1000;
	ofEditable			= $2000;

{ TView GrowMode masks }
	gfGrowLoX			= $01;
	gfGrowLoY			= $02;
	gfGrowHiX			= $04;
	gfGrowHiY			= $08;
	gfGrowAll			= $0F;
	gfGrowRel			= $10;

{ TView DragMode masks }
	dmDragMove			= $01;
	dmDragGrow			= $02;
	dmLimitLoX			= $10;
	dmLimitLoY			= $20;
	dmLimitHiX			= $40;
	dmLimitHiY			= $80;
	dmLimitAll			= $F0;

{ TView Help context codes }
	hcNoContext			= 0;
	hcDragging			= 1;

{ TScrollBar part codes }
	sbLeftArrow			= 0;
	sbRightArrow		= 1;
	sbPageLeft			= 2;
	sbPageRight			= 3;
	sbUpArrow			= 4;
	sbDownArrow			= 5;
	sbPageUp			= 6;
	sbPageDown			= 7;
	sbIndicator			= 8;

{ TScrollBar flags }
	lfHorizontal		= $01;
	lfTracking			= $02;
	lfPtrDraw			= $04;
	lfBoxes				= $08;
	lfStepDraw			= $10;
	lfPosDraw			= $20;
	lfSmallItem			= $40;
	lfMSPtr				= $80;
	lfDefault			= lfTracking or lfPtrDraw or lfStepDraw or lfSmallItem or lfMSPtr or lfPosDraw;

{ TScrollBar options for TWindow.StandardScrollBar }
	sbHorizontal		= $0000;
	sbVertical			= $0100;
	sbHandleKeyboard	= $0200;

{ TButton flags }
	bfNormal			= $0000;
	bfDefault			= $0001;
	bfLeftJust			= $0002;
	bfBroadcast			= $0004;
	bfGrabFocus			= $0008;
	bfMulti				= $0100;
	bfHistory			= $0200;
	bfRightJust			= $0400;
	bfLoJust			= $0800;
	bfHiJust			= $1000;
	bfNoPoints			= $2000;

	ButtonsSleep		: Word = 3;

	cmGrabDefault		= 61;
	cmReleaseDefault	= 62;

{ TWindow Flags masks }
	wfMove				= $0001;
	wfGrow				= $0002;
	wfClose				= $0004;
	wfZoom				= $0008;
	wfNoTitle			= $0010;
	wfScrolled			= $0020;

	wfWinTitle			= $0100;
	wfWinFrame			= $0200;
	wfBoldFrame			= $0400;
	wfSingleFrame		= $0800;
	wfNoFrame			= $1000;

{ TWindow number constants }
	wnNoNumber			= -1;

{ TWindow palette entries }
	wpBlueWindow		= 0;
	wpCyanWindow		= 1;
	wpGrayWindow		= 2;

{ Standard command codes }
	cmValid				= 0;
	cmQuit				= 1;
	cmError				= 2;
	cmMenu				= 3;
	cmClose				= 4;
	cmZoom				= 5;
	cmResize			= 6;
	cmNext				= 7;
	cmPrev				= 8;
	cmHelp				= 9;
	cmHide				= 15;
	cmShow				= 16;

{ Application command codes }
	cmReplace			= 17;
	cmSave				= 18;
	cmSaveAs			= 19;
	cmCut				= 20;
	cmCopy				= 21;
	cmPaste				= 22;
	cmUndo				= 23;
	cmClear				= 24;
	cmAgain				= 25;
	cmNew				= 26;
	cmDel				= 27;
	cmEdit				= 28;
	cmFind				= 29;
	cmClip				= 30;
	cmOpen				= 31;
	cmSaveAll			= 34;
	cmChangeDir			= 35;
	cmDosShell			= 36;
	cmCloseAll			= 37;

	cmTile				= 39;
	cmCascade			= 40;

{ TDialog standard commands }
	cmOK				= 10;
	cmCancel			= 11;
	cmYes				= 12;
	cmNo				= 13;
	cmDefault			= 14;

	cOKStr				: String [7] = '&⮢';
	cCancelStr			: String [5] = '';
	cYesStr				: String [3] = '&';
	cNoStr				: String [4] = '&';
	cDefStr				: String [4] = '&';
	cHelpStr			: String [7] = '&';
	cNewStr				: String [6] = '&';
	cDelStr				: String [8] = '&';
	cEdtStr				: String [9] = '&';

{ Standard messages }
	cmHelpCtxChanged	= 49;
	cmReceivedFocus		= 50;
	cmReleasedFocus		= 51;
	cmCommandSetChanged	= 52;

{ TScrollBar messages }
	cmScrollBarChanged	= 53;
	cmScrollBarClicked	= 54;

{ TWindow select messages }
	cmSelectWindowNum	= 55;

{ TListViewer messages }
	cmListItemSelected	= 56;

{ Dialog broadcast commands }
	cmRecordHistory		= 60;

{ Dark step message}
	cmDarkStep			= 70;

{ Color palettes }
	CGrayWindow			= #16#17#18#19#20#21#22#23#24#25#26#27#28#29#30#31#32#33#34#35#36#37#38#39#40#41#42#43#44#45#46#47;
	CBlueWindow			= #64#65#66#67#68#69#70#71#72#73#74#75#76#77#78#79#80#81#82#83#84#85#86#87#88#89#90#91#92#93#94#95;
	CCyanWindow			= #96#97#98#99#100#101#102#103#104#105#106#107#108#109#110#111#112#113#114#115#116#117#118#119#120
						+ #121#122#123#124#125#126#127;

	CFrame				= #1#1#2#2#3;
	CScrollBar			= #4#5#4;
	CScroller			= #7#8;
	CListViewer			= #26#26#27#28#29#17;
	CButton				= #10#11#12#13#14#15#6;

{ TDrawBuffer maximum view width }
	MaxViewWidth		= 132;
	PendingSize			= 32;

type

{ Command sets }
	PCommandSet			= ^TCommandSet;
	TCommandSet			= Set of Byte;

{ TDrawBuffer, buffer used by draw methods }
	TDrawBuffer			= array [0..MaxViewWidth - 1] of Word;
	TPending			= array [0..PendingSize - 1] of TEvent;
	PPending			= ^TPending;

{ TView Object Pointer }
	PView				= ^TView;

{ TGroup Object Pointer }
	PGroup				= ^TGroup;

{ TView Object }
	TView = Object (TObject)
		Owner		: PGroup;
		Next		: PView;
		Origin		: TPoint;
		Size		: TPoint;
		Cursor		: TPoint;
		GrowMode	: Byte;
		DragMode	: Byte;
		HelpCtx		: Word;
		State		: Word;
		Options		: Word;
		EventMask	: Word;
		constructor	Init (var Bounds : TRect);
		constructor	Load (var S : TStream);
		destructor	Done; virtual;
		procedure	BlockCursor;
		procedure	CalcBounds (var Bounds : TRect; Delta : TPoint); virtual;
		procedure	ChangeBounds (var Bounds : TRect); virtual;
		procedure	ClearEvent (var Event : TEvent);
		function	CommandEnabled (Command : Word) : Boolean;
		function	DataSize : Word; virtual;
		procedure	DisableCommands (Commands : TCommandSet);
		procedure	DragView (Event : TEvent; Mode : Byte; var Limits : TRect; MinSize, MaxSize : TPoint);
		procedure	Draw; virtual;
		procedure	DrawView;
		procedure	EnableCommands (Commands : TCommandSet);
		procedure	EndModal (Command : Word); virtual;
		function	SendCommand (Cmd : Word) : Boolean;
		function	SendBroadCast (Cmd : Word) : Pointer;
		function	EventAvail (Mask : Word) : Boolean;
		function	Execute : Word; virtual;
		function	Exposed : Boolean;
		function	Focus : Boolean;
		procedure	GetBounds (var Bounds : TRect);
		procedure	GetClipRect (var Clip : TRect);
		function	GetColor (Color : Word) : Word;
		procedure	GetCommands (var Commands : TCommandSet);
		procedure	GetData (var Rec); virtual;
		procedure	GetEvent (var Event : TEvent); virtual;
		procedure	GetExtent (var Extent : TRect);
		function	GetHelpCtx : Word; virtual;
		procedure	GetPeerViewPtr (var S : TStream; var P);
		function	GetState (AState : Word) : Boolean;
		procedure	GrowTo (X, Y : Integer);
		procedure	HandleEvent (var Event : TEvent); virtual;
		procedure	Hide;
		procedure	HideCursor;
		procedure	KeyEvent (var Event : TEvent);
		procedure	Locate (var Bounds : TRect);
		procedure	MakeFirst;
		procedure	MakeGlobal (Source : TPoint; var Dest : TPoint);
		procedure	MakeLocal (Source : TPoint; var Dest : TPoint);
		function	MouseEvent (var Event : TEvent; Mask : Word) : Boolean;
		function	MouseInView (Mouse : TPoint) : Boolean;
		procedure	MoveTo (X, Y : Integer);
		function	NextView : PView;
		procedure	NormalCursor;
		function	Prev : PView;
		function	PrevView : PView;
		procedure	PutEvent (var Event : TEvent); virtual;
		procedure	PutInFrontOf (Target : PView);
		procedure	PutPeerViewPtr (var S : TStream; P : PView);
		procedure	Select;
		procedure	SetBounds (var Bounds : TRect);
		procedure	SetCommands (Commands : TCommandSet);
		procedure	SetCmdState (Commands : TCommandSet; Enable : Boolean);
		procedure	SetCursor (X, Y : Integer);
		procedure	SetData (var Rec); virtual;
		procedure	SetState (AState : Word; Enable : Boolean); virtual;
		procedure	Show;
		procedure	ShowCursor;
		procedure	SizeLimits (var Min, Max : TPoint); virtual;
		procedure	Store (var S : TStream);
		function	TopView : PView;
		function	Valid (Command : Word) : Boolean; virtual;
		procedure	WriteBuf (X, Y, W, H : Integer; var Buf);
		procedure	WriteChar (X, Y : Integer; C : Char; Color : Byte; Count : Integer);
		procedure	WriteLine (X, Y, W, H : Integer; var Buf);
		procedure	WriteStr (X, Y : Integer; Str : String; Color : Byte);
		procedure	Awaken; virtual;
		procedure	Destroy;
	private
		procedure	DrawCursor;
		procedure	DrawHide (LastView : PView);
		procedure	DrawShow (LastView : PView);
		procedure	DrawUnderRect (var R : TRect; LastView : PView);
		procedure	DrawUnderView (DoShadow : Boolean; LastView : PView);
		procedure	ResetCursor; virtual;
	end;

	PPure = ^TPure;
	TPure = Object (TView)
		constructor	Init (var R : TRect);
		procedure	Draw; virtual;
	end;

{ TFrame types }
	TTitleStr = String [80];

{ TFrame Object }
	{ Palette layout }
	{ 1 = Passive frame }
	{ 2 = Passive title }
	{ 3 = Active frame }
	{ 4 = Active title }
	{ 5 = Icons }

	PFrame = ^TFrame;
	TFrame = Object (TView)
		constructor	Init (var Bounds : TRect);
		procedure	Draw; virtual;
		procedure	HandleEvent (var Event : TEvent); virtual;
		procedure	SetState (AState : Word; Enable : Boolean); virtual;
	private
		Flags		: Byte;
		procedure	FrameLine (var FrameBuf; Y, N : Integer; Color : Word);
	end;

{ ScrollBar characters }
	TScrollChars	= array [0..4] of Char;

{ TScrollBar Object }
	{ Palette layout }
	{ 1 = Page areas }
	{ 2 = Arrows }
	{ 3 = Indicator }

	PScrollBar = ^TScrollBar;
	TScrollBar = Object (TView)
		Value		: Integer;
		Top			: Integer;
		Min			: Integer;
		Max			: Integer;
		PgStep		: Integer;
		ArStep		: Integer;
		Flags		: Byte;
		constructor	Init (var Bounds : TRect; AFlags : Byte);
		constructor	Load (var S : TStream);
		procedure	Draw; virtual;
		procedure	HandleEvent (var Event : TEvent); virtual;
		procedure	ScrollDraw; virtual;
		function	ScrollStep (Part : Integer) : Integer; virtual;
		function	SetParams (AValue, ATop, AMin, AMax, APgStep, AArStep : Integer) : Integer;
		function	SetRange (AMin, AMax : Integer) : Integer;
		function	SetStep (APgStep, AArStep : Integer) : Integer;
		function	SetValue (AValue : Integer) : Integer;
		function	SetLocate (AValue, ATop : Integer) : Integer;
		procedure	Store (var S : TStream);
		function	GetPos (AValue : Integer) : Integer;
		function	GetValue (APos : Integer) : Integer;
		procedure	DrawPos (APos : Integer); virtual;
	end;

	PProgresBar = ^TProgresBar;
	TProgresBar = Object (TScrollBar)
		constructor	Init (var R : TRect);
		procedure	Draw; virtual;
	end;

{ TScroller Object }
	{ Palette layout }
	{ 1 = Normal text }
	{ 2 = Selected text }

	PScroller = ^TScroller;
	TScroller = Object (TView)
		HScrollBar	: PScrollBar;
		VScrollBar	: PScrollBar;
		Delta		: TPoint;
		Limit		: TPoint;
		constructor	Init (var Bounds : TRect; AHScrollBar, AVScrollBar : PScrollBar);
		constructor	Load (var S : TStream);
		procedure	ChangeBounds (var Bounds : TRect); virtual;
		procedure	HandleEvent (var Event : TEvent); virtual;
		procedure	ScrollDraw; virtual;
		procedure	ScrollTo (X, Y : Integer);
		procedure	SetLimit (X, Y : Integer);
		procedure	SetState (AState : Word; Enable : Boolean); virtual;
		procedure	Store (var S : TStream);
	private
		DrawLock	: Byte;
		DrawFlag	: Boolean;
		procedure	CheckDraw;
	end;

{ TListViewer }
	{ Palette layout }
	{ 1 = Active }
	{ 2 = Inactive }
	{ 3 = Focused }
	{ 4 = Selected }
	{ 5 = Divider }

	PListViewer = ^TListViewer;
	TListViewer = Object (TView)
		HScrollBar	: PScrollBar;
		VScrollBar	: PScrollBar;
		NumCols		: Integer;
		TopItem		: Integer;
		Focused		: Integer;
		Range		: Integer;
		Marker		: Integer;
		constructor	Init (var Bounds : TRect; ANumCols : Word; AHScrollBar, AVScrollBar : PScrollBar);
		constructor	Load (var S : TStream);
		procedure	ChangeBounds (var Bounds : TRect); virtual;
		procedure	Draw; virtual;
		procedure	FocusItem (Item : Integer); virtual;
		function	GetText (Item : Integer; MaxLen : Integer) : String; virtual;
		function	IsSelected (Item : Integer) : Boolean; virtual;
		procedure	HandleEvent (var Event : TEvent); virtual;
		procedure	SelectItem (Item : Integer); virtual;
		procedure	SetRange (ARange : Integer);
		procedure	SetState (AState : Word; Enable : Boolean); virtual;
		procedure	Store (var S : TStream);
	private
		procedure	FocusItemNum (Item : Integer); virtual;
	end;

{ Video buffer }
	PVideoBuf		= ^TVideoBuf;
	TVideoBuf		= array [0..3999] of Word;

{ Selection modes }
	SelectMode		= (NormalSelect, EnterSelect, LeaveSelect);

{ TGroup Object }

	TGroup = Object (TView)
		Last		: PView;
		Current		: PView;
		Phase		: (phFocused, phPreProcess, phPostProcess);
		Buffer		: PVideoBuf;
		EndState	: Word;
		Palette		: Byte;
		procedure	GetEvent (var Event : TEvent); virtual;
		procedure	PutEvent (var Event : TEvent); virtual;
		procedure	PutSelfEvent (var Event : TEvent);
		procedure	ClearPending;
		function	SelfEventAvail : Boolean;
		constructor	Init (var Bounds : TRect);
		procedure	Awaken; virtual;
		constructor	Load (var S : TStream);
		destructor	Done; virtual;
		procedure	ChangeBounds (var Bounds : TRect); virtual;
		function	DataSize : Word; virtual;
		procedure	Delete (P : PView); virtual;
		procedure	Draw; virtual;
		procedure	EndModal (Command : Word); virtual;
		procedure	EventError (var Event : TEvent); virtual;
		function	ExecView (P : PView) : Word;
		function	Execute : Word; virtual;
		function	First : PView;
		function	FirstThat (P : Pointer) : PView;
		procedure	ForEach (P : Pointer);
		procedure	GetData (var Rec); virtual;
		function	GetHelpCtx : Word; virtual;
		procedure	GetSubViewPtr (var S : TStream; var P);
		procedure	HandleEvent (var Event : TEvent); virtual;
		procedure	Insert (P : PView);
		procedure	InsertBefore (P, Target : PView); virtual;
		procedure	Lock;
		procedure	PutSubViewPtr (var S : TStream; P : PView);
		procedure	Redraw;
		function	FocusNext (Forwards : Boolean) : Boolean;
		procedure	SelectNext (Forwards : Boolean);
		procedure	SetData (var Rec); virtual;
		procedure	SetState (AState : Word; Enable : Boolean); virtual;
		procedure	Store (var S : TStream);
		procedure	Unlock;
		function	Valid (Command : Word) : Boolean; virtual;
		function	Search (X, Y : Integer) : PView;
		procedure	InsertSoftGrid;
{$IFDEF UseDark}
		function	Fork (StackSize, StackFrames : Word) : Boolean;
		procedure	ForkView (P : PView);
		procedure	CloseFork;
{$ENDIF}
	private
		PendHead	: Integer;
		PendTail	: Integer;
		Pending		: PPending;
		Clip		: TRect;
		LockFlag	: Byte;
{$IFDEF UseDark}
		TID			: Word;
{$ENDIF}
		function	At (Index : Integer) : PView;
		procedure	DrawSubViews (P, Bottom : PView);
		function	FirstMatch (AState : Word; AOptions : Word) : PView;
		function	FindNext (Forwards : Boolean) : PView;
		procedure	FreeBuffer;
		procedure	GetBuffer;
		function	IndexOf (P : PView) : Integer;
		procedure	InsertView (P, Target : PView);
		procedure	RemoveView (P : PView);
		procedure	ResetCurrent;
		procedure	ResetCursor; virtual;
		procedure	SetCurrent (P : PView; Mode : SelectMode);
	end;

{ TWindow Object }
	{ Palette layout }
	{ 1 = Frame passive }
	{ 2 = Frame active }
	{ 3 = Frame icon }
	{ 4 = ScrollBar page area }
	{ 5 = ScrollBar controls }
	{ 6 = Scroller normal text }
	{ 7 = Scroller selected text }
	{ 8 = Reserved }

	PWindow = ^TWindow;
	TWindow = Object (TGroup)
		Flags		: Word;
		ZoomRect	: TRect;
		Number		: Integer;
		Title		: PString;
		Frame		: PFrame;
		constructor	Init (var Bounds : TRect; ATitle : TTitleStr; ANumber : Integer);
		constructor	Load (var S : TStream);
		destructor	Done; virtual;
		procedure	Close; virtual;
		function	GetTitle (MaxSize : Integer) : TTitleStr; virtual;
		procedure	HandleEvent (var Event : TEvent); virtual;
		procedure	InitFrame; virtual;
		procedure	SetState (AState : Word; Enable : Boolean); virtual;
		procedure	SizeLimits (var Min, Max : TPoint); virtual;
		function	StandardScrollBar (AOptions : Word) : PScrollBar;
		procedure	Store (var S : TStream);
		procedure	Zoom; virtual;
	end;

{ TButton Object }

{ Palette layout }
	{ 1 = Normal text }
	{ 2 = Default text }
	{ 3 = Selected text }
	{ 4 = Disabled text }
	{ 5 = Normal shortcut }
	{ 6 = Default shortcut }
	{ 7 = Selected shortcut }
	{ 8 = Shadow }

	PButton = ^TButton;
	TButton = Object (TView)
		Title		: PString;
		Command		: Word;
		Flags		: Word;
		AmDefault	: Boolean;
		DownIs		: Boolean;
		constructor	Init (var Bounds : TRect; ATitle : TTitleStr; ACommand : Word; AFlags : Word);
		constructor	Load (var S : TStream);
		destructor	Done; virtual;
		procedure	Draw; virtual;
		procedure	DrawState (Down : Boolean);
		procedure	HandleEvent (var Event : TEvent); virtual;
		procedure	MakeDefault (Enable : Boolean);
		procedure	Press; virtual;
		procedure	SetState (AState : Word; Enable : Boolean); virtual;
		procedure	Store (var S : TStream);
	end;

function Message (Receiver : PView; AWhat, ACommand : Word; AInfoPtr : Pointer) : Pointer;
procedure RegisterViews;

const

{ Event masks }
	PositionalEvents	: Word = evMouse;
	FocusedEvents		: Word = evKeyboard + evCommand;

{ Minimum window size }
	MinWinSize			: TPoint = (X : 24; Y : 6);

{ Shadow definitions }
	ShadowSize			: TPoint = (X : 2; Y : 1);
	ShadowAttr			: Byte = $08;

{ Stream Registration Records }
	RView		: TStreamRec = (
		ObjType	: 1;
		VmtLink	: Ofs (TypeOf (TView)^);
		Load	: @TView.Load;
		Store	: @TView.Store);

	RFrame		: TStreamRec = (
		ObjType	: 2;
		VmtLink : Ofs (TypeOf (TFrame)^);
		Load	: @TFrame.Load;
		Store	: @TFrame.Store);

	RScrollBar	: TStreamRec = (
		ObjType	: 3;
		VmtLink	: Ofs (TypeOf (TScrollBar)^);
		Load	: @TScrollBar.Load;
		Store	: @TScrollBar.Store);

	RScroller	: TStreamRec = (
		ObjType	: 4;
		VmtLink	: Ofs (TypeOf (TScroller)^);
		Load	: @TScroller.Load;
		Store	: @TScroller.Store);

	RListViewer	: TStreamRec = (
		ObjType	: 5;
		VmtLink	: Ofs (TypeOf (TListViewer)^);
		Load	: @TListViewer.Load;
		Store	: @TLIstViewer.Store);

	RGroup		: TStreamRec = (
		ObjType	: 6;
		VmtLink	: Ofs (TypeOf (TGroup)^);
		Load	: @TGroup.Load;
		Store	: @TGroup.Store);

	RWindow		: TStreamRec = (
		ObjType	: 7;
		VmtLink : Ofs (TypeOf (TWindow)^);
		Load	: @TWindow.Load;
		Store	: @TWindow.Store);

	RProgresBar : TStreamRec = (
		ObjType : 201;
		VmtLink	: Ofs (TypeOf (TProgresBar)^);
		Load	: @TScrollBar.Load;
		Store	: @TScrollBar.Store);

	RPure		: TStreamRec = (
		ObjType	: 205;
		VmtLink	: Ofs (TypeOf (TPure)^);
		Load	: @TPure.Load;
		Store	: @TPure.Store);

{ True if the command set has changed since being set to false }
	CommandSetChanged	: Boolean = False;

implementation
{$IFDEF UseDark}
uses	Resident, Memory, CharLog, Sysvars, Quick, Grid, Dark;
{$ELSE}
uses	Resident, Memory, CharLog, Sysvars, Quick, Grid;
{$ENDIF}

type
	PFixupList			= ^TFixupList;
	TFixupList			= array [1..4096] of Pointer;

const
	OwnerGroup			: PGroup = NIL;
	FixupList			: PFixupList = NIL;
	TheTopView			: PView = NIL;

const

	ffCloseClicked		= $40;
	ffZoomClicked		= $80;

	CurCommandSet		: TCommandSet = [0..255] - [cmZoom, cmClose, cmResize, cmNext, cmPrev];

{ Convert color into attribute									}
{ In	AL = Color												}
{ Out	AL = Attribute											}

procedure MapColor; near; assembler;
const
	Self	= 6;
asm
	LES		DI, [BP].Self
@1:	LES		DI, ES:[DI].TView.Owner
	MOV		CX, ES
	JCXZ	@2
	ADD		AL, ES:[DI].TGroup.Palette
	JMP		@1
@2:	XOR		BX, BX
	MOV		BL, AL
	MOV		AX, WORD PTR AppPalette [BX]
end;

{ Convert color pair into attribute pair					}
{ In	AX = Color pair										}
{ Out	AX = Attribute pair									}

procedure MapCPair; near; assembler;
asm
	OR		AH, AH
	JE		@1
	PUSH	AX
	MOV		AL, AH
	CALL	MapColor
	POP		CX
	XCHG	AL, CL
	PUSH	CX
	CALL	MapColor
	POP		CX
	MOV		AH, CL
	JMP		@2
@1:	CALL	MapColor
@2:
end;

{ Write to view												}
{ In	AX	= Y coordinate									}
{		BX	= X coordinate									}
{		CX	= Count											}
{		ES :DI = Buffer Pointer								}

var
	_SP, _SS : Word;

procedure WriteView; near; assembler;
const
	Self	= 6;
	Target	= -4;
	Buffer	= -8;
	BufOfs	= -10;
asm
	MOV		[BP].BufOfs, BX
	MOV		[BP].Buffer [0], DI
	MOV		[BP].Buffer [2], ES
	ADD		CX, BX
	XOR		DX, DX
	LES		DI, [BP].Self
	OR		AX, AX
	JL		@3
	CMP		AX, ES:[DI].TView.Size.Y
	JGE		@3
	OR		BX, BX
	JGE		@1
	XOR		BX, BX
@1:	CMP		CX, ES:[DI].TView.Size.X
	JLE		@2
	MOV		CX, ES:[DI].TView.Size.X
@2:	CMP		BX, CX
	JL		@10
@3:	RET

@10:TEST	ES:[DI].TView.State, sfVisible
	JE		@3
	CMP		ES:[DI].TView.Owner.Word [2], 0
	JE		@3
	MOV		[BP].Target [0], DI
	MOV		[BP].Target [2], ES
	ADD		AX, ES:[DI].TView.Origin.Y
	MOV		SI, ES:[DI].TView.Origin.X
	ADD		BX, SI
	ADD		CX, SI
	ADD		[BP].BufOfs, SI
	LES		DI, ES:[DI].TView.Owner
	CMP		AX, ES:[DI].TGroup.Clip.A.Y
	JL		@3
	CMP		AX, ES:[DI].TGroup.Clip.B.Y
	JGE		@3
	CMP		BX, ES:[DI].TGroup.Clip.A.X
	JGE		@11
	MOV		BX, ES:[DI].TGroup.Clip.A.X
@11:CMP		CX, ES:[DI].TGroup.Clip.B.X
	JLE		@12
	MOV		CX, ES:[DI].TGroup.Clip.B.X
@12:CMP		BX, CX
	JGE		@3
	LES		DI, ES:[DI].TGroup.Last
@20:LES		DI, ES:[DI].TView.Next
	CMP		DI, [BP].Target [0]
	JNE		@21
	MOV		SI, ES
	CMP		SI, [BP].Target [2]
	JNE		@21
	JMP		@40
@21:TEST	ES:[DI].TView.State, sfVisible
	JE		@20
	MOV		SI, ES:[DI].TView.Origin.Y
	CMP		AX, SI
	JL		@20
	ADD		SI, ES:[DI].TView.Size.Y
	CMP		AX, SI
	JL		@23
	TEST	ES:[DI].TView.State, sfShadow
	JE		@20
	ADD		SI, ShadowSize.Y
	CMP		AX, SI
	JGE		@20
	MOV		SI, ES:[DI].TView.Origin.X
	ADD		SI, ShadowSize.X
	CMP		BX, SI
	JGE		@22
	CMP		CX, SI
	JLE		@20
	CALL	@30
@22:ADD		SI, ES:[DI].TView.Size.X
	JMP		@26
@23:MOV		SI, ES:[DI].TView.Origin.X
	CMP		BX, SI
	JGE		@24
	CMP		CX, SI
	JLE		@20
	CALL	@30
@24:ADD		SI, ES:[DI].TView.Size.X
	CMP		BX, SI
	JGE		@25
	CMP		CX, SI
	JLE		@31
	MOV		BX, SI
@25:TEST	ES:[DI].TView.State, sfShadow
	JE		@20
	PUSH	SI
	MOV		SI, ES:[DI].TView.Origin.Y
	ADD		SI, ShadowSize.Y
	CMP		AX, SI
	POP		SI
	JL		@27
	ADD		SI, ShadowSize.X
@26:CMP		BX, SI
	JGE		@27
	INC		DX
	CMP		CX, SI
	JLE		@27
	CALL	@30
	DEC		DX
@27:JMP		@20
@30:PUSH	[BP].Target.Word [2]
	PUSH	[BP].Target.Word [0]
	PUSH	[BP].BufOfs.Word [0]
	PUSH	ES
	PUSH	DI
	PUSH	SI
	PUSH	DX
	PUSH	CX
	PUSH	AX
	MOV		CX, SI
	CALL	@20
	POP		AX
	POP		CX
	POP		DX
	POP		SI
	POP		DI
	POP		ES
	POP		[BP].BufOfs.Word [0]
	POP		[BP].Target.Word [0]
	POP		[BP].Target.Word [2]
	MOV		BX, SI
@31:RET
@40:LES		DI, ES:[DI].TView.Owner
	MOV		SI, ES:[DI].TGroup.Buffer.Word [2]
	OR		SI, SI
	JE		@44
	CMP		SI, DevicesInfo.ScreenBuffer.Word [2]
	JE		@41
	CALL	@50
	JMP		@44
@41:CLI
	CMP		AX, MouseLocate.A.Y
	JB		@42
	CMP		AX, MouseLocate.B.Y
	JA		@42
	CMP		BX, MouseLocate.B.X
	JA		@42
	CMP		CX, MouseLocate.A.X
	JAE		@43
@42:MOV		MouseIntFlag, 0
	STI
	CALL	@50
	CMP		MouseIntFlag, 0
	JE		@44
@43:STI
	CALL	HideMouse
	CALL	@50
	CALL	ShowMouse
@44:CMP		ES:[DI].TGroup.LockFlag, 0
	JNE		@31
	JMP		@10

@50:PUSH	ES
	PUSH	DS
	PUSH	DI
	PUSH	CX
	PUSH	AX
	MUL		ES:[DI].TView.Size.X.Byte [0]
	ADD		AX, BX
	SHL		AX, 1
	ADD		AX, ES:[DI].TGroup.Buffer.Word [0]
	MOV		DI, AX
	MOV		ES, SI
	MOV		AH, ShadowAttr
	SUB		CX, BX
	CMP		SI, DevicesInfo.ScreenBuffer.Word [2]
	JE		@51
@56:MOV		SI, BX
	SUB		SI, [BP].BufOfs
	SHL		SI, 1
	ADD		SI, [BP].Buffer.Word [0]
	MOV		DS, [BP].Buffer.Word [2]
	CLD
	OR		DX, DX
	JNE		@53
	REP		MOVSW
	JMP		@70
@53:LODSB
	INC		SI
	STOSW
	LOOP	@53
	JMP		@70
@51:CMP		SI, [BP].Buffer.Word [2]
	JE		@56
	MOV		SI, BX
	SUB		SI, [BP].BufOfs
	SHL		SI, 1
	ADD		SI, [BP].Buffer.Word [0]
	PUSH	BX
	MOV		BX, DS
	MOV		_SS, SS
	MOV		_SP, SP
	MOV		DS, [BP].Buffer.Word [2]
	MOV		SS, BX
	MOV		SP, OFFSET XlatScreen + 512
	CLD
	TEST	SS:DevicesInfo.CheckSnow, - 1
	JNE		@60
	MOV		BX, OFFSET XlatScreen
	OR		DX, DX
	JNE		@52
@54:LODSW
	SEGSS	XLAT
	STOSW
	LOOP	@54
	JMP		@69
@52:LODSB
	SEGSS	XLAT
	INC		SI
	STOSW
	LOOP	@52
	JMP		@69
@60:PUSH	DX
	OR		DX, DX
	MOV		DX, 03DAH
	JNE		@65
@61:MOV		BX, OFFSET XlatScreen
	LODSW
	SEGSS	XLAT
	MOV		BX, AX
@62:IN		AL, DX
	TEST	AL, 1
	JNE		@62
	CLI
@63:IN		AL, DX
	TEST	AL, 1
	JE		@63
	MOV		ES:[DI], BX
	ADD		DI, 2
	STI
	LOOP	@61
	JMP		@68
@65:MOV		BX, OFFSET XlatScreen
	LODSB
	SEGSS	XLAT
	INC		SI
	MOV		BX, AX
@66:IN		AL, DX
	TEST	AL, 1
	JNE		@66
	CLI
@67:IN		AL, DX
	TEST	AL, 1
	JE		@67
	MOV		ES:[DI], BX
	ADD		DI, 2
	STI
	LOOP	@65
@68:POP		DX
@69:MOV		AX, SS :_SP
	MOV		SS, SS :_SS
	MOV		SP, AX
	POP		BX
@70:MOV		SI, ES
	POP		AX
	POP		CX
	POP		DI
	POP		DS
	POP		ES
	RET
end;

{******************************************************************* TView **}
constructor TView.Init (var Bounds : TRect);
begin
{$IFNDEF Turbo6}
	inherited Init;
{$ELSE}
	TObject.Init;
{$ENDIF}
	State := sfVisible;
	SetBounds (Bounds);
	DragMode := dmLimitLoY;
	EventMask := evMouseDown + evKeyDown + evCommand;
end;

constructor TView.Load (var S : TStream);
begin
{$IFNDEF Turbo6}
	inherited Init;
{$ELSE}
	TObject.Init;
{$ENDIF}
	S.Read (Origin, SizeOf (TPoint) * 3 + SizeOf (Byte) * 2 + SizeOf (Word) * 4);
end;

destructor TView.Done;
begin
	Hide;
	if PtrRec (Owner).Seg <> 0 then Owner^.Delete (@Self);
end;

procedure TView.Awaken;
begin
end;

procedure TView.BlockCursor;
begin
	SetState (sfCursorIns, True);
end;

procedure TView.CalcBounds (var Bounds : TRect; Delta : TPoint);
var
	S,
	D	: Integer;
	Min,
	Max	: TPoint;

	procedure Grow (var I : Integer); near;
	begin
		if GrowMode and gfGrowRel = 0 then
			Inc (I, D)
		else
			I := (I * S + (S - D) shr 1) div (S - D);
	end;

begin
	S := Owner^.Size.X;
	D := Delta.X;
	GetBounds (Bounds);
	if GrowMode and gfGrowLoX <> 0 then Grow (Bounds.A.X);
	if GrowMode and gfGrowHiX <> 0 then Grow (Bounds.B.X);
	if Options and ofCenterX <> 0 then
		begin
			D := Bounds.B.X - Bounds.A.X;
			S := (S - D) shr 1;
			Bounds.A.X := S;
			Bounds.B.X := S + D;
		end;
	S := Owner^.Size.Y;
	D := Delta.Y;
	if GrowMode and gfGrowLoY <> 0 then Grow (Bounds.A.Y);
	if GrowMode and gfGrowHiY <> 0 then Grow (Bounds.B.Y);
	if Options and ofCenterY <> 0 then
		begin
			D := Bounds.B.Y - Bounds.A.Y;
			S := (S - D) shr 1;
			Bounds.A.Y := S;
			Bounds.B.Y := S + D;
		end;
	SizeLimits (Min, Max);
	Bounds.B.X := Bounds.A.X + Range (Bounds.B.X - Bounds.A.X, Min.X, Max.X);
	Bounds.B.Y := Bounds.A.Y + Range (Bounds.B.Y - Bounds.A.Y, Min.Y, Max.Y);
	if Bounds.B.X - Bounds.A.X > MaxViewWidth then
		Bounds.B.X := Bounds.A.X + MaxViewWidth;
end;

procedure TView.ChangeBounds (var Bounds : TRect);
begin
	SetBounds (Bounds);
	DrawView;
end;

procedure TView.ClearEvent (var Event : TEvent);
begin
	if (PtrRec (Event.InfoPtr).Seg <> 0) and (Word (Event.InfoPtr^) = Ofs (TypeOf (TButton)^)) then
		PButton (Event.InfoPtr)^.DrawState (False)
	else
		if (Event.What = evMouseDown) and (Event.Double) then
			MarkMouse (msMark);
	Event.What := evNothing;
	Event.InfoPtr := @Self;
end;

function TView.CommandEnabled (Command : Word) : Boolean;
begin
	CommandEnabled := (Command > 255) or (Command in CurCommandSet);
end;

function TView.DataSize : Word;
begin
	DataSize := 0;
end;

procedure TView.DisableCommands (Commands : TCommandSet);
begin
	CommandSetChanged := CommandSetChanged or (CurCommandSet * Commands <> []);
	CurCommandSet := CurCommandSet - Commands;
end;

procedure TView.DragView (Event : TEvent; Mode : Byte; var Limits : TRect; MinSize, MaxSize : TPoint);
var
	P,
	S			: TPoint;
	SaveBounds	: TRect;

	procedure MoveGrow (P, S : TPoint);
	var
		R	: TRect;
	begin
		S.X := Min (Max (S.X, MinSize.X), MaxSize.X);
		S.Y := Min (Max (S.Y, MinSize.Y), MaxSize.Y);
		P.X := Min (Max (P.X, Limits.A.X - S.X + 1), Limits.B.X - 1);
		P.Y := Min (Max (P.Y, Limits.A.Y - S.Y + 1), Limits.B.Y - 1);
		if Mode and dmLimitLoX <> 0 then P.X := Max (P.X, Limits.A.X);
		if Mode and dmLimitLoY <> 0 then P.Y := Max (P.Y, Limits.A.Y);
		if Mode and dmLimitHiX <> 0 then P.X := Min (P.X, Limits.B.X - S.X);
		if Mode and dmLimitHiY <> 0 then P.Y := Min (P.Y, Limits.B.Y - S.Y);
		R.Assign (P.X, P.Y, P.X + S.X, P.Y + S.Y);
		Locate (R);
	end;

	procedure Change (DX, DY : Integer);
	begin
		if (Mode and dmDragMove <> 0) and (ShiftState and $03 = 0) then
			begin
				Inc (P.X, DX);
				Inc (P.Y, DY);
			end
		else
			if (Mode and dmDragGrow <> 0) and (ShiftState and $03 <> 0) then
				begin
					Inc (S.X, DX);
					Inc (S.Y, DY);
				end;
	end;

begin
	SetState (sfDragging, True);
	if Event.What = evMouseDown then
		if Mode and dmDragMove <> 0 then
			begin
				P.X := Origin.X - Event.Where.X;
				P.Y := Origin.Y - Event.Where.Y;
				repeat
					Inc (Event.Where.X, P.X);
					Inc (Event.Where.Y, P.Y);
					MoveGrow (Event.Where, Size);
				until not MouseEvent (Event, evMouseMove);
			end
		else
			begin
				P.X := Size.X - Event.Where.X;
				P.Y := Size.Y - Event.Where.Y;
				repeat
					Inc (Event.Where.X, P.X);
					Inc (Event.Where.Y, P.Y);
					MoveGrow (Origin, Event.Where);
				until not MouseEvent (Event, evMouseMove);
			end
	else
		begin
			GetBounds (SaveBounds);
			repeat
				P := Origin;
				S := Size;
				KeyEvent (Event);
				case Event.KeyCode and $FF00 of
					kbLeft		: Change ( - 1, 0);
					kbRight		: Change (1, 0);
					kbUp		: Change (0, - 1);
					kbDown		: Change (0, 1);
					kbCtrlLeft	: Change ( - 8, 0);
					kbCtrlRight	: Change (8, 0);
					kbHome		: P.X := Limits.A.X;
					kbEnd		: P.X := Limits.B.X - S.X;
					kbPgUp		: P.Y := Limits.A.Y;
					kbPgDn		: P.Y := Limits.B.Y - S.Y;
				end;
				MoveGrow (P, S);
			until (Event.KeyCode = kbEnter) or (Event.KeyCode = kbEsc);
			if Event.KeyCode = kbEsc then Locate (SaveBounds);
		end;
	SetState (sfDragging, False);
end;

procedure TView.Draw;
var
	B	: TDrawBuffer;
begin
	MoveChar (B, ' ', Lo (GetColor (0)), Size.X);
	WriteLine (0, 0, Size.X, Size.Y, B);
end;

procedure TView.DrawCursor;
begin
	if State and sfFocused <> 0 then ResetCursor;
end;

procedure TView.DrawHide (LastView : PView);
begin
	DrawCursor;
	DrawUnderView (State and sfShadow <> 0, LastView);
end;

procedure TView.DrawShow (LastView : PView);
begin
	DrawView;
	if State and sfShadow <> 0 then DrawUnderView (True, LastView);
end;

procedure TView.DrawUnderRect (var R : TRect; LastView : PView);
begin
	Owner^.Clip.Intersect (R);
	Owner^.DrawSubViews (NextView, LastView);
	Owner^.GetExtent (Owner^.Clip);
end;

procedure TView.DrawUnderView (DoShadow : Boolean; LastView : PView);
var
	R	: TRect;
begin
	GetBounds (R);
	if DoShadow then
		begin
			Inc (R.B.X, ShadowSize.X);
			Inc (R.B.Y, ShadowSize.Y);
		end;
	DrawUnderRect (R, LastView);
end;

procedure TView.DrawView;
begin
	if Exposed then
		begin
			State := State or sfDrawing;
			Draw;
			DrawCursor;
			State := State and not sfDrawing;
		end;
end;

procedure TView.EnableCommands (Commands : TCommandSet);
begin
	CommandSetChanged := CommandSetChanged or (CurCommandSet * Commands <> Commands);
	CurCommandSet := CurCommandSet + Commands;
end;

procedure TView.EndModal (Command : Word);
var
	P	: PView;
begin
	P := TopView;
	if Seg (TopView^) <> 0 then TopView^.EndModal (Command);
end;

function TView.EventAvail (Mask : Word) : Boolean;
var
	Event	: TEvent;
begin
	GetEvent (Event);
	if Event.What <> evNothing then PutEvent (Event);
	EventAvail := Event.What and Mask <> evNothing;
end;

procedure TView.GetBounds (var Bounds : TRect); assembler;
asm
	PUSH	DS
	LDS		SI, Self
	ADD		SI, OFFSET TView.Origin
	LES		DI, Bounds
	CLD
	LODSW
	MOV		CX, AX
	STOSW
	LODSW
	MOV		DX, AX
	STOSW
	LODSW
	ADD		AX, CX
	STOSW
	LODSW
	ADD		AX, DX
	STOSW
	POP		DS
end;

function TView.Execute : Word;
begin
	Execute := cmCancel;
end;

function TView.Exposed : Boolean; assembler;
var
	Target	: Pointer;
asm
	LES		DI, Self
	TEST	ES:[DI].TView.State, sfExposed
	JE		@2
	XOR		AX, AX
	CMP		AX, ES:[DI].TView.Size.X
	JGE		@2
	CMP		AX, ES:[DI].TView.Size.Y
	JGE		@2
@1:	XOR		BX, BX
	MOV		CX, ES:[DI].TView.Size.X
	PUSH	AX
	CALL	@11
	POP		AX
	JNC		@3
	LES		DI, Self
	INC		AX
	CMP		AX, ES:[DI].TView.Size.Y
	JL		@1
@2:	MOV		AL, 0
	JMP		@30
@3:	MOV		AL, 1
	JMP		@30
@8:	STC
@9:	RETN
@10:LES		DI, ES:[DI].TView.Owner
	CMP		ES:[DI].TGroup.Buffer.Word [2], 0
	JNE		@9
@11:MOV		Target.Word [0], DI
	MOV		Target.Word [2], ES
	ADD		AX, ES:[DI].TView.Origin.Y
	MOV		SI, ES:[DI].TView.Origin.X
	ADD		BX, SI
	ADD		CX, SI
	LES		DI, ES:[DI].TView.Owner
	MOV		SI, ES
	OR		SI, DI
	JE		@9
	CMP		AX, ES:[DI].TGroup.Clip.A.Y
	JL		@8
	CMP		AX, ES:[DI].TGroup.Clip.B.Y
	JGE		@8
	CMP		BX, ES:[DI].TGroup.Clip.A.X
	JGE		@12
	MOV		BX, ES:[DI].TGroup.Clip.A.X
@12:CMP		CX, ES:[DI].TGroup.Clip.B.X
	JLE		@13
	MOV		CX, ES:[DI].TGroup.Clip.B.X
@13:CMP		BX, CX
	JGE		@8
	LES		DI, ES:[DI].TGroup.Last
@20:LES		DI, ES:[DI].TView.Next
	CMP		DI, Target.Word [0]
	JNE		@21
	MOV		SI, ES
	CMP		SI, Target.Word [2]
	JE		@10
@21:TEST	ES:[DI].TView.State, sfVisible
	JE		@20
	MOV		SI, ES:[DI].TView.Origin.Y
	CMP		AX, SI
	JL		@20
	ADD		SI, ES:[DI].TView.Size.Y
	CMP		AX, SI
	JGE		@20
	MOV		SI, ES:[DI].TView.Origin.X
	CMP		BX, SI
	JL		@22
	ADD		SI, ES:[DI].TView.Size.X
	CMP		BX, SI
	JGE		@20
	MOV		BX, SI
	CMP		BX, CX
	JL		@20
	STC
	RETN
@22:CMP		CX, SI
	JLE		@20
	ADD		SI, ES:[DI].TView.Size.X
	CMP		CX, SI
	JG		@23
	MOV		CX, ES:[DI].TView.Origin.X
	JMP		@20
@23:PUSH	Target.Word [2]
	PUSH	Target.Word [0]
	PUSH	ES
	PUSH	DI
	PUSH	SI
	PUSH	CX
	PUSH	AX
	MOV		CX, ES:[DI].TView.Origin.X
	CALL	@20
	POP		AX
	POP		CX
	POP		BX
	POP		DI
	POP		ES
	POP		Target.Word [0]
	POP		Target.Word [2]
	JC		@20
	RETN
@30:
end;

function TView.Focus : Boolean;
var
	Result : Boolean;
begin
	Result := True;
	if State and (sfSelected + sfModal) = 0 then
		begin
			if PtrRec (Owner).Seg <> 0 then
				begin
					Result := Owner^.Focus;
					if Result then
						if ((PtrRec (Owner^.Current).Seg = 0)
						or (Owner^.Current^.Options and ofValidate = 0)
						or (Owner^.Current^.Valid (cmReleasedFocus))) then
							Select
						else
							Result := False;
				end;
		end;
	Focus := Result;
end;

procedure TView.GetClipRect (var Clip : TRect);
begin
	GetBounds (Clip);
	if PtrRec (Owner).Seg <> 0 then Clip.Intersect (Owner^.Clip);
	Clip.Move ( - Origin.X, - Origin.Y);
end;

function TView.GetColor (Color : Word) : Word; assembler;
asm
	MOV		AX, Color
	CALL	MapCPair
end;

procedure TView.GetCommands (var Commands : TCommandSet);
begin
	Commands := CurCommandSet;
end;

procedure TView.GetData (var Rec);
begin
end;

procedure TView.GetEvent (var Event : TEvent);
begin
	if PtrRec (Owner).Seg <> 0 then
		Owner^.GetEvent (Event)
	else
		Event.What := evNothing;
end;

procedure TView.GetExtent (var Extent : TRect); assembler;
asm
	PUSH	DS
	LDS		SI, Self
	ADD		SI, OFFSET TView.Size
	LES		DI, Extent
	CLD
	XOR		AX, AX
	STOSW
	STOSW
	MOVSW
	MOVSW
	POP		DS
end;

function TView.GetHelpCtx : Word;
begin
	if State and sfDragging <> 0 then
		GetHelpCtx := hcDragging
	else
		GetHelpCtx := HelpCtx;
end;

procedure TView.GetPeerViewPtr (var S : TStream; var P);
var
	Index	: Integer;
begin
	S.Read (Index, SizeOf (Word));
	if (Index <= 0) or (PtrRec (OwnerGroup).Seg = 0) then
		Pointer (P) := NIL
	else
		begin
			Pointer (P) := FixupList^ [Index];
			FixupList^ [Index] := @P;
		end;
end;

function TView.GetState (AState : Word) : Boolean;
begin
	GetState := State and AState = AState;
end;

procedure TView.GrowTo (X, Y : Integer);
var
	R	: TRect;
begin
	R.Assign (Origin.X, Origin.Y, Origin.X + X, Origin.Y + Y);
	Locate (R);
end;

procedure TView.HandleEvent (var Event : TEvent);
begin
	if Event.What = evMouseDown then
		if (State and (sfSelected + sfDisabled) = 0) and (Options and ofSelectable <> 0) then
			if not Focus or (Options and ofFirstClick = 0) then
				ClearEvent (Event);
end;

procedure TView.Hide;
begin
	if State and sfVisible <> 0 then SetState (sfVisible, False);
end;

procedure TView.HideCursor;
begin
	SetState (sfCursorVis, False);
end;

procedure TView.KeyEvent (var Event : TEvent);
begin
	repeat GetEvent (Event) until Event.What = evKeyDown;
end;

procedure TView.Locate (var Bounds : TRect);
var
	R		: TRect;
	Min,
	Max		: TPoint;

begin
	SizeLimits (Min, Max);
	Bounds.B.X := Bounds.A.X + Range (Bounds.B.X - Bounds.A.X, Min.X, Max.X);
	Bounds.B.Y := Bounds.A.Y + Range (Bounds.B.Y - Bounds.A.Y, Min.Y, Max.Y);
	GetBounds (R);
	if not Bounds.Equals (R) then
		begin
			ChangeBounds (Bounds);
			if (PtrRec (Owner).Seg <> 0) and (State and sfVisible <> 0) then
				begin
					if State and sfShadow <> 0 then
						begin
							R.Union (Bounds);
							Inc (R.B.X, ShadowSize.X);
							Inc (R.B.Y, ShadowSize.Y);
						end;
					DrawUnderRect (R, NIL);
				end;
		end;
end;

procedure TView.MakeFirst;
begin
	PutInFrontOf (Owner^.First);
end;

procedure TView.MakeGlobal (Source : TPoint; var Dest : TPoint); assembler;
asm
	LES		DI, Self
	XOR		AX, AX
	MOV		DX, AX
@1:	ADD		AX, ES:[DI].TView.Origin.X
	ADD		DX, ES:[DI].TView.Origin.Y
	LES		DI, ES:[DI].TView.Owner
	MOV		SI, ES
	OR		SI, DI
	JNE		@1
	ADD		AX, Source.X
	ADD		DX, Source.Y
	LES		DI, Dest
	CLD
	STOSW
	XCHG	AX, DX
	STOSW
end;

procedure TView.MakeLocal (Source : TPoint; var Dest : TPoint); assembler;
asm
	LES		DI, Self
	XOR		AX, AX
	MOV		DX, AX
@1:	ADD		AX, ES:[DI].TView.Origin.X
	ADD		DX, ES:[DI].TView.Origin.Y
	LES		DI, ES:[DI].TView.Owner
	MOV		SI, ES
	OR		SI, DI
	JNE		@1
	NEG		AX
	NEG		DX
	ADD		AX, Source.X
	ADD		DX, Source.Y
	LES		DI, Dest
	CLD
	STOSW
	XCHG	AX, DX
	STOSW
end;

function TView.MouseEvent (var Event : TEvent; Mask : Word) : Boolean;
begin
	repeat GetEvent (Event) until Event.What and (Mask or evMouseUp) <> 0;
	MouseEvent := Event.What <> evMouseUp;
end;

function TView.MouseInView (Mouse : TPoint) : Boolean;
var
	Extent	: TRect;
begin
	MakeLocal (Mouse, Mouse);
	GetExtent (Extent);
	MouseInView := Extent.Contains (Mouse);
end;

procedure TView.MoveTo (X, Y : Integer);
var
	R	: TRect;
begin
	R.Assign (X, Y, X + Size.X, Y + Size.Y);
	Locate (R);
end;

function TView.NextView : PView;
begin
	if @Self = Owner^.Last then
		NextView := NIL
	else
		NextView := Next;
end;

procedure TView.NormalCursor;
begin
	SetState (sfCursorIns, False);
end;

function TView.Prev : PView; assembler;
asm
	LES		DI, Self
	MOV		CX, DI
	MOV		BX, ES
@1:	MOV		AX, DI
	MOV		DX, ES
	LES		DI, ES:[DI].TView.Next
	CMP		DI, CX
	JNE		@1
	MOV		SI, ES
	CMP		SI, BX
	JNE		@1
end;

function TView.PrevView : PView;
begin
	if @Self = Owner^.First then
		PrevView := NIL
	else
		PrevView := Prev;
end;

procedure TView.PutEvent (var Event : TEvent);
begin
	if PtrRec (Owner).Seg <> 0 then Owner^.PutEvent (Event);
end;

function TView.SendCommand (Cmd : Word) : Boolean;
var
	Event	: TEvent;
begin
	if (Cmd <> 0) and CommandEnabled (Cmd) then
		begin
			with Event do
				begin
					What := evCommand;
					Command := Cmd;
					InfoPtr := @Self;
				end;
			PutEvent (Event);
			SendCommand := True;
		end
	else
		SendCommand := False;
end;

function TView.SendBroadcast (Cmd : Word) : Pointer;
begin
	SendBroadcast := Message (Owner, evBroadcast, Cmd, @Self);
end;

procedure TView.PutInFrontOf (Target : PView);
var
	P,
	LastView	: PView;
	R			: TRect;

	procedure MoveView;
	begin
		Owner^.Lock;
		Owner^.RemoveView (@Self);
		Owner^.InsertView (@Self, Target);
		Owner^.UnLock;
	end;

begin
	if (PtrRec (Owner).Seg <> 0) and (Target <> @Self) and (Target <> NextView) and
	((PtrRec (Target).Seg = 0) or (Target^.Owner = Owner)) then
		if State and sfVisible = 0 then
			MoveView
		else
			begin
				LastView := NextView;
				P := Target;
				while (PtrRec (P).Seg <> 0) and (P <> LastView) do P := P^.NextView;
				if PtrRec (P).Seg = 0 then LastView := Target;
				State := State and not sfVisible;
				if LastView = Target then DrawHide (LastView);
				MoveView;
				State := State or sfVisible;
				if LastView <> Target then DrawShow (LastView);
				if Options and ofSelectable <> 0 then Owner^.ResetCurrent;
			end;
end;

procedure TView.PutPeerViewPtr (var S : TStream; P : PView);
var
	Index	: Integer;
begin
	if (PtrRec (P).Seg = 0) or (PtrRec (OwnerGroup).Seg = 0) then
		Index := 0
	else
		Index := OwnerGroup^.IndexOf (P);
	S.Write (Index, SizeOf (Word));
end;

procedure TView.ResetCursor; assembler;
asm
	LES		DI, Self
	MOV		AX, ES:[DI].TView.State
	NOT		AX
	TEST	AX, sfVisible + sfCursorVis + sfFocused
	JNE		@4
	MOV		AX, ES:[DI].TView.Cursor.Y
	MOV		DX, ES:[DI].TView.Cursor.X
@1:	OR		AX, AX
	JL		@4
	CMP		AX, ES:[DI].TView.Size.Y
	JGE		@4
	OR		DX, DX
	JL		@4
	CMP		DX, ES:[DI].TView.Size.X
	JGE		@4
	ADD		AX, ES:[DI].TView.Origin.Y
	ADD		DX, ES:[DI].TView.Origin.X
	MOV		CX, DI
	MOV		BX, ES
	LES		DI, ES:[DI].TView.Owner
	MOV		SI, ES
	OR		SI, DI
	JE		@5
	TEST	ES:[DI].TView.State, sfVisible
	JE		@4
	LES		DI, ES:[DI].TGroup.Last
@2:	LES		DI, ES:[DI].TView.Next
	CMP		CX, DI
	JNE		@3
	MOV		SI, ES
	CMP		BX, SI
	JNE		@3
	LES		DI, ES:[DI].TView.Owner
	JMP		@1
@3:	TEST	ES:[DI].TView.State, sfVisible
	JE		@2
	MOV		SI, ES:[DI].TView.Origin.Y
	CMP		AX, SI
	JL		@2
	ADD		SI, ES:[DI].TView.Size.Y
	CMP		AX, SI
	JGE		@2
	MOV		SI, ES:[DI].TView.Origin.X
	CMP		DX, SI
	JL		@2
	ADD		SI, ES:[DI].TView.Size.X
	CMP		DX, SI
	JGE		@2
@4:	MOV		CX, 2000H
	JMP		@6
@5:	MOV		DH, AL
	XOR		BH, BH
	MOV		AH, 2
	INT		10H
	MOV		CX, DevicesInfo.CursorLines
	LES		DI, Self
	TEST	ES:[DI].TView.State, sfCursorIns
	JE		@6
	MOV		CH, 0
	OR		CL, CL
	JNE		@6
	MOV		CL, 7
@6:	MOV		AH, 1
	INT		10H
end;

procedure TView.Select;
begin
	if Options and ofSelectable <> 0 then
		if Options and ofTopSelect <> 0 then
			MakeFirst
		else
			if PtrRec (Owner).Seg <> 0 then
				Owner^.SetCurrent (@Self, NormalSelect);
end;

procedure TView.SetBounds (var Bounds : TRect); assembler;
asm
	PUSH	DS
	LES		DI, Self
	LDS		SI, Bounds
	MOV		AX, [SI].TRect.A.X
	MOV		ES:[DI].Origin.X, AX
	MOV		AX, [SI].TRect.A.Y
	MOV		ES:[DI].Origin.Y, AX
	MOV		AX, [SI].TRect.B.X
	SUB		AX, [SI].TRect.A.X
	MOV		ES:[DI].Size.X, AX
	MOV		AX, [SI].TRect.B.Y
	SUB		AX, [SI].TRect.A.Y
	MOV		ES:[DI].Size.Y, AX
	POP		DS
end;

procedure TView.SetCmdState (Commands : TCommandSet; Enable : Boolean);
begin
	if Enable then
		EnableCommands (Commands)
	else
		DisableCommands (Commands);
end;

procedure TView.SetCommands (Commands : TCommandSet);
begin
	CommandSetChanged := CommandSetChanged or (CurCommandSet <> Commands);
	CurCommandSet := Commands;
end;

procedure TView.SetCursor (X, Y : Integer);
begin
	Cursor.X := X;
	Cursor.Y := Y;
	DrawCursor;
end;

procedure TView.SetData (var Rec);
begin
end;

procedure TView.SetState (AState : Word; Enable : Boolean);
var
	Command : Word;
begin
	if Enable then
		State := State or AState
	else
		State := State and not AState;
	if PtrRec (Owner).Seg <> 0 then
		case AState of
			sfVisible	:
				begin
					if Owner^.State and sfExposed <> 0 then
						SetState (sfExposed, Enable);
					if Enable then
						DrawShow (NIL)
					else
						DrawHide (NIL);
					if Options and ofSelectable <> 0 then Owner^.ResetCurrent;
				end;
			sfCursorVis,
			sfCursorIns	:	DrawCursor;
			sfShadow	:	DrawUnderView (True, NIL);
			sfFocused	:
					begin
						ResetCursor;
						if Enable then
							Command := cmReceivedFocus
						else
							Command := cmReleasedFocus;
						DrawView;
						SendBroadcast (Command);
					end;
		end;
end;

procedure TView.Show;
begin
	if State and sfVisible = 0 then SetState (sfVisible, True);
end;

procedure TView.ShowCursor;
begin
	SetState (sfCursorVis, True);
end;

procedure TView.SizeLimits (var Min, Max : TPoint);
begin
	Longint (Min) := 0;
	if PtrRec (Owner).Seg <> 0 then
		Max := Owner^.Size
	else
		Longint (Max) := $7FFF7FFF;
end;

procedure TView.Store (var S : TStream);
var
	SaveState	: Word;
begin
	SaveState := State;
	State := State and not (sfActive + sfSelected + sfFocused + sfExposed);
	S.Write (Origin, SizeOf (TPoint) * 3 + SizeOf (Byte) * 2 + SizeOf (Word) * 4);
	State := SaveState;
end;

function TView.TopView : PView;
var
	P	: PView;
begin
	if PtrRec (TheTopView).Seg = 0 then
		begin
			P := @Self;
			while (PtrRec (P).Seg <> 0) and (P^.State and sfModal = 0) do P := P^.Owner;
			TopView := P;
		end
	else
		TopView := TheTopView;
end;

function TView.Valid (Command : Word) : Boolean;
begin
	Valid := True;
end;

procedure TView.WriteBuf (X, Y, W, H : Integer; var Buf); assembler;
var
	Target	: Pointer;
	Buffer	: Pointer;
	Offset	: Word;
asm
	CMP		H, 0
	JLE		@2
@1:	MOV		AX, Y
	MOV		BX, X
	MOV		CX, W
	LES		DI, Buf
	CALL	WriteView
	MOV		AX, W
	SHL		AX, 1
	ADD		WORD PTR Buf [0], AX
	INC		Y
	DEC		H
	JNE		@1
@2:
end;

procedure TView.WriteChar (X, Y : Integer; C : Char; Color : Byte; Count : Integer); assembler;
var
	Target	: Pointer;
	Buffer	: Pointer;
	Offset	: Word;
asm
	MOV		AL, Color
	CALL	MapColor
	MOV		AH, AL
	MOV		AL, C
	MOV		CX, Count
	OR		CX, CX
	JLE		@2
	CMP		CX, 256
	JLE		@1
	MOV		CX, 256
@1:	MOV		DI, CX
	SHL		DI, 1
	SUB		SP, DI
	MOV		DI, SP
	PUSH	SS
	POP		ES
	MOV		DX, CX
	CLD
	REP		STOSW
	MOV		CX, DX
	MOV		DI, SP
	MOV		AX, Y
	MOV		BX, X
	CALL	WriteView
@2:
end;

procedure TView.WriteLine (X, Y, W, H : Integer; var Buf); assembler;
var
	Target	: Pointer;
	Buffer	: Pointer;
	Offset	: Word;
asm
	CMP		H, 0
	JLE		@2
@1:	MOV		AX, Y
	MOV		BX, X
	MOV		CX, W
	LES		DI, Buf
	CALL	WriteView
	INC		Y
	DEC		H
	JNE		@1
@2:
end;

procedure TView.WriteStr (X, Y : Integer; Str : String; Color : Byte); assembler;
var
	Target	: Pointer;
	Buffer	: Pointer;
	Offset	: Word;
asm
	MOV		AL, Color
	CALL	MapColor
	MOV		AH, AL
	MOV		BX, DS
	LDS		SI, Str
	CLD
	LODSB
	MOV		CL, AL
	XOR		CH, CH
	JCXZ	@3
	MOV		DI, CX
	SHL		DI, 1
	SUB		SP, DI
	MOV		DI, SP
	PUSH	SS
	POP		ES
	MOV		DX, CX
@1:	LODSB
	STOSW
	LOOP	@1
	MOV		DS, BX
	MOV		CX, DX
	MOV		DI, SP
	MOV		AX, Y
	MOV		BX, X
	CALL	WriteView
	JMP		@2
@3:	MOV		DS, BX
@2:
end;

procedure TView.Destroy;
begin
	State := State or sfDestroyed;
	if State and sfRunning = 0 then	Free;
end;

{****************************************************************** TFrame **}
constructor TFrame.Init (var Bounds : TRect);
begin
{$IFNDEF Turbo6}
	inherited Init (Bounds);
{$ELSE}
	TView.Init (Bounds);
{$ENDIF}
	GrowMode := gfGrowHiX + gfGrowHiY;
	EventMask := EventMask or evBroadcast;
end;

procedure TFrame.FrameLine (var FrameBuf; Y, N : Integer; Color : Word); assembler;
var
	FrameMask	: array [0..MaxViewWidth - 1] of Byte;

const

	InitFrame		: array [0..35] of Byte = (
		$66, $6A, $7C,	{     }
		$65, $00, $75,	{     }
		$63, $7A, $79,	{     }
		$06, $0A, $1C,	{Ŀ}
		$05, $00, $15,	{   }
		$03, $1A, $19,	{}
		$26, $2A, $3C,	{ͻ}
		$25, $00, $35,	{   }
		$23, $3A, $39,	{ͼ}
		$46, $4A, $5C,	{}
		$45, $00, $55,	{   }
		$43, $5A, $59	{}
		);

	FrameChars		: array [0..127] of Char =
		'          ' +
		'     ϻ     ϻ' +
		'          ' +
		'                                ';
asm
	LES		BX, Self
	MOV		DX, ES:[BX].TFrame.Size.X
	DEC		DX
	MOV		CX, DX
	DEC		CX
	MOV		SI, OFFSET InitFrame
	ADD		SI, N
	LEA		DI, FrameMask
	PUSH	SS
	POP		ES
	CLD
	MOVSB
	LODSB
	REP		STOSB
	MOVSB
	LES		BX, Self
	LES		BX, ES:[BX].TFrame.Owner
	LES		BX, ES:[BX].TGroup.Last
	PUSH	BX
@1: POP		SI
	LES		SI, ES:[SI].TView.Next
	CMP		SI, WORD PTR Self [0]
	JNE		@2
	MOV		AX, ES
	CMP		AX, WORD PTR Self [2]
	JE		@10
@2: PUSH	SI
	MOV		AX, ES:[SI].TView.Options
	AND		AX, ofISFramed
	JE		@1
	TEST	ES:[SI].TView.State, sfVisible
	JE		@1
	MOV		CX, Y
	SUB		CX, ES:[SI].TView.Origin.Y
	JL		@3
	CMP		CX, ES:[SI].TView.Size.Y
	JG		@1
	MOV		BX, OFFSET InitFrame [3]
	JL		@4
	MOV		BX, OFFSET InitFrame [6]
	JMP		@4
@3:	INC		CX
	JNE		@1
	MOV		BX, OFFSET InitFrame [0]
@4:	MOV		DI, ES:[SI].TView.Size.X
	MOV		SI, ES:[SI].TView.Origin.X
	ADD		DI, SI
	CMP		SI, 1
	JG		@5
	MOV		SI, 1
@5:	CMP		DI, DX
	JL		@6
	MOV		DI, DX
@6:	CMP		SI, DI
	JGE		@1
	MOV		CX, AX
	AND		AL, ofBoldFramed
	ADD		BX, AX
	ADD		AX, AX
	ADD		AX, AX
	ADD		AX, AX
	ADD		BX, AX
	TEST	CL, ofShadowFrame
	JNE		@9
	MOV		AL, [BX]
	OR		BYTE PTR FrameMask [SI - 1], AL
	MOV		AX, [BX + 1]
	OR		BYTE PTR FrameMask [DI], AH
	OR		AL, AL
	JE		@1
	MOV		CX, DI
	SUB		CX, SI
@8:	OR		BYTE PTR FrameMask [SI], AL
	INC		SI
	LOOP	@8
	JMP		@1
@9: DEC		SI
	TEST	CL, 2
	JNE		@30

@20:MOV		AL, [BX]
	TEST	AL, $10
	JE		@21
	TEST	BYTE PTR FrameMask [SI], -1
	JNE		@22
	OR		AL, $80
@21:OR		BYTE PTR FrameMask [SI], AL
@22:MOV		AX, [BX + 1]
	TEST	AH, $10
	JE		@23
	TEST	BYTE PTR FrameMask [DI], -1
	JNE		@24
	OR		AH, $80
@23:OR		BYTE PTR FrameMask [DI], AH
@24:OR		AL, AL
	JE		@1
	INC		SI
	MOV		CX, DI
	SUB		CX, SI
	TEST	AL, $10
	JE		@8
	OR		AL, $80
@25:TEST	BYTE PTR FrameMask [SI], -1
	JNE		@26
	OR		BYTE PTR FrameMask [SI], AL
@26:INC		SI
	LOOP	@25
	JMP		@1
@30:SUB		BX, 9
	MOV		AL, [BX]
	TEST	AL, $10
	JNE		@21
	TEST	BYTE PTR FrameMask [SI], -1
	JNE		@32
	OR		AL, $80
@31:OR		BYTE PTR FrameMask [SI], AL
@32:MOV		AX, [BX + 1]
	TEST	AH, $10
	JNE		@33
	TEST	BYTE PTR FrameMask [DI], -1
	JNE		@34
	OR		AH, $80
@33:OR		BYTE PTR FrameMask [DI], AH
@34:OR		AL, AL
	JE		@1
	INC		SI
	MOV		CX, DI
	SUB		CX, SI
	TEST	AL, $10
	JNE		@8
	OR		AL, $80
@35:TEST	BYTE PTR FrameMask [SI], -1
	JNE		@36
	OR		BYTE PTR FrameMask [SI], AL
@36:INC		SI
	LOOP	@35
	JMP		@1
@10:INC		DX
	MOV		CX, DX
	MOV		DX, Color
	MOV		BX, OFFSET FrameChars
	LEA		SI, FrameMask
	LES		DI, FrameBuf
@11:SEGSS	LODSB
	TEST	AL, $80
	JNE		@14
@12:MOV		AH, DL
	XLAT
	STOSW
	LOOP	@11
	JMP		@15
@13:SEGES	LODSB
	TEST	AL, $80
	JE		@12
@14:MOV		AH, DH
	AND		AL, $7F
	XLAT
	STOSW
	LOOP	@13
@15:
end;

procedure TFrame.Draw;
var
	CFrame	: Word;
	CTitle	: Byte;
	CButton	: Word;
	OButton	: Byte;
	I, N,
	L,
	Width	: Integer;
	B		: TDrawBuffer;
	F		: Byte;
	FO		: Word;
	S		: Word;
	X		: Boolean;
	Title	: TTitleStr;

	procedure GetTitle;
	begin
		if (PtrRec (Owner).Seg <> 0) and (FO and wfNoTitle = 0) then
			Title := PWindow (Owner)^.GetTitle (L)
		else
			Title := '';
	end;

	function IsZoomed : Boolean;
	begin
		IsZoomed := Longint (Owner^.Size) = Longint (Owner^.Owner^.Size);
	end;

	function XColor (AFlags : Byte) : Byte;
	begin
		if AFlags and Flags <> 0 then
			XColor := Hi (CButton)
		else
			XColor := Lo (CButton);
	end;

begin
	S := State;
	FO := PWindow (Owner)^.Flags;
	F := Flags;
	X := FO and (wfWinTitle or wfWinFrame) = 0;
	if FO and wfNoFrame <> 0 then
		N := 0
	else
		if FO and wfSingleFrame <> 0 then
			N := 9
		else
			if FO and wfBoldFrame <> 0 then
				N := 27
			else
				N := 18;
	if S and sfActive = 0 then
		begin
			CFrame := $0600;
			if X then
				CTitle := $00
			else
				CTitle := $20;
			if N = 18 then N := 9;
		end
	else
		begin
			if X then
				CTitle := $01
			else
				CTitle := $21;
			if S and sfDragging <> 0 then
				begin
					if X then
						CFrame := $0602
					else
						CFrame := $0622;
					if N = 18 then N := 9;
				end
			else
				CFrame := $0601
		end;
	CTitle := Lo (GetColor (CTitle));
	CFrame := GetColor (CFrame);
	OButton := Lo (GetColor ($02));
	Width := Size.X;
	if FO and wfWinFrame = 0 then
		begin
			WordRec (CButton).Lo := CFrame;
			WordRec (CButton).Hi := OButton;
			L := Width - 10;
			if FO and (wfClose + wfZoom) <> 0 then Dec (L, 6);
			FrameLine (B, 0, N, CFrame);
			if (PWindow (Owner)^.Number > wnNoNumber) and (PWindow (Owner)^.Number < 10) then
				begin
					Dec (L, 4);
					if FO and wfZoom <> 0 then
						I := 7
					else
						I := 3;
					WordRec (B [Width - I]).Lo := PWindow (Owner)^.Number + $30;
				end;
			GetTitle;
			if S and sfActive <> 0 then
				begin
					if FO and wfClose <> 0 then
						if Flags and ffCloseClicked = 0 then
							MoveCStr (B [2], '[~~]', CButton)
						else
							MoveCStr (B [2], '[~'#15'~]', CButton);
					if FO and wfZoom <> 0 then
						begin
							MoveCStr (B [Width - 5], '[~'#24'~]', CButton);
							if IsZoomed then
								WordRec (B [Width - 4]).Lo := 25;
						end;
				end;
		end
	else
		begin
			CButton := GetColor ($23);
			if FO and wfClose <> 0 then
				L := 6
			else
				L := 2;
			if FO and wfZoom <> 0 then Inc (L, 6);
			if FO and wfWinTitle = 0 then
				begin
					FrameLine (B, 0, N, CFrame);
					if L = 2 then Inc (L, 4);
				end;
			L := Width - L;
			GetTitle;
			L := Ord (FO and wfWinTitle = 0) shl 1;
			MoveChar (B [L], ' ', CTitle, Width - L shl 1);
			if S and sfActive <> 0 then
				begin
					if FO and wfClose <> 0 then
						MoveStr (B [0], '[]', XColor (ffCloseClicked));
					if FO and wfZoom <> 0 then
						begin
							MoveStr (B [Width - 3], '[]', XColor (ffZoomClicked));
							if IsZoomed then
								WordRec (B [Width - 2]).Lo := 31;
						end;
				end;
		end;
	if Title <> '' then
		begin
			L := Length (Title);
			if L > Width - 10 then L := Width - 10;
			if L < 0 then L := 0;
			I := (Width - L) shr 1;
			MoveChar (B [I - 1], ' ', CTitle, 1);
			MoveBuf (B [I], Title [1], CTitle, L);
			MoveChar (B [I + L], ' ', CTitle, 1);
		end;
	WriteLine (0, 0, Size.X, 1, B);
	for I := 1 to Size.Y - 2 do
		begin
			FrameLine (B, I, N + 3, CFrame);
			WriteLine (0, I, Size.X, 1, B);
		end;
	FrameLine (B, Size.Y - 1, N + 6, CFrame);
	if FO and wfGrow <> 0 then
		if FO and wfScrolled <> 0 then
			begin
				if S and sfActive <> 0 then
					MoveCStr (B [Width - 2], '', OButton)
			end
		else
			if FO and wfWinTitle = 0 then
				MoveCStr (B [Width - 5], '[~'#26'~]', CButton)
			else
				MoveCStr (B [Width - 5], '[~~]', CButton);
	WriteLine (0, Size.Y - 1, Size.X, 1, B);
end;

procedure TFrame.HandleEvent (var Event : TEvent);
var
	Mouse	: TPoint;
	FO		: Word;
	WF		: Boolean;

	procedure DragWindow (Mode : Byte);
	var
		Limits	: TRect;
		Min,
		Max		: TPoint;
	begin
		Owner^.Owner^.GetExtent (Limits);
		Limits.B.X := MaxViewWidth;
		Owner^.SizeLimits (Min, Max);
		Owner^.DragView (Event, Owner^.DragMode or Mode, Limits, Min, Max);
		ClearEvent (Event);
	end;

	function TrackMouse (X1, DX, Y : Integer; Flag : Word) : Boolean;
	var
		NS	: Word;
	begin
		repeat
			MakeLocal (Event.Where, Mouse);
			if ((Mouse.X >= X1) and (Mouse.X <= X1 + DX)) and (Mouse.Y = Y) then
				NS := Flag
			else
				NS := 0;
			if NS <> Flags then
				begin
					Flags := NS;
					DrawView;
				end;
		until not MouseEvent (Event, evMouseMove + evMouseAuto);
		Flags := 0;
		TrackMouse := NS <> 0;
		ClearEvent (Event);
		DrawView;
	end;

begin
{$IFNDEF Turbo6}
	inherited HandleEvent (Event);
{$ELSE}
	TView.HandleEvent (Event);
{$ENDIF}
	if (Event.What = evMouseDown) and (State and sfActive <> 0) then
		begin
			FO := PWindow (Owner)^.Flags;
			MakeLocal (Event.Where, Mouse);
			if Mouse.Y = 0 then
				begin
					WF := (FO and wfWinFrame <> 0);
					if (FO and wfClose <> 0) and
					((not WF and (Mouse.X = 3)) or (WF and (Mouse.X < 2))) then
						begin
							if (not WF and TrackMouse (3, 0, 0, ffCloseClicked))
							or (WF and TrackMouse (0, 1, 0, ffCloseClicked)) then
								SendCommand (cmClose);
						end
					else
						if (FO and wfZoom <> 0) and (Event.Double or (Mouse.X = Size.X - 4 + Ord (WF) shl 1)) then
							begin
								if TrackMouse (Size.X - 4 + Ord (WF) shl 1, 1, 0, ffZoomClicked) then
									SendCommand (cmZoom);
							end
						else
							if FO and wfMove <> 0 then
								DragWindow (dmDragMove);
				end
			else
				if FO and wfGrow <> 0 then
					if ((FO and wfScrolled = 0) and  (Mouse.X >= Size.X - 4) and (Mouse.X <= Size.X - 3) and (Mouse.Y >= Size.Y - 1))
					or ((FO and wfScrolled <> 0) and (Mouse.X >= Size.X - 2) and (Mouse.Y >= Size.Y - 1)) then
						DragWindow (dmDragGrow);
		end;
end;

procedure TFrame.SetState (AState : Word; Enable : Boolean);
begin
{$IFNDEF Turbo6}
	inherited SetState (AState, Enable);
{$ELSE}
	TView.SetState (AState, Enable);
{$ENDIF}
	if AState and (sfActive + sfDragging) <> 0 then DrawView;
end;

{************************************************************** TScrollBar **}
constructor TScrollBar.Init (var Bounds : TRect; AFlags : Byte);
begin
{$IFNDEF Turbo6}
	inherited Init (Bounds);
{$ELSE}
	TView.Init (Bounds);
{$ENDIF}
	PgStep := 1;
	ArStep := 1;
	if Size.X > Size.Y then
		AFlags := AFlags or lfHorizontal;
	if AFlags and lfHorizontal = 0 then
		GrowMode := gfGrowLoX + gfGrowHiX + gfGrowHiY
	else
		GrowMode := gfGrowLoY + gfGrowHiX + gfGrowHiY;
	Flags := AFlags;
end;

constructor TScrollBar.Load (var S : TStream);
begin
{$IFNDEF Turbo6}
	inherited Load (S);
{$ELSE}
	TView.Load (S);
{$ENDIF}
	S.Read (Value, SizeOf (Integer) * 6 + SizeOf (Flags));
end;

procedure TScrollBar.Draw;
begin
	DrawPos (GetPos (Value));
end;

procedure TScrollBar.DrawPos (APos : Integer);
var
	ATop	: Integer;
	S		: Integer;
	Delta	: Integer;
	V, I	: Boolean;
	Start	: Integer;
	Finish	: Integer;
	Tmp		: Integer;
	B		: TDrawBuffer;
	A		: array [0..1] of Char;
	C1, C2	: Byte;
	F		: Byte;

	function Calc (Value : Integer) : Integer; near;
	begin
		Value := LongDiv (LongMul (Value - Min, S), Max - Min);
		if Value < 0 then Value := 0;
		if Value > S then Value := S;
		Calc := Value;
	end;

begin
	C1 := Lo (GetColor (3));
	C2 := Lo (GetColor (4));
	ATop := Top;
	F := Flags;
	if (F and lfTracking <> 0) and (GetPos (Value) <> APos) then
		begin
			SetValue (GetValue (APos));
			Exit;
		end;
	V := F and lfHorizontal = 0;
	if V then
		Delta := Size.Y
	else
		Delta := Size.X;
	if Delta < 3 then Delta := 3;
	if F and lfSmallItem = 0 then
		if Max <= Min then
			MoveChar (B, '', C1, Delta)
		else
			MoveChar (B, '', C1, Delta)
	else
		MoveChar (B, ' ', C1, Delta);
	if F and lfPtrDraw <> 0 then
		begin
			if F and lfMSPtr <> 0 then
				if V then
					A := ''
				else
					A := ''#26
			else
				if V then
					A := ''
				else
					A := '';
			MoveChar (B [0], A [0], C2, 1);
			MoveChar (B [Delta - 1], A [1], C2, 1);
			Tmp := 1;
		end
	else
		Tmp := 0;
	S := Delta - Tmp shl 1;
	I := F and lfSmallItem <> 0;
	if I then S := S shl 1;
	if (F and lfStepDraw <> 0) and (Max > Min) then
		begin
			Start := Calc (ATop);
			Finish := Calc (ATop + PgStep);
			if Start > Finish then
				asm
					MOV		AX, Start
					XCHG	AX, Finish
					MOV		Start, AX
				end;
			if (Start = Finish) and (PgStep <> 0) then
				if Start > 0 then
					Dec (Start)
				else
					Inc (Finish);
			if I then
				begin
					if V then
						A := ''
					else
						A := '';
					MoveChar (B [Tmp + Start shr 1], '', C1, (Finish - Start) shr 1);
					if Start and 1 <> 0 then
						MoveChar (B [Tmp + Start shr 1], A [0], C1, 1);
					if Finish and 1 <> 0 then
						MoveChar (B [Tmp + Finish shr 1], A [1], C1, 1);
				end
			else
				MoveChar (B [Tmp + Start], '', C1, Finish - Start);
		end;
	if (F and lfPosDraw <> 0) and (Max > Min) then
		begin
			if F and lfMSPtr <> 0 then
				if V then
					A [0] := ''
				else
					A  [0] := ''
			else
				A [0] := '';
			MoveChar (B [APos], A [0], C1, 1);
		end;
	if V then
		for Delta := 0 to Size.X - 1 do
			WriteBuf (Delta, 0, 1, Size.Y, B)
		else
			WriteLine (0, 0, Size.X, Size.Y, B);
end;

function TScrollBar.GetValue (APos : Integer) : Integer;
var
	T, S	: Integer;
begin
	T := Ord (Flags and lfPtrDraw <> 0);
	Dec (APos, T);
	if APos < 0 then APos := 0;
	if Flags and lfHorizontal <> 0 then
		S := Size.X - 1 - (T shl 1)
	else
		S := Size.Y - 1 - (T shl 1);
	if APos > S then APos := S;
	if S > 0 then
		GetValue := Min + LongDiv (LongMul (APos, Max - Min) + S shr 1, S)
	else
		GetValue := 0;
end;

function TScrollBar.GetPos (AValue : Integer) : Integer;
var
	T, S	: Integer;
begin
	AValue := Range (AValue, Min, Max);
	T := Ord (Flags and lfPtrDraw <> 0);
	if Flags and lfHorizontal = 0 then
		S := Size.Y - 1 - T shl 1
	else
		S := Size.X - 1 - T shl 1;
	if Max > Min then
		AValue := LongDiv (LongMul (AValue - Min, S) + (Max - Min) shr 1, Max - Min)
	else
		AValue := 0;
	if AValue < 0 then AValue := 0;
	if AValue > S then AValue := S;
	GetPos := T + AValue;
end;

procedure TScrollBar.HandleEvent (var Event : TEvent);
var
	Tracking	: Boolean;
	I,
	P,
	O,
	ClickPart	: Integer;
	Mouse		: TPoint;
	Extent		: TRect;

	function GetPartCode : Integer;
	var
		Mark,
		T, S,
		Part	: Integer;
		V		: Boolean;
	begin
		Part := -1;
		if Extent.Contains (Mouse) then
			begin
				T := Ord (Flags and lfPtrDraw <> 0);
				V := Flags and lfHorizontal = 0;
				if V then
					begin
						S := Size.Y - T shl 1;
						Mark := Mouse.Y
					end
				else
					begin
						S := Size.X - T shl 1;
						Mark := Mouse.X;
					end;
				if Mark = P then
					Part := sbIndicator
				else
					begin
						if Mark < T then
							Part := sbLeftArrow
						else
							if Mark < P then
								Part := sbPageLeft
							else
								begin
									if V then
										T := Size.Y - T
									else
										T := Size.X - T;
									if Mark < T then
										Part := sbPageRight
									else
										Part := sbRightArrow;
								end;
						if V then Inc (Part, 4);
					end;
			end;
		GetPartCode := Part;
	end;

	procedure Clicked;
	begin
		SendBroadcast (cmScrollBarClicked);
	end;

begin
{$IFNDEF Turbo6}
	inherited HandleEvent (Event);
{$ELSE}
	TView.HandleEvent (Event);
{$ENDIF}
	case Event.What of
		evMouseDown	:
			begin
				Clicked;
				MakeLocal (Event.Where, Mouse);
				GetExtent (Extent);
				Extent.Grow (1, 1);
				O := Value;
				P := GetPos (Value);
				ClickPart := GetPartCode;
				if ClickPart <> sbIndicator then
					repeat
						MakeLocal (Event.Where, Mouse);
						if GetPartCode = ClickPart then
							SetValue (Value + ScrollStep (ClickPart));
					until not MouseEvent (Event, evMouseAuto)
				else
					begin
						repeat
							MakeLocal (Event.Where, Mouse);
							Tracking := Extent.Contains (Mouse);
							if Tracking then
								begin
									if Flags and lfHorizontal = 0 then
										I := Mouse.Y
									else
										I := Mouse.X;
								end;
							if I <> P then
								begin
									P := I;
									DrawPos (I);
								end;
						until not MouseEvent (Event, evMouseMove);
						if (Flags and lfTracking <> 0) then
							begin
								if not Tracking then SetValue (O);
							end
						else
							if Tracking then SetValue (GetValue (I));
					end;
				ClearEvent (Event);
			end;
		evKeyDown	:
			if State and sfVisible <> 0 then
				begin
					ClickPart := sbIndicator;
					if Size.Y < Size.X then
						case CtrlToArrow (Event.KeyCode) of
							kbLeft		: ClickPart := sbLeftArrow;
							kbRight		: ClickPart := sbRightArrow;
							kbCtrlLeft	: ClickPart := sbPageLeft;
							kbCtrlRight	: ClickPart := sbPageRight;
							kbHome		: I := Min;
							kbEnd		: I := Max;
						else
							Exit;
						end
					else
						case CtrlToArrow (Event.KeyCode) of
							kbUp		: ClickPart := sbUpArrow;
							kbDown		: ClickPart := sbDownArrow;
							kbPgUp		: ClickPart := sbPageUp;
							kbPgDn		: ClickPart := sbPageDown;
							kbCtrlPgUp	: I := Min;
							kbCtrlPgDn	: I := Max;
						else
							Exit;
						end;
					Clicked;
					if ClickPart <> sbIndicator then
						I := Value + ScrollStep (ClickPart);
					SetValue (I);
					ClearEvent (Event);
				end;
	end;
end;

procedure TScrollBar.ScrollDraw;
begin
	SendBroadcast (cmScrollBarChanged);
end;

function TScrollBar.ScrollStep (Part : Integer) : Integer;
var
	Step	: Integer;
begin
	if Part and 2 = 0 then
		Step := ArStep
	else
		Step := PgStep;
	if Part and 1 = 0 then
		ScrollStep := -Step
	else
		ScrollStep := Step;
end;

function TScrollBar.SetParams (AValue, ATop, AMin, AMax, APgStep, AArStep : Integer) : Integer;
var
	SValue	: Integer;
	STop	: Integer;
	SPgStep	: Integer;
	SMin	: Integer;
	SMax	: Integer;
begin
	if AMax < AMin then AMax := AMin;
	if AValue < AMin then AValue := AMin;
	if APgStep < 1 then APgStep := 1;
	if Flags and lfBoxes = 0 then
		begin
			if AValue >= AMax then AValue := AMax - 1;
			if ATop > AValue then ATop := AValue;
			if ATop + APgStep <= AValue then ATop := AValue - APgStep + 1;
			if ATop < 0 then ATop := 0;
		end
	else
		begin
			if AValue > AMax - APgStep then
				begin
					AValue := AMax - APgStep;
					if AValue < AMin then AValue := AMin;
				end;
			ATop := AValue;
		end;
	SValue := Value;
	STop := Top;
	SPgStep := PgStep;
	SMin := Min;
	SMax := Max;
	Value := AValue;
	Top := ATop;
	PgStep := APgStep;
	Min := AMin;
	Max := AMax;
	ArStep := AArStep;
	if (SValue <> AValue) or (STop <> ATop) then
		begin
			DrawView;
			ScrollDraw;
		end
	else
		if (APgStep <> SPgStep) and (Flags and lfStepDraw <> 0) then
			DrawView
		else
			if (SMin <> AMin) or (SMax <> AMax) then
				DrawView;
	SetParams := Top;
end;

function TScrollBar.SetRange (AMin, AMax : Integer) : Integer;
begin
	SetRange := SetParams (Value, Top, AMin, AMax, PgStep, ArStep);
end;

function TScrollBar.SetStep (APgStep, AArStep : Integer) : Integer;
begin
	SetStep := SetParams (Value, Top, Min, Max, APgStep, AArStep);
end;

function TScrollBar.SetValue (AValue : Integer) : Integer;
begin
	SetValue := SetParams (AValue, Top, Min, Max, PgStep, ArStep);
end;

function TScrollBar.SetLocate (AValue, ATop : Integer) : Integer;
begin
	SetLocate := SetParams (AValue, ATop, Min, Max, PgStep, ArStep);
end;

procedure TScrollBar.Store (var S : TStream);
begin
{$IFNDEF Turbo6}
	inherited Store (S);
{$ELSE}
	TView.Store (S);
{$ENDIF}
	S.Write (Value, SizeOf (Integer) * 6 + SizeOf (Flags));
end;

{*************************************************************** TScroller **}
constructor TScroller.Init (var Bounds : TRect; AHScrollBar, AVScrollBar : PScrollBar);
begin
{$IFNDEF Turbo6}
	inherited Init (Bounds);
{$ELSE}
	TView.Init (Bounds);
{$ENDIF}
	Options := Options or ofSelectable;
	EventMask := EventMask or evBroadcast;
	HScrollBar := AHScrollBar;
	VScrollBar := AVScrollBar;
end;

constructor TScroller.Load (var S : TStream);
begin
{$IFNDEF Turbo6}
	inherited Load (S);
{$ELSE}
	TView.Load (S);
{$ENDIF}
	GetPeerViewPtr (S, HScrollBar);
	GetPeerViewPtr (S, VScrollBar);
	S.Read (Delta, SizeOf (TPoint) * 2);
end;

procedure TScroller.ChangeBounds (var Bounds : TRect);
begin
	SetBounds (Bounds);
	Inc (DrawLock);
	SetLimit (Limit.X, Limit.Y);
	Dec (DrawLock);
	DrawFlag := False;
	DrawView;
end;

procedure TScroller.CheckDraw;
begin
	if (DrawLock = 0) and DrawFlag then
		begin
			DrawFlag := False;
			DrawView;
		end;
end;

procedure TScroller.HandleEvent (var Event : TEvent);
begin
{$IFNDEF Turbo6}
	inherited HandleEvent (Event);
{$ELSE}
	TView.HandleEvent (Event);
{$ENDIF}
	if (Event.What = evBroadcast) and (Event.Command = cmScrollBarChanged) and
	((Event.InfoPtr = HScrollBar) or (Event.InfoPtr = VScrollBar)) then
		ScrollDraw;
end;

procedure TScroller.ScrollDraw;
var
	D	: TPoint;
begin
	if PtrRec (HScrollBar).Seg <> 0 then
		D.X := HScrollBar^.Top
	else
		D.X := 0;
	if PtrRec (VScrollBar).Seg <> 0 then
		D.Y := VScrollBar^.Top
	else
		D.Y := 0;
	if (D.X <> Delta.X) or (D.Y <> Delta.Y) then
		begin
			SetCursor (Cursor.X + Delta.X - D.X, Cursor.Y + Delta.Y - D.Y);
			Delta := D;
			if DrawLock <> 0 then
				DrawFlag := True
			else
				DrawView;
	end;
end;

procedure TScroller.ScrollTo (X, Y : Integer);
begin
	Inc (DrawLock);
	if PtrRec (HScrollBar).Seg <> 0 then HScrollBar^.SetValue (X);
	if PtrRec (VScrollBar).Seg <> 0 then VScrollBar^.SetValue (Y);
	Dec (DrawLock);
	CheckDraw;
end;

procedure TScroller.SetLimit (X, Y : Integer);
begin
	Limit.X := X;
	Limit.Y := Y;
	Inc (DrawLock);
	if PtrRec (HScrollBar).Seg <> 0 then
		HScrollBar^.SetParams (Cursor.X, Delta.X, 0, X - Size.X, Size.X - 1, 1);
	if PtrRec (VScrollBar).Seg <> 0 then
		VScrollBar^.SetParams (Cursor.Y, Delta.Y, 0, Y - Size.Y, Size.Y - 1, 1);
	Dec (DrawLock);
	CheckDraw;
end;

procedure TScroller.SetState (AState : Word; Enable : Boolean);
	procedure ShowSBar (SBar : PScrollBar);
	begin
		if (PtrRec (SBar).Seg <> 0) then
		if GetState (sfActive + sfSelected) then
			SBar^.Show
		else
			SBar^.Hide;
	end;

begin
{$IFNDEF Turbo6}
	inherited SetState (AState, Enable);
{$ELSE}
	TView.SetState (AState, Enable);
{$ENDIF}
	if AState and (sfActive + sfSelected) <> 0 then
		begin
			ShowSBar (HScrollBar);
			ShowSBar (VScrollBar);
		end;
end;

procedure TScroller.Store (var S : TStream);
begin
{$IFNDEF Turbo6}
	inherited Store (S);
{$ELSE}
	TView.Store (S);
{$ENDIF}
	PutPeerViewPtr (S, HScrollBar);
	PutPeerViewPtr (S, VScrollBar);
	S.Write (Delta, SizeOf (TPoint) * 2);
end;

{************************************************************* TListViewer **}
constructor TListViewer.Init (var Bounds : TRect; ANumCols : Word; AHScrollBar, AVScrollBar : PScrollBar);
begin
{$IFNDEF Turbo6}
	inherited Init (Bounds);
{$ELSE}
	TView.Init (Bounds);
{$ENDIF}
	Options := Options or (ofFirstClick + ofSelectable);
	EventMask := EventMask or evBroadcast;
	NumCols := ANumCols;
	Marker := -1;
	HScrollBar := AHScrollBar;
	VScrollBar := AVScrollBar;
	ChangeBounds (Bounds);
end;

constructor TListViewer.Load (var S : TStream);
begin
{$IFNDEF Turbo6}
	inherited Load (S);
{$ELSE}
	TView.Load (S);
{$ENDIF}
	GetPeerViewPtr (S, HScrollBar);
	GetPeerViewPtr (S, VScrollBar);
	S.Read (NumCols, SizeOf (Word) * 5);
end;

procedure TListViewer.ChangeBounds (var Bounds : TRect);
var
	ArStep,
	PgStep	: Integer;
begin
{$IFNDEF Turbo6}
	inherited ChangeBounds (Bounds);
{$ELSE}
	TView.ChangeBounds (Bounds);
{$ENDIF}
	if PtrRec (HScrollBar).Seg <> 0 then HScrollBar^.SetStep (Size.X div NumCols, 1);
	if PtrRec (VScrollBar).Seg <> 0 then
		begin
			if NumCols = 1 then
				begin
					PgStep := Size.Y;
					ArStep := 1;
				end
			else
				begin
					PgStep := Size.Y * NumCols;
					ArStep := Size.Y;
				end;
			VScrollBar^.SetStep (PgStep, ArStep);
		end;
end;

procedure TListViewer.Draw;
var
	I,
	J,
	Item			: Integer;
	NormalColor,
	SelectedColor,
	FocusedColor,
	Color			: Word;
	ColWidth,
	CurCol,
	Indent,
	Shift			: Integer;
	B				: TDrawBuffer;
	SCOff			: TSpecialCharsUser;
begin
	FocusedColor := GetColor (26);
	SelectedColor := GetColor (27);
	NormalColor := GetColor (25);
	if PtrRec (HScrollBar).Seg <> 0 then
		with HScrollBar^ do
			begin
				Indent := Top;
				Shift := Value - Top + 1;
			end
	else
		begin
			Indent := 0;
			Shift := 1;
		end;
	ColWidth := Size.X div NumCols + 1;
	for I := 0 to Size.Y - 1 do
		begin
			for J := 0 to NumCols - 1 do
				begin
					Item := J * Size.Y + I + TopItem;
					CurCol := J * ColWidth;
					if (Focused = Item) and (Range > 0) then
						if (State and (sfSelected + sfActive) = (sfSelected + sfActive)) then
							begin
								Color := FocusedColor;
								SetCursor (CurCol + Shift, I);
								SCOff := scuListCurrent;
							end
						else
							begin
								Color := SelectedColor;
								SCOff := scuNoActive;
							end
					else
						if (Item < Range) and IsSelected (Item) then
							begin
								Color := SelectedColor;
								SCOff := scuListSelect;
							end
						else
							if Item = Marker then
								begin
									Color := GetColor (37);
									SCOff := scuListMarker;
								end
							else
								begin
									Color := NormalColor;
									SCOff := scuNone;
								end;
					MoveChar (B [CurCol], ' ', Lo (Color), ColWidth);
					if Item < Range then
						MoveMarkCStr (B [CurCol], Copy (GetText (Item, ColWidth + Indent), Indent, ColWidth), Color, ColWidth - 1, SCOff);
					MoveChar (B [CurCol + ColWidth - 1], #179, Lo (GetColor (28)), 1);
				end;
			WriteLine (0, I, Size.X, 1, B);
		end;
end;

procedure TListViewer.FocusItem (Item : Integer);
begin
	if Item < 0 then
		Item := 0
	else
		if (Item >= Range) and (Range > 0) then Item := Range - 1;
	Focused := Item;
	if Item < TopItem then
		if NumCols = 1 then
			TopItem := Item
		else
			TopItem := Item - Item mod Size.Y
	else
		if Item >= TopItem + (Size.Y * NumCols) then
			if NumCols = 1 then
				TopItem := Item - Size.Y + 1
			else
				TopItem := Item - Item mod Size.Y - (Size.Y * (NumCols - 1));
	if PtrRec (VScrollBar).Seg <> 0 then VScrollBar^.SetLocate (Item, TopItem);
end;

procedure TListViewer.FocusItemNum (Item : Integer);
begin
	if Range <> 0 then FocusItem (Item);
end;

function TListViewer.GetText (Item : Integer; MaxLen : Integer) : String;
begin
	Abstract;
end;

function TListViewer.IsSelected (Item : Integer) : Boolean;
begin
	IsSelected := Item = Focused;
end;

procedure TListViewer.HandleEvent (var Event : TEvent);
const
	MouseAutosToSkip = 4;
var
	Mouse		: TPoint;
	ColWidth	: Word;
	OldItem,
	NewItem		: Integer;
	Count		: Word;
begin
{$IFNDEF Turbo6}
	inherited HandleEvent (Event);
{$ELSE}
	TView.HandleEvent (Event);
{$ENDIF}
		if Event.What = evMouseDown then
			begin
				ColWidth := Size.X div NumCols + 1;
				OldItem := Focused;
				MakeLocal (Event.Where, Mouse);
				NewItem := Mouse.Y + (Size.Y * (Mouse.X div ColWidth)) + TopItem;
				Count := 0;
				repeat
					if NewItem <> OldItem then FocusItemNum (NewItem);
					OldItem := NewItem;
					MakeLocal (Event.Where, Mouse);
					if MouseInView (Event.Where) then
						NewItem := Mouse.Y + (Size.Y * (Mouse.X div ColWidth)) + TopItem
					else
						begin
							if NumCols = 1 then
								begin
									if Event.What = evMouseAuto then Inc (Count);
									if Count = MouseAutosToSkip then
										begin
											Count := 0;
											if Mouse.Y < 0 then
												NewItem := Focused - 1
											else
												if Mouse.Y >= Size.Y then
													NewItem := Focused + 1;
										end;
								end
							else
								begin
									if Event.What = evMouseAuto then Inc (Count);
									if Count = MouseAutosToSkip then
										begin
											Count := 0;
											if Mouse.X < 0 then
												NewItem := Focused - Size.Y
											else
												if Mouse.X >= Size.X then
													NewItem := Focused + Size.Y
												else
													if Mouse.Y < 0 then
														NewItem := Focused - Focused mod Size.Y
													else
														if Mouse.Y > Size.Y then
															NewItem := Focused - Focused mod Size.Y + Size.Y - 1;
										end
								end;
						end;
				until not MouseEvent (Event, evMouseMove + evMouseAuto);
				FocusItemNum (NewItem);
				if Event.Double and (Range > Focused) then SelectItem (Focused);
				ClearEvent (Event);
			end
		else
			if Event.What = evKeyDown then
				begin
					if (Event.CharCode = ' ') and (Focused < Range) then
						begin
							SelectItem (Focused);
							NewItem := Focused;
						end
					else
						case CtrlToArrow (Event.KeyCode) of
							kbUp		:
								begin
									NewItem := Focused - 1;
									if ShiftState and $3 <> 0 then
										begin
											Dec (TopItem);
											if TopItem < 0 then TopItem := 0;
											if NewItem < 0 then NewItem := Range - 1;
										end;
								end;
							kbDown		:
								begin
									NewItem := Focused + 1;
									if (ShiftState and $3 <> 0) and (TopItem < Range) then
										begin
											Inc (TopItem);
											if NewItem >= Range then NewItem := 0;
										end;
								end;
							kbRight		:
								if NumCols > 1 then
									NewItem := Focused + Size.Y
								else
									Exit;
							kbLeft		:
								if NumCols > 1 then
									NewItem := Focused - Size.Y
								else
									Exit;
							kbPgDn		: NewItem := Focused + Size.Y * NumCols;
							kbPgUp		: NewItem := Focused - Size.Y * NumCols;
							kbHome		: NewItem := TopItem;
							kbEnd		: NewItem := TopItem + (Size.Y * NumCols) - 1;
							kbCtrlEnd	: NewItem := Range - 1;
							kbCtrlHome	: NewItem := 0;
							kbCtrlEnter	:
								if Marker <> - 2 then
									begin
										NewItem := Marker;
										if Marker = Focused then
											Marker := - 1
										else
											Marker := Focused;
										if NewItem < 0 then NewItem := Focused;
									end
								else
									Exit;
						else
							Exit;
						end;
					FocusItemNum (NewItem);
					ClearEvent (Event);
				end
			else
				if Event.What = evBroadcast then
					if Options and ofSelectable <> 0 then
						if (Event.Command = cmScrollBarClicked) and ((Event.InfoPtr = HScrollBar) or (Event.InfoPtr = VScrollBar)) then
							Select
						else
							if (Event.Command = cmScrollBarChanged) then
								begin
									if (VScrollBar = Event.InfoPtr) then
										begin
											FocusItemNum (VScrollBar^.Value);
											DrawView;
										end
									else
										if (HScrollBar = Event.InfoPtr) then
											DrawView;
								end;
end;

procedure TListViewer.SelectItem (Item : Integer);
begin
	SendBroadcast (cmListItemSelected);
end;

procedure TListViewer.SetRange (ARange : Integer);
begin
	Range := ARange;
	if PtrRec (VScrollBar).Seg <> 0 then
		begin
			if Focused > ARange then Focused := 0;
			VScrollbar^.SetParams (Focused, TopItem, 0, ARange, VScrollBar^.PgStep, VScrollBar^.ArStep);
		end;
end;

procedure TListViewer.SetState (AState : Word; Enable : Boolean);

	procedure ShowSBar (SBar : PScrollBar);
	begin
		if PtrRec (SBar).Seg <> 0 then
			if GetState (sfActive) then
				SBar^.Show
			else
				SBar^.Hide;
	end;

begin
{$IFNDEF Turbo6}
	inherited SetState (AState, Enable);
{$ELSE}
	TView.SetState (AState, Enable);
{$ENDIF}
	if AState and (sfSelected + sfActive) <> 0 then
		begin
			ShowSBar (HScrollBar);
			ShowSBar (VScrollBar);
			DrawView;
		end;
end;

procedure TListViewer.Store (var S : TStream);
begin
{$IFNDEF Turbo6}
	inherited Store (S);
{$ELSE}
	TView.Store (S);
{$ENDIF}
	PutPeerViewPtr (S, HScrollBar);
	PutPeerViewPtr (S, VScrollBar);
	S.Write (NumCols, SizeOf (Word) * 5);
end;

{****************************************************************** TGroup **}
constructor TGroup.Init (var Bounds : TRect);
begin
{$IFNDEF Turbo6}
	inherited Init (Bounds);
{$ELSE}
	TView.Init (Bounds);
{$ENDIF}
	Options := Options or (ofSelectable + ofBuffered);
	GetExtent (Clip);
	EventMask := $FFFF;
end;

procedure TGroup.ClearPending;
var
	Event	: TEvent;
begin
	while SelfEventAvail do
		begin
			GetEvent (Event);
			ClearEvent (Event);
		end;
	PendTail := 0;
	PendHead := 0;
end;

function TGroup.SelfEventAvail : Boolean;
begin
	SelfEventAvail := (PtrRec (Pending).Seg <> 0) and (PendTail <> PendHead);
end;

procedure TGroup.PutSelfEvent (var Event : TEvent);
begin
	if PtrRec (Pending).Seg = 0 then Exit;
	Pending^ [PendTail] := Event;
	Inc (PendTail);
	if PendTail = PendingSize then PendTail := 0;
	if PendTail = PendHead then
		begin
			Dec (PendTail);
			if PendTail < 0 then PendTail := PendingSize - 1;
		end;
end;

procedure TGroup.PutEvent (var Event : TEvent);
begin
	if State and sfModal <> 0 then
		PutSelfEvent (Event)
	else
{$IFNDEF Turbo6}
		inherited PutEvent (Event);
{$ELSE}
		TView.PutEvent (Event);
{$ENDIF}
end;

procedure TGroup.GetEvent (var Event : TEvent);
begin
	if SelfEventAvail then
		begin
			Event := Pending^ [PendHead];
			Inc (PendHead);
			if PendHead >= PendingSize then PendHead := 0;
		end
	else
{$IFNDEF Turbo6}
		inherited GetEvent (Event);
{$ELSE}
		TView.GetEvent (Event);
{$ENDIF}
end;

constructor TGroup.Load (var S : TStream);
var
	FixupSave	: PFixupList;
	Count,
	I			: Integer;
	P, Q		: ^Pointer;
	V			: PView;
	OwnerSave	: PGroup;
begin
{$IFNDEF Turbo6}
	inherited Load (S);
{$ELSE}
	TView.Load (S);
{$ENDIF}
	if State and sfModal <> 0 then
		begin
			New (Pending);
			S.Read (PendHead, SizeOf (PendHead) + SizeOf (PendTail));
			S.Read (Pending^, SizeOf (Pending^));
		end;
	GetExtent (Clip);
	OwnerSave := OwnerGroup;
	OwnerGroup := @Self;
	FixupSave := FixupList;
	S.Read (Palette, SizeOf (Palette));
	S.Read (Count, SizeOf (Word));
	asm
		MOV		CX, Count
		SHL		CX, 1
		SHL		CX, 1
		SUB		SP, CX
		MOV		FixupList.Word [0], SP
		MOV		FixupList.Word [2], SS
		MOV		DI, SP
		PUSH	SS
		POP		ES
		XOR		AL, AL
		CLD
		REP		STOSB
	end;
	for I := 1 to Count do
		InsertView (PView (S.Get), NIL);
	V := Last;
	for I := 1 to Count do
		begin
			V := V^.Next;
			P := FixupList^ [I];
			while PtrRec (P).Seg <> 0 do
				begin
					Q := P;
					P := P^;
					Q^ := V;
				end;
		end;
	OwnerGroup := OwnerSave;
	FixupList := FixupSave;
	GetSubViewPtr (S, V);
	SetCurrent (V, NormalSelect);
	if PtrRec (OwnerGroup).Seg = 0 then Awaken;
end;

destructor TGroup.Done;
var
	P,
	T	: PView;
begin
{$IFDEF UseDark}
	CloseFork;
{$ENDIF}
	Hide;
	P := Last;
	if PtrRec (P).Seg <> 0 then
		repeat
			T := P^.Prev;
			Dispose (P, Done);
			P := T;
		until PtrRec (Last).Seg = 0;
	FreeBuffer;
	if PtrRec (Pending).Seg <> 0 then Dispose (Pending);
{$IFNDEF Turbo6}
	inherited Done;
{$ELSE}
	TView.Done;
{$ENDIF}
end;

function TGroup.At (Index : Integer) : PView; assembler;
asm
	LES		DI, Self
	LES		DI, ES:[DI].TGroup.Last
	MOV		CX, Index
@1:	LES		DI, ES:[DI].TView.Next
	LOOP	@1
	MOV		AX, DI
	MOV		DX, ES
end;

procedure TGroup.Awaken;
	procedure DoAwaken (P : PView); far;
	begin
		P^.Awaken;
	end;
begin
	ForEach (@DoAwaken);
end;

procedure TGroup.ChangeBounds (var Bounds : TRect);
var
	D	: TPoint;

	procedure DoCalcChange (P : PView); far;
	var
		R	: TRect;
	begin
		P^.CalcBounds (R, D);
		P^.ChangeBounds (R);
	end;

begin
	D.X := Bounds.B.X - Bounds.A.X - Size.X;
	D.Y := Bounds.B.Y - Bounds.A.Y - Size.Y;
	if Longint (D) = 0 then
		begin
			SetBounds (Bounds);
			DrawView;
		end
	else
		begin
			FreeBuffer;
			SetBounds (Bounds);
			GetExtent (Clip);
			GetBuffer;
			Lock;
			ForEach (@DoCalcChange);
			Unlock;
		end;
end;

function TGroup.DataSize : Word;
var
	T	: Word;

	procedure AddSubviewDataSize (P : PView); far;
	begin
		Inc (T, P^.DataSize);
	end;

begin
	T := 0;
	ForEach (@AddSubviewDataSize);
	DataSize := T;
end;

procedure TGroup.Delete (P : PView);
begin
	P^.Hide;
	RemoveView (P);
	P^.Owner := NIL;
	P^.Next := NIL;
end;

procedure TGroup.Draw;
var
	R	: TRect;
begin
	if PtrRec (Buffer).Seg = 0 then
		begin
			GetBuffer;
			if PtrRec (Buffer).Seg <> 0 then
				begin
					Inc (LockFlag);
					Redraw;
					Dec (LockFlag);
				end;
		end;
	if PtrRec (Buffer).Seg <> 0 then
		WriteBuf (0, 0, Size.X, Size.Y, Buffer^)
	else
		begin
			GetClipRect (Clip);
			Redraw;
			GetExtent (Clip);
		end;
end;

procedure TGroup.DrawSubViews (P, Bottom : PView);
begin
	while P <> Bottom do
		begin
			P^.DrawView;
			P := P^.NextView;
		end;
end;

procedure TGroup.EndModal (Command : Word);
begin
	if State and sfModal <> 0 then
		EndState := Command
	else
{$IFNDEF Turbo6}
		inherited EndModal (Command);
{$ELSE}
		TView.EndModal (Command);
{$ENDIF}
end;

procedure TGroup.EventError (var Event : TEvent);
begin
	if PtrRec (Owner).Seg <> 0 then
{$IFDEF EventMultiHandlers}
		begin
			Owner^.HandleEvent (Event);
			if Event.What <> evNothing then
				Owner^.EventError (Event);
		end
{$ELSE}
		Owner^.EventError (Event)
{$ENDIF}
{$IFDEF KillLostEvents}
	else
		ClearEvent (Event);
{$ENDIF}
end;

function TGroup.Execute : Word;
var
	E	: TEvent;
begin
	repeat
		EndState := 0;
			repeat
				GetEvent (E);
				HandleEvent (E);
				if E.What <> evNothing then EventError (E);
			until EndState <> 0;
	until Valid (EndState);
	Execute := EndState;
end;

function TGroup.ExecView (P : PView) : Word;
var
	SaveOptions		: Word;
	SaveOwner		: PGroup;
	SaveTopView		: PView;
	SaveCurrent		: PView;
	SaveCommands	: TCommandSet;
begin
	if PtrRec (P).Seg <> 0 then
		begin
			SaveOptions := P^.Options;
			SaveOwner := P^.Owner;
			SaveTopView := TheTopView;
			SaveCurrent := Current;
			GetCommands (SaveCommands);
			TheTopView := P;
			P^.Options := P^.Options and not ofSelectable;
			P^.SetState (sfModal, True);
			SetCurrent (P, EnterSelect);
			if PtrRec (SaveOwner).Seg = 0 then Insert (P);
			ExecView := P^.Execute;
			if PtrRec (SaveOwner).Seg = 0 then Delete (P);
			SetCurrent (SaveCurrent, LeaveSelect);
			P^.SetState (sfModal, False);
			P^.Options := SaveOptions;
			if TheTopView = P then
				begin
					TheTopView := SaveTopView;
					SetCommands (SaveCommands);
				end;
		end
	else
		ExecView := cmCancel;
end;

function TGroup.First : PView;
begin
	if PtrRec (Last).Seg = 0 then
		First := NIL
	else
		First := Last^.Next;
end;

function TGroup.FirstMatch (AState : Word; AOptions : Word) : PView;

	function Matches (P : PView) : Boolean; far;
	begin
		Matches := (P^.State and AState = AState) and (P^.Options and AOptions = AOptions);
	end;

begin
	FirstMatch := FirstThat (@Matches);
end;

function TGroup.FirstThat (P : Pointer) : PView; assembler;
var
	ALast	: Pointer;
asm
	LES		DI, Self
	LES		DI, ES:[DI].TGroup.Last
	MOV		AX, ES
	OR		AX, DI
	JE		@3
	MOV		WORD PTR ALast [2], ES
	MOV		WORD PTR ALast [0], DI
@1:	LES		DI, ES:[DI].TView.Next
	PUSH	ES
	PUSH	DI
	PUSH	ES
	PUSH	DI
	PUSH	WORD PTR [BP]
	CALL	P
	POP		DI
	POP		ES
	OR		AL, AL
	JNE		@2
	CMP		DI, WORD PTR ALast [0]
	JNE		@1
	MOV		AX, ES
	CMP		AX, WORD PTR ALast [2]
	JNE		@1
	XOR		DI, DI
	MOV		ES, DI
@2:	MOV		SP, BP
@3:	MOV		AX, DI
	MOV		DX, ES
end;

procedure TGroup.ForEach (P : Pointer); assembler;
var
	ALast	: Pointer;
asm
	LES		DI, Self
	LES		DI, ES:[DI].TGroup.Last
	MOV		AX, ES
	OR		AX, DI
	JE		@4
	MOV		WORD PTR ALast [2], ES
	MOV		WORD PTR ALast [0], DI
	LES		DI, ES:[DI].TView.Next
@1:	CMP		DI, WORD PTR ALast [0]
	JNE		@2
	MOV		AX, ES
	CMP		AX, WORD PTR ALast [2]
	JE		@3
@2:	PUSH	WORD PTR ES:[DI].TView.Next [2]
	PUSH	WORD PTR ES:[DI].TView.Next [0]
	PUSH	ES
	PUSH	DI
	PUSH	WORD PTR [BP]
	CALL	P
	POP		DI
	POP		ES
	JMP		@1
@3:	PUSH	WORD PTR [BP]
	CALL	P
@4:
end;

procedure TGroup.FreeBuffer;
begin
	if PtrRec (Buffer).Seg <> 0 then
		FreeBufMem (Pointer (Buffer));
end;

procedure TGroup.GetBuffer; assembler;
asm
	LES		DI, Self
	TEST	ES:[DI].State, sfExposed
	JZ		@1
	TEST	ES:[DI].Options, ofBuffered
	JZ		@1
	MOV		AX, ES:[DI].Buffer.Word [2]
	TEST	AX, AX
	JNZ		@1
	MOV		AX, ES:[DI].TView.Size.X
	MUL		ES:[DI].TView.Size.Y
	JO		@1
	SHL		AX, 1
	JC		@1
	JS		@1
	LEA		DI, [DI].TView.Buffer
	PUSH	ES
	PUSH	DI
	PUSH	AX
	CALL	NewCache
@1:
end;

procedure TGroup.GetData (var Rec);
type
	Bytes	= array [0..65534] of Byte;
var
	I	: Word;
	V	: PView;
begin
	I := 0;
	if PtrRec (Last).Seg <> 0 then
		begin
			V := Last;
			repeat
				V^.GetData (Bytes (Rec) [I]);
				Inc (I, V^.DataSize);
				V := V^.Prev;
			until V = Last;
		end;
end;

function TGroup.GetHelpCtx : Word;
var
	H	: Word;
begin
	H := hcNoContext;
	if PtrRec (Current).Seg <> 0 then H := Current^.GetHelpCtx;
	if H = hcNoContext then
{$IFNDEF Turbo6}
		H := inherited GetHelpCtx;
{$ELSE}
		H := TView.GetHelpCtx;
{$ENDIF}
	GetHelpCtx := H;
end;

procedure TGroup.GetSubViewPtr (var S : TStream; var P);
var
	Index	: Word;
begin
	S.Read (Index, SizeOf (Word));
	if Index > 0 then
		Pointer (P) := At (Index)
	else
		Pointer (P) := NIL;
end;

procedure TGroup.HandleEvent (var Event : TEvent);

	function DoHandleEvent (P : PView) : Boolean; far;
	var
		B	: Boolean;
	begin
		DoHandleEvent := False;
		if (PtrRec (P).Seg = 0) or ((P^.State and sfDisabled <> 0) and
		((Event.What and (PositionalEvents or FocusedEvents) <> 0))) then
			Exit;
		with P^ do
			begin
				case Phase of
					phPreProcess	: if Options and ofPreProcess = 0 then Exit;
					phPostProcess	: if Options and ofPostProcess = 0 then Exit;
				end;
				B := State and (sfDestroyed or sfRunning) = 0;
				State := State or sfRunning;
				if Event.What and EventMask <> 0 then HandleEvent (Event);
				DoHandleEvent := Event.What = evNothing;
				if B then
					begin
						State := State and not sfRunning;
						if State and sfDestroyed <> 0 then
							Free
						else
							State := State and not sfDestroyed;
					end;
			end;
	end;

	function ContainsMouse (P : PView) : Boolean; far;
	begin
		ContainsMouse := (P^.State and sfVisible <> 0) and P^.MouseInView (Event.Where);
	end;

begin
{$IFNDEF Turbo6}
	inherited HandleEvent (Event);
{$ELSE}
	TView.HandleEvent (Event);
{$ENDIF}
	if Event.What and FocusedEvents <> 0 then
		begin
			Phase := phPreProcess;
			if Seg (FirstThat (@DoHandleEvent)^) <> 0 then Exit;
			Phase := phFocused;
			if DoHandleEvent (Current) then Exit;
			Phase := phPostProcess;
			FirstThat (@DoHandleEvent);
		end
	else
		begin
			Phase := phFocused;
			if (Event.What and PositionalEvents <> 0) then
				DoHandleEvent (FirstThat (@ContainsMouse))
			else
				FirstThat (@DoHandleEvent);
		end;
end;

function TGroup.IndexOf (P : PView) : Integer; assembler;
asm
	LES		DI, Self
	LES		DI, ES:[DI].TGroup.Last
	MOV		AX, ES
	OR		AX, DI
	JE		@3
	MOV		CX, DI
	MOV		BX, ES
	XOR		AX, AX
@1:	INC		AX
	LES		DI, ES:[DI].TView.Next
	MOV		DX, ES
	CMP		DI, P.Word [0]
	JNE		@2
	CMP		DX, P.Word [2]
	JE		@3
@2:	CMP		DI, CX
	JNE		@1
	CMP		DX, BX
	JNE		@1
	XOR		AX, AX
@3:
end;

procedure TGroup.Insert (P : PView);
begin
	InsertBefore (P, First);
end;

procedure TGroup.InsertBefore (P, Target : PView);
var
	SaveState	: Word;
begin
	if (PtrRec (P).Seg <> 0) and (PtrRec (P^.Owner).Seg = 0) and ((PtrRec (Target).Seg = 0) or (Target^.Owner = @Self)) then
		begin
			Lock;
			if P^.Options and ofCenterX <> 0 then
				P^.Origin.X := (Size.X - P^.Size.X) shr 1;
			if P^.Options and ofCenterY <> 0 then
				P^.Origin.Y := (Size.Y - P^.Size.Y) shr 1;
			SaveState := P^.State;
			P^.Hide;
			InsertView (P, Target);
			if SaveState and sfVisible <> 0 then P^.Show;
			UnLock;
		end;
end;

procedure TGroup.InsertView (P, Target : PView);
begin
	if PtrRec (P).Seg <> 0 then
		begin
			P^.Owner := @Self;
			if PtrRec (Target).Seg <> 0 then
				begin
					Target := Target^.Prev;
					P^.Next := Target^.Next;
					Target^.Next := P;
				end
			else
				begin
					if PtrRec (Last).Seg = 0 then
						P^.Next := P
					else
						begin
							P^.Next := Last^.Next;
							Last^.Next := P;
						end;
					Last := P;
				end;
		end;
end;

procedure TGroup.Lock;
begin
	if (PtrRec (Buffer).Seg <> 0) then Inc (LockFlag);
end;

procedure TGroup.PutSubViewPtr (var S : TStream; P : PView);
var
	Index	: Word;
begin
	if PtrRec (P).Seg = 0 then
		Index := 0
	else
		Index := IndexOf (P);
	S.Write (Index, SizeOf (Word));
end;

procedure TGroup.Redraw;
begin
	DrawSubViews (First, NIL);
end;

procedure TGroup.RemoveView (P : PView); assembler;
asm
	PUSH	DS
	LDS		SI, Self
	LES		DI, P
	LDS		SI, DS:[SI].TGroup.Last
	PUSH	BP
	MOV		AX, DS
	OR		AX, SI
	JE		@7
	MOV		AX, SI
	MOV		DX, DS
	MOV		BP, ES
@1:	MOV		BX, WORD PTR DS:[SI].TView.Next [0]
	MOV		CX, WORD PTR DS:[SI].TView.Next [2]
	CMP		CX, BP
	JE		@5
@2:	CMP		CX, DX
	JE		@4
@3:	MOV		SI, BX
	MOV		DS, CX
	JMP		@1
@4:	CMP		BX, AX
	JNE		@3
	JMP		@7
@5:	CMP		BX, DI
	JNE		@2
	MOV		BX, WORD PTR ES:[DI].TView.Next [0]
	MOV		CX, WORD PTR ES:[DI].TView.Next [2]
	MOV		DS :WORD PTR [SI].TView.Next [0], BX
	MOV		DS :WORD PTR [SI].TView.Next [2], CX
	CMP		DX, BP
	JNE		@7
	CMP		AX, DI
	JNE		@7
	CMP		CX, BP
	JNE		@6
	CMP		BX, DI
	JNE		@6
	XOR		SI, SI
	MOV		DS, SI
@6:	POP		BP
	PUSH	BP
	LES		DI, Self
	MOV		WORD PTR ES:[DI].TView.Last [0], SI
	MOV		WORD PTR ES:[DI].TView.Last [2], DS
@7:	POP		BP
	POP		DS
end;

procedure TGroup.ResetCurrent;
begin
	SetCurrent (FirstMatch (sfVisible, ofSelectable), NormalSelect);
end;

procedure TGroup.ResetCursor;
begin
	if PtrRec (Current).Seg <> 0 then Current^.ResetCursor;
end;

function TGroup.FindNext (Forwards : Boolean) : PView;
var
	P	: PView;
begin
	FindNext := NIL;
	if PtrRec (Current).Seg <> 0 then
		begin
			P := Current;
			repeat
				if Forwards then
					P := P^.Next
				else
					P := P^.Prev;
			until ((P^.State and (sfVisible + sfDisabled) = sfVisible)
			and (P^.Options and ofSelectable <> 0)) or (P = Current);
			if P <> Current then FindNext := P;
		end;
end;

function TGroup.FocusNext (Forwards : Boolean) : Boolean;
var
	P	: PView;
begin
	P := FindNext (Forwards);
	FocusNext := True;
	if PtrRec (P).Seg <> 0 then FocusNext := P^.Focus;
end;

procedure TGroup.SelectNext (Forwards : Boolean);
var
	P	: PView;
begin
	if PtrRec (Current).Seg <> 0 then
		begin
			Lock;
			P := Current;
			repeat
				if Forwards then
					P := P^.Next
				else
					P := P^.Prev;
			until ((P^.State and (sfVisible + sfDisabled) = sfVisible) and (P^.Options and ofSelectable <> 0)) or (P = Current);
			P^.Select;
			UnLock;
		end;
end;

procedure TGroup.SetCurrent (P : PView; Mode : SelectMode);

	procedure SelectView (P : PView; Enable : Boolean);
	begin
		if PtrRec (P).Seg <> 0 then P^.SetState (sfSelected, Enable);
	end;

	procedure FocusView (P : PView; Enable : Boolean);
	begin
		if (State and sfFocused <> 0) and (PtrRec (P).Seg <> 0) then
			P^.SetState (sfFocused, Enable);
	end;

begin
	if Current <> P then
		begin
			FocusView (Current, False);
			if Mode <> EnterSelect then SelectView (Current, False);
			if Mode <> LeaveSelect then SelectView (P, True);
			FocusView (P, True);
			Current := P;
		end;
end;

procedure TGroup.SetData (var Rec);
var
	I		: Word;
	V		: PView;
	Bytes	: array [0..65534] of Byte absolute Rec;
begin
	I := 0;
	if PtrRec (Last).Seg <> 0 then
		begin
			V := Last;
			repeat
				V^.SetData (Bytes [I]);
				Inc (I, V^.DataSize);
				V := V^.Prev;
			until V = Last;
		end;
end;

procedure TGroup.SetState (AState : Word; Enable : Boolean);

	procedure DoSetState (P : PView); far;
	begin
		P^.SetState (AState, Enable);
	end;

	procedure DoExpose (P : PView); far;
	begin
		if P^.State and sfVisible <> 0 then P^.SetState (sfExposed, Enable);
	end;

begin
{$IFNDEF Turbo6}
	inherited SetState (AState, Enable);
{$ELSE}
	TView.SetState (AState, Enable);
{$ENDIF}
	case AState of
		sfActive,
		sfDragging	:
			begin
				Lock;
				ForEach (@DoSetState);
				Unlock;
			end;
		sfFocused	:
			if PtrRec (Current).Seg <> 0 then Current^.SetState (sfFocused, Enable);
		sfExposed	:
			begin
				ForEach (@DoExpose);
				if not Enable then FreeBuffer;
			end;
		sfModal :
			if Enable <> (PtrRec (Pending).Seg <> 0) then
				begin
					ClearPending;
					if Enable then
						New (Pending)
					else
						begin
							Dispose (Pending);
							Pending := NIL;
						end;
				end;
	end;
end;

procedure TGroup.Store (var S : TStream);
var
	Count		: Integer;
	OwnerSave	: PGroup;

	procedure DoPut (P : PView); far;
	begin
		S.Put (P);
	end;

begin
{$IFNDEF Turbo6}
	inherited Store (S);
{$ELSE}
	TView.Store (S);
{$ENDIF}
	if State and sfModal <> 0 then
		begin
			S.Write (PendHead, SizeOf (PendHead) + SizeOf (PendTail));
			S.Write (Pending^, SizeOf (Pending^));
		end;
	OwnerSave := OwnerGroup;
	OwnerGroup := @Self;
	S.Write (Palette, SizeOf (Palette));
	Count := IndexOf (Last);
	S.Write (Count, SizeOf (Word));
	ForEach (@DoPut);
	PutSubViewPtr (S, Current);
	OwnerGroup := OwnerSave;
end;

procedure TGroup.Unlock;
	begin
		if LockFlag > 0 then
			begin
				Dec (LockFlag);
				if LockFlag = 0 then DrawView;
			end;
	end;

function TGroup.Valid (Command : Word) : Boolean;

	function IsInvalid (P : PView) : Boolean; far;
		begin
			IsInvalid := not P^.Valid (Command);
		end;

begin
	if Command = cmReleasedFocus then
		if (PtrRec (Current).Seg <> 0) and (Current^.Options and ofValidate <> 0) then
			Valid := Current^.Valid (Command)
		else
			Valid := True
	else
		Valid := Seg (FirstThat (@IsInvalid)^) = 0;
end;

function TGroup.Search (X, Y : Integer) : PView;
var
	Min		: Integer;
	N		: PView;

	procedure Calc (P : PView); far;
	var
		Max	: Integer;
	begin
		if (P <> Current) and (P^.Options and ofSelectable <> 0) and (P^.State and sfVisible <> 0) then
			begin
				with P^ do
					Max := sqr (Origin.X + Size.X shr 1 - X) + sqr (Origin.Y + Size.Y shr 1 - Y);
				if Max < Min then
					begin
						Min := Max;
						N := P;
					end;
			end;
	end;
begin
	Min := MaxInt;
	N := NIL;
	ForEach (@Calc);
	Search := N;
end;

procedure TGroup.InsertSoftGrid;
var
	P	: PSoftGrid;
begin
	New (P, Init (Self));
end;

{$IFDEF UseDark}
function TGroup.Fork (StackSize, StackFrames : Word) : Boolean;
begin
	if (TID = 0) and Dark.Fork (StackSize, StackFrames + 1) then
		begin
			TID := SSeg;
			Fork := True;
		end
	else
		Fork := False;
end;

procedure TGroup.ForkView (P : PView);
var
	Event	: TEvent;
	B		: Boolean;
begin
	if (PtrRec (P).Seg <> 0) and Fork (8192, 2) then
		begin
			B := PtrRec (P^.Owner).Seg = 0;
			if B then Insert (P);
			repeat
				Event.What := evCommand;
				Event.Command := cmDarkStep;
				P^.HandleEvent (Event);
			until Event.What <> evNothing;
			if B then P^.Destroy;
			CloseFork;
		end;
end;

procedure TGroup.CloseFork;
var
	ATID	: Word;
begin
	ATID := TID;
	TID := 0;
	if testTID (ATID) then
		killTID (ATID);
end;
{$ENDIF}
{***************************************************************** TWindow **}
constructor TWindow.Init (var Bounds : TRect; ATitle : TTitleStr; ANumber : Integer);
begin
	TGroup.Init (Bounds);
	State := State or sfShadow;
	Options := Options or (ofSelectable or ofTopSelect);
	GrowMode := gfGrowAll + gfGrowRel;
	Flags := wfMove or wfGrow or wfClose or wfZoom or wfWinFrame or wfScrolled;
	Title := GenStr (@ATitle);
	Number := ANumber;
	Palette := 20;
	InitFrame;
	Insert (Frame);
	GetBounds (ZoomRect);
end;

constructor TWindow.Load (var S : TStream);
begin
	TGroup.Load (S);
	S.Read (Flags, SizeOf (Flags) + SizeOf (TRect) + SizeOf (Number));
	GetSubViewPtr (S, Frame);
	Title := S.ReadStr;
end;

destructor TWindow.Done;
begin
	TGroup.Done;
	DisposeStr (Title);
end;

procedure TWindow.Close;
var
	Event	: TEvent;
begin
	if Valid (cmClose) then
		begin
			With Event do
				begin
					What := evCommand;
					Command := cmCancel;
					InfoPtr := @Self;
				end;
			TGroup.HandleEvent (Event);
			Destroy;
		end;
end;

function TWindow.GetTitle (MaxSize : Integer) : TTitleStr;
begin
	if PtrRec (Title).Seg <> 0 then
		GetTitle := Title^
	else
		GetTitle := '';
end;

procedure TWindow.HandleEvent (var Event : TEvent);
var
	Limits	: TRect;
	Min,
	Max		: TPoint;
begin
	TGroup.HandleEvent (Event);
	if (Event.What = evCommand) then
		case Event.Command of
			cmResize :
				if Flags and (wfMove + wfGrow) <> 0 then
					begin
						Owner^.GetExtent (Limits);
						Limits.B.X := MaxViewWidth;
						SizeLimits (Min, Max);
						DragView (Event, DragMode or (Flags and (wfMove + wfGrow)), Limits, Min, Max);
					end;
			cmClose :
				if Flags and wfClose <> 0 then
					if State and sfModal = 0 then
						Close
					else
						SendCommand (cmCancel);
			cmZoom	:
				if Flags and wfZoom <> 0 then
					Zoom;
		else
			Exit;
		end
	else
		if Event.What = evKeyDown then
			case Event.KeyCode of
				kbTab		: FocusNext (False);
				kbShiftTab	: FocusNext (True);
			else
				Exit;
			end
		else
			if (Event.What = evBroadcast) and (Event.Command = cmSelectWindowNum)
			and (Event.InfoInt = Number) and (Options and ofSelectable <> 0) then
				Select
			else
				Exit;
	ClearEvent (Event);
end;

procedure TWindow.InitFrame;
var
	R	: TRect;
begin
	GetExtent (R);
	Frame := New (PFrame, Init (R));
end;

procedure TWindow.SetState (AState : Word; Enable : Boolean);
var
	WindowCommands	: TCommandSet;
begin
{$IFNDEF Turbo6}
	inherited SetState (AState, Enable);
{$ELSE}
	TGroup.SetState (AState, Enable);
{$ENDIF}
	if AState = sfSelected then
		begin
			SetState (sfActive, Enable);
			WindowCommands := [cmNext, cmPrev];
			if Flags and wfGrow + wfMove <> 0 then
				WindowCommands := WindowCommands + [cmResize];
			if Flags and wfClose <> 0 then
				WindowCommands := WindowCommands + [cmClose];
			if Flags and wfZoom <> 0 then
				WindowCommands := WindowCommands + [cmZoom];
			if Enable then
				EnableCommands (WindowCommands)
			else
				DisableCommands (WindowCommands);
		end;
end;

function TWindow.StandardScrollBar (AOptions : Word) : PScrollBar;
var
	R	: TRect;
	S	: PScrollBar;
begin
	GetExtent (R);
	if AOptions and sbVertical = 0 then
		R.Assign (R.A.X + 2, R.B.Y - 1, R.B.X - 2, R.B.Y)
	else
		R.Assign (R.B.X - 1, R.A.Y + 1, R.B.X, R.B.Y - 1);
	if Lo (AOptions) = 0 then AOptions := AOptions or lfDefault;
	S := New (PScrollBar, Init (R, Lo (AOptions)));
	Insert (S);
	if AOptions and sbHandleKeyboard <> 0 then
		S^.Options := S^.Options or ofPostProcess;
	StandardScrollBar := S;
end;

procedure TWindow.SizeLimits (var Min, Max : TPoint);
begin
{$IFNDEF Turbo6}
	inherited SizeLimits (Min, Max);
{$ELSE}
	TView.SizeLimits (Min, Max);
{$ENDIF}
	Min.X := MinWinSize.X;
	Min.Y := MinWinSize.Y;
	Max.X := MaxViewWidth;
end;

procedure TWindow.Store (var S : TStream);
begin
{$IFNDEF Turbo6}
	inherited Store (S);
{$ELSE}
	TGroup.Store (S);
{$ENDIF}
	S.Write (Flags, SizeOf (Flags) + SizeOf (TRect) + SizeOf (Number));
	PutSubViewPtr (S, Frame);
	S.WriteStr (Title);
end;

procedure TWindow.Zoom;
var
	R	: TRect;
begin
	if Longint (Size) <> Longint (Owner^.Size) then
		begin
			GetBounds (ZoomRect);
			Owner^.GetExtent (R);
			Locate (R);
		end
	else
		Locate (ZoomRect);
end;

{***************************************************************** TButton **}
constructor TButton.Init (var Bounds : TRect; ATitle : TTitleStr; ACommand : Word; AFlags : Word);
begin
{$IFNDEF Turbo6}
	inherited Init (Bounds);
{$ELSE}
	TView.Init (Bounds);
{$ENDIF}
	Options := Options or (ofFirstClick + ofPreProcess + ofPostProcess + ofSelectable);
	EventMask := EventMask or evBroadcast;
	if not CommandEnabled (ACommand) then State := State or sfDisabled;
	Flags := AFlags;
	if AFlags and bfDefault <> 0 then
		AmDefault := True
	else
		AmDefault := False;
	Title := GenStr (@ATitle);
	Command := ACommand;
end;

constructor TButton.Load (var S : TStream);
begin
{$IFNDEF Turbo6}
	inherited Load (S);
{$ELSE}
	TView.Load (S);
{$ENDIF}
	Title := S.ReadStr;
	S.Read (Command, SizeOf (Command) + SizeOf (Flags) + SizeOf (AmDefault) + SizeOf (DownIs));
	if not CommandEnabled (Command) then
		State := State or sfDisabled
	else
		State := State and not sfDisabled;
end;

destructor TButton.Done;
begin
	DisposeStr (Title);
{$IFNDEF Turbo6}
	inherited Done;
{$ELSE}
	TView.Done;
{$ENDIF}
end;

procedure TButton.Draw;
begin
	DrawState (DownIs);
end;

procedure TButton.DrawState (Down : Boolean);
var
	CButton,
	CShadow	: Word;
	I, S,
	Y, T	: Integer;
	B		: TDrawBuffer;

	procedure DrawTitle;
	var
		L, N	: Integer;
		SCOff	: TSpecialCharsUser;
	begin
		if Flags and bfLeftJust <> 0 then
			L := 2
		else
			begin
				N := CStrLen (Title^);
				L := S - N + 1;
				if Flags and bfRightJust = 0 then L := L shr 1;
				if L < 2 then L := 2;
			end;
		MoveCStr (B [L + Ord (Down)], Title^, CButton);
		if Flags and bfNoPoints = 0 then
			begin
				if Down then
					SCOff := scuButtonPress
				else
					if State and sfSelected <> 0 then
						SCOff := scuButtonSelect
					else
						if AmDefault then
							SCOff := scuButtonDef
						else
							SCOff := scuButton;
				WordRec (B [1 + Ord (Down)]).Lo := Byte (SpecialChars [SCOff, 0]);
				WordRec (B [S - 1 + Ord (Down)]).Lo := Byte (SpecialChars [SCOff, 1]);
			end;
	end;

begin
	DownIs := Down;
	if State and sfDisabled <> 0 then
		CButton := GetColor ($0C0C)
	else
		if State and sfActive <> 0 then
			if State and sfSelected <> 0 then
				CButton := GetColor ($260B)
			else
				if AmDefault then
					CButton := GetColor ($0D0A)
				else
					CButton := GetColor ($0D09);
	CShadow := GetColor ($0E);
	S := Size.X - 1;
	if S <= 2 then
		begin
			MoveChar (B, ' ', Lo (CShadow), 6);
			WriteLine (0, 0, Size.X, 3, B);
			Exit;
		end;
	if Flags and bfLoJust <> 0 then
		T := 0
	else
		if Flags and bfHiJust <> 0 then
			T := Size.Y - 1
		else
			T := Size.Y shr 1 - 1;
	for Y := 0 to Size.Y - 2 do
		begin
			MoveChar (B, ' ', Lo (CButton), Size.X);
			WordRec (B [0]).Hi := Lo (CShadow);
			if (Y = T) and (PtrRec (Title).Seg <> 0) then DrawTitle;
			if Down then
				WordRec (B [1]).Hi := Lo (CShadow)
			else
				begin
					WordRec (B [S]).Hi := Lo (CShadow);
					if Y = 0 then
						WordRec (B [S]).Lo := Ord (ButtonShadowChars [5])
					else
						WordRec (B [S]).Lo := Ord (ButtonShadowChars [6]);
				end;
			WriteLine (0, Y, Size.X, 1, B);
		end;
	if Down then
		MoveChar (B [0], ' ', Lo (CShadow), Size.X)
	else
		begin
			MoveBuf (B [0], ButtonShadowChars, Lo (CShadow), 3);
			MoveChar (B [3], ButtonShadowChars [3], Lo (CShadow), S - 3);
			WordRec (B [S]).Lo := Ord (ButtonShadowChars [4]);
			WordRec (B [S]).Hi := Lo (CShadow);
		end;
	WriteLine (0, Size.Y - 1, Size.X, 1, B);
end;

procedure TButton.HandleEvent (var Event : TEvent);
var
	Down		: Boolean;
	C			: Char;
	Mouse		: TPoint;
	ClickRect	: TRect;

	procedure DoPress;
	var
		I	: Word;
		B	: Boolean;
	begin
		B := DownIs;
		DrawState (True);
		ClearEvent (Event);
		I := 0;
		while (I < ButtonsSleep) and (not EventAvail (evMouse + evKeyDown)) do
			begin
				Inc (I);
				Sysvars.Sleep (1);
			end;
		if not B then Press;
	end;

begin
	GetExtent (ClickRect);
	Inc (ClickRect.A.X);
	Dec (ClickRect.B.X);
	Dec (ClickRect.B.Y);
	if Event.What = evMouseDown then
		begin
			MakeLocal (Event.Where, Mouse);
			if not ClickRect.Contains (Mouse) then ClearEvent (Event);
		end;
  if Flags and bfGrabFocus <> 0 then
{$IFNDEF Turbo6}
		inherited HandleEvent (Event);
{$ELSE}
		TView.HandleEvent (Event);
{$ENDIF}
	case Event.What of
		evMouseDown	:
			begin
				Inc (ClickRect.B.X);
				Down := False;
				repeat
					MakeLocal (Event.Where, Mouse);
					if Down <> ClickRect.Contains (Mouse) then
						begin
							Down := not Down;
							DrawState (Down);
						end;
				until not MouseEvent (Event, evMouseMove);
				if Down then Press;
			end;
		evKeyDown	:
			begin
				C := HotKey (Title^);
				if ((Event.KeyCode = GetAltCode (C)) or (State and sfFocused <> 0) and (Event.CharCode = ' ')) or
				(((Owner^.Phase = phPostProcess) or (Flags and bfMulti <> 0)) and (C <> #0) and (KeyCase (Event.CharCode) = C)) then
					DoPress
				else
					Exit;
			end;
		evCommand	:
			if (Event.Command = Command) and (PtrRec (Event.InfoPtr).Seg <> 0) and
			(Word (Event.InfoPtr^) <> Ofs (TypeOf (TButton)^)) and (State and sfDisabled = 0) then
				DoPress
			else
				Exit;
		evBroadcast	:
			case Event.Command of
				cmDefault			:
					if AmDefault and (State and sfDisabled = 0) then
						DoPress
					else
						Exit;
				cmGrabDefault,
				cmReleaseDefault	:
					if Flags and bfDefault <> 0 then
						begin
							AmDefault := Event.Command = cmReleaseDefault;
							DrawView;
						end
					else
						Exit;
				cmCommandSetChanged	:
					begin
						SetState (sfDisabled, not CommandEnabled (Command));
						DrawView;
						Exit;
					end;
			else
				Exit;
			end;
	else
		Exit;
	end;
	ClearEvent (Event);
end;

procedure TButton.MakeDefault (Enable : Boolean);
var
	C	: Word;
begin
	if Flags and bfDefault = 0 then
		begin
			if Enable then
				C := cmGrabDefault
			else
				C := cmReleaseDefault;
			SendBroadcast (C);
			AmDefault := Enable;
			DrawView;
		end;
end;

procedure TButton.Press;
begin
	if Flags and bfHistory <> 0 then
		SendBroadcast (cmRecordHistory);
	if Flags and bfBroadcast <> 0 then
		SendBroadcast (Command)
	else
		SendCommand (Command);
end;

procedure TButton.SetState (AState : Word; Enable : Boolean);
begin
{$IFNDEF Turbo6}
	inherited SetState (AState, Enable);
{$ELSE}
	TView.SetState (AState, Enable);
{$ENDIF}
	if AState and (sfSelected + sfActive) <> 0 then DrawView;
	if AState and sfFocused <> 0 then MakeDefault (Enable);
end;

procedure TButton.Store (var S : TStream);
begin
{$IFNDEF Turbo6}
	inherited Store (S);
{$ELSE}
	TView.Store (S);
{$ENDIF}
	S.WriteStr (Title);
	S.Write (Command, SizeOf (Command) + SizeOf (Flags) + SizeOf (AmDefault) + SizeOf (DownIs));
end;

{*********************************************************** TPure **********}
constructor TPure.Init (var R : TRect);
begin
{$IFNDEF Turbo6}
	inherited Init (R);
{$ELSE}
	TView.Init (R);
{$ENDIF}
	Options := ofFramed;
	EventMask := evNothing;
	State := 0;
end;

procedure TPure.Draw;
begin
end;

{************************************************************* TProgresBar **}
constructor TProgresBar.Init (var R : TRect);
begin
	TScrollBar.Init (R, lfStepDraw or lfSmallItem);
	EventMask := evNothing;
	Options := 0;
	Max := 100;
	PgStep := 100;
end;

procedure TProgresBar.Draw;
begin
	PgStep := Value;
	Value := Min;
{$IFNDEF Turbo6}
	inherited Draw;
{$ELSE}
	TScrollBar.Draw;
{$ENDIF}
	Value := PgStep;
end;

{*********************************************** Message dispatch function **}
function Message (Receiver : PView; AWhat, ACommand : Word; AInfoPtr : Pointer) : Pointer;
var
	Event	: TEvent;
begin
	Message := NIL;
	if PtrRec (Receiver).Seg <> 0 then
		begin
			With Event do
				begin
					What := AWhat;
					Command := ACommand;
					InfoPtr := AInfoPtr;
				end;
			Receiver^.HandleEvent (Event);
			if Event.What = evNothing then Message := Event.InfoPtr;
		end;
end;

{******************************************** Views registration procedure **}
procedure RegisterViews;
begin
	RegisterType (RView);
	RegisterType (RPure);
	RegisterType (RFrame);
	RegisterType (RScrollBar);
	RegisterType (RScroller);
	RegisterType (RListViewer);
	RegisterType (RGroup);
	RegisterType (RWindow);
	RegisterType (RProgresBar);
end;

end.
